; ======================================================;
;                                                       ;
;   ntdll.inc for Easy Code 2.0 64-bit Masm projects    ;
;                    (version 1.0.2)                    ;
;                                                       ;
;              Copyright  Ramon Sala 2020              ;
;                                                       ;
; ======================================================;

IFNDEF NTDLL_INC
NTDLL_INC     EQU     1

IFNDEF KERNEL32_INC
    include kernel32.inc
ENDIF

MAXIMUM_FILENAME_LENGTH                         EQU     256
PORT_MAXIMUM_MESSAGE_LENGTH                     EQU     256
INITIAL_PRIVILEGE_COUNT                         EQU     3

FSCTL_GET_VOLUME_INFORMATION                    EQU     90064H

DOS_PATHTYPE_UNC                                EQU     00000001H
DOS_PATHTYPE_ROOTDRIVE                          EQU     00000002H
DOS_PATHTYPE_STREAM                             EQU     00000003H
DOS_PATHTYPE_NT                                 EQU     00000004H
DOS_PATHTYPE_NAME                               EQU     00000005H
DOS_PATHTYPE_DEVICE                             EQU     00000006H
DOS_PATHTYPE_LOCALUNCROOT                       EQU     00000007H

FILE_REMOVABLE_MEDIA                            EQU     00000001H
FILE_READ_ONLY_DEVICE                           EQU     00000002H
FILE_FLOPPY_DISKETTE                            EQU     00000004H
FILE_WRITE_ONCE_MEDIA                           EQU     00000008H
FILE_REMOTE_DEVICE                              EQU     00000010H
FILE_DEVICE_IS_MOUNTED                          EQU     00000020H
FILE_VIRTUAL_VOLUME                             EQU     00000040H
FILE_AUTOGENERATED_DEVICE_NAME                  EQU     00000080H
FILE_DEVICE_SECURE_OPEN                         EQU     00000100H

FILE_SUPERSEDE                                  EQU     00000000H
FILE_OPEN                                       EQU     00000001H
FILE_CREATE                                     EQU     00000002H
FILE_OPEN_IF                                    EQU     00000003H
FILE_OVERWRITE                                  EQU     00000004H
FILE_OVERWRITE_IF                               EQU     00000005H
FILE_MAXIMUM_DISPOSITION                        EQU     00000005H

FILE_DIRECTORY_FILE                             EQU     00000001H
FILE_WRITE_THROUGH                              EQU     00000002H
FILE_SEQUENTIAL_ONLY                            EQU     00000004H
FILE_NO_INTERMEDIATE_BUFFERING                  EQU     00000008H

FILE_SYNCHRONOUS_IO_ALERT                       EQU     00000010H
FILE_SYNCHRONOUS_IO_NONALERT                    EQU     00000020H
FILE_NON_DIRECTORY_FILE                         EQU     00000040H
FILE_CREATE_TREE_CONNECTION                     EQU     00000080H

FILE_COMPLETE_IF_OPLOCKED                       EQU     00000100H
FILE_NO_EA_KNOWLEDGE                            EQU     00000200H
FILE_OPEN_FOR_RECOVERY                          EQU     00000400H
FILE_RANDOM_ACCESS                              EQU     00000800H

FILE_DELETE_ON_CLOSE                            EQU     00001000H
FILE_OPEN_BY_FILE_ID                            EQU     00002000H
FILE_OPEN_FOR_BACKUP_INTENT                     EQU     00004000H
FILE_NO_COMPRESSION                             EQU     00008000H

FILE_RESERVE_OPFILTER                           EQU     00100000H
FILE_OPEN_REPARSE_POINT                         EQU     00200000H
FILE_OPEN_NO_RECALL                             EQU     00400000H
FILE_OPEN_FOR_FREE_SPACE_QUERY                  EQU     00800000H

FILE_COPY_STRUCTURED_STORAGE                    EQU     00000041H
FILE_STRUCTURED_STORAGE                         EQU     00000441H

FILE_VALID_OPTION_FLAGS                         EQU     00ffffffH
FILE_VALID_PIPE_OPTION_FLAGS                    EQU     00000032H
FILE_VALID_MAILSLOT_OPTION_FLAGS                EQU     00000032H
FILE_VALID_SET_FLAGS                            EQU     00000036H

THREAD_STATE_INITIALIZED                        EQU     0
THREAD_STATE_READY                              EQU     1
THREAD_STATE_RUNNING                            EQU     2
THREAD_STATE_STANDBY                            EQU     3
THREAD_STATE_TERMINATED                         EQU     4
THREAD_STATE_WAIT                               EQU     5
THREAD_STATE_TRANSITION                         EQU     6
THREAD_STATE_UNKNOWN                            EQU     7

OB_TYPE_TYPE                                    EQU     1
OB_TYPE_DIRECTORY                               EQU     2
OB_TYPE_SYMBOLIC_LINK                           EQU     3
OB_TYPE_TOKEN                                   EQU     4
OB_TYPE_PROCESS                                 EQU     5
OB_TYPE_THREAD                                  EQU     6
OB_TYPE_EVENT                                   EQU     7
OB_TYPE_EVENT_PAIR                              EQU     8
OB_TYPE_MUTANT                                  EQU     9
OB_TYPE_SEMAPHORE                               EQU     10
OB_TYPE_TIMER                                   EQU     11
OB_TYPE_PROFILE                                 EQU     12
OB_TYPE_WINDOW_STATION                          EQU     13
OB_TYPE_DESKTOP                                 EQU     14
OB_TYPE_SECTION                                 EQU     15
OB_TYPE_KEY                                     EQU     16
OB_TYPE_PORT                                    EQU     17
OB_TYPE_ADAPTER                                 EQU     18
OB_TYPE_CONTROLLER                              EQU     19
OB_TYPE_DEVICE                                  EQU     20
OB_TYPE_DRIVER                                  EQU     21
OB_TYPE_IO_COMPLETION                           EQU     22
OB_TYPE_FILE                                    EQU     23

OBJ_INHERIT                                     EQU     00000002H
OBJ_PERMANENT                                   EQU     00000010H
OBJ_EXCLUSIVE                                   EQU     00000020H
OBJ_CASE_INSENSITIVE                            EQU     00000040H
OBJ_OPENIF                                      EQU     00000080H
OBJ_OPENLINK                                    EQU     00000100H
OBJ_VALID_ATTRIBUTES                            EQU     000001F2H


DIRECTORY_QUERY                                 EQU     0001H
DIRECTORY_TRAVERSE                              EQU     0002H
DIRECTORY_CREATE_OBJECT                         EQU     0004H
DIRECTORY_CREATE_SUBDIRECTORY                   EQU     0008H
DIRECTORY_ALL_ACCESS                            EQU     (STANDARD_RIGHTS_REQUIRED OR 0FH)

SYMBOLIC_LINK_QUERY                             EQU     0001H
SYMBOLIC_LINK_ALL_ACCESS                        EQU     (STANDARD_RIGHTS_REQUIRED OR 01H)

DEVICE_TYPE                                     TYPEDEF QWORD

SE_MIN_WELL_KNOWN_PRIVILEGE                     EQU     2
SE_CREATE_TOKEN_PRIVILEGE                       EQU     2
SE_ASSIGNPRIMARYTOKEN_PRIVILEGE                 EQU     3
SE_LOCK_MEMORY_PRIVILEGE                        EQU     4
SE_INCREASE_QUOTA_PRIVILEGE                     EQU     5
SE_UNSOLICITED_INPUT_PRIVILEGE                  EQU     6
SE_MACHINE_ACCOUNT_PRIVILEGE                    EQU     6
SE_TCB_PRIVILEGE                                EQU     7
SE_SECURITY_PRIVILEGE                           EQU     8
SE_TAKE_OWNERSHIP_PRIVILEGE                     EQU     9
SE_LOAD_DRIVER_PRIVILEGE                        EQU     10
SE_SYSTEM_PROFILE_PRIVILEGE                     EQU     11
SE_SYSTEMTIME_PRIVILEGE                         EQU     12
SE_PROF_SINGLE_PROCESS_PRIVILEGE                EQU     13
SE_INC_BASE_PRIORITY_PRIVILEGE                  EQU     14
SE_CREATE_PAGEFILE_PRIVILEGE                    EQU     15
SE_CREATE_PERMANENT_PRIVILEGE                   EQU     16
SE_BACKUP_PRIVILEGE                             EQU     17
SE_RESTORE_PRIVILEGE                            EQU     18
SE_SHUTDOWN_PRIVILEGE                           EQU     19
SE_DEBUG_PRIVILEGE                              EQU     20
SE_AUDIT_PRIVILEGE                              EQU     21
SE_SYSTEM_ENVIRONMENT_PRIVILEGE                 EQU     22
SE_CHANGE_NOTIFY_PRIVILEGE                      EQU     23
SE_REMOTE_SHUTDOWN_PRIVILEGE                    EQU     24
SE_MAX_WELL_KNOWN_PRIVILEGE                     EQU     SE_REMOTE_SHUTDOWN_PRIVILEGE

KAFFINITY                                       TYPEDEF ULONG_PTR
KPRIORITY                                       TYPEDEF LONG
KPROCESSOR_MODE                                 TYPEDEF BYTE

PROCESS_PARAMETERS_NORMALIZED                   EQU     1

LDR_STATIC_LINK                                 EQU     0000002H
LDR_IMAGE_DLL                                   EQU     0000004H
LDR_LOAD_IN_PROGRESS                            EQU     0001000H
LDR_UNLOAD_IN_PROGRESS                          EQU     0002000H
LDR_ENTRY_PROCESSED                             EQU     0004000H
LDR_ENTRY_INSERTED                              EQU     0008000H
LDR_CURRENT_LOAD                                EQU     0010000H
LDR_FAILED_BUILTIN_LOAD                         EQU     0020000H
LDR_DONT_CALL_FOR_THREADS                       EQU     0040000H
LDR_PROCESS_ATTACH_CALLED                       EQU     0080000H
LDR_DEBUG_SYMBOLS_LOADED                        EQU     0100000H
LDR_IMAGE_NOT_AT_BASE                           EQU     0200000H
LDR_WX86_IGNORE_MACHINETYPE                     EQU     0400000H
LDR_COR_IMAGE                                   EQU     00400000H
LDR_COR_OWNS_UNMAP                              EQU     00800000H
LDR_SYSTEM_MAPPED                               EQU     01000000H
LDR_IMAGE_VERIFYING                             EQU     02000000H
LDR_DRIVER_DEPENDENT_DLL                        EQU     04000000H
LDR_ENTRY_NATIVE                                EQU     08000000H
LDR_REDIRECTED                                  EQU     10000000H
LDR_NON_PAGED_DEBUG_INFO                        EQU     20000000H
LDR_MM_LOADED                                   EQU     40000000H
LDR_COMPAT_DATABASE_PROCESSED                   EQU     80000000H

;POOL_TYPE Enumeration
NonPagedPool                                    EQU     0
PagedPool                                       EQU     1
NonPagedPoolMustSucceed                         EQU     2
DontUseThisType                                 EQU     3
NonPagedPoolCacheAligned                        EQU     4
PagedPoolCacheAligned                           EQU     5
NonPagedPoolCacheAlignedMustS                   EQU     6
MaxPoolType                                     EQU     7

;KWAIT_REASON Enumeration
Executive                                       EQU     0
FreePage                                        EQU     1
PageIn                                          EQU     2
PoolAllocation                                  EQU     3
DelayExecution                                  EQU     4
Suspended                                       EQU     5
UserRequest                                     EQU     6
WrExecutive                                     EQU     7
WrFreePage                                      EQU     8
WrPageIn                                        EQU     9
WrPoolAllocation                                EQU     10
WrDelayExecution                                EQU     11
WrSuspended                                     EQU     12
WrUserRequest                                   EQU     13
WrEventPair                                     EQU     14
WrQueue                                         EQU     15
WrLpcReceive                                    EQU     16
WrLpcReply                                      EQU     17
WrVirtualMemory                                 EQU     18
WrPageOut                                       EQU     19
WrRendezvous                                    EQU     20
Spare2                                          EQU     21
Spare3                                          EQU     22
Spare4                                          EQU     23
Spare5                                          EQU     24
Spare6                                          EQU     25
WrKernel                                        EQU     26
MaximumWaitReason                               EQU     27

;SYSTEMINFOCLASS Enumeration
SystemBasicInformation                          EQU     0
SystemProcessorInformation                      EQU     1
SystemPerformanceInformation                    EQU     2
SystemTimeOfDayInformation                      EQU     3
SystemProcessInformation                        EQU     5
SystemCallCounts                                EQU     6
SystemConfigurationInformation                  EQU     7
SystemProcessorTimes                            EQU     8
SystemGlobalFlag                                EQU     9
SystemModuleInformation                         EQU     11
SystemLockInformation                           EQU     12
SystemHandleInformation                         EQU     16
SystemObjectInformation                         EQU     17
SystemPagefileInformation                       EQU     18
SystemInstructionEmulationCounts                EQU     19
SystemCacheInformation                          EQU     21
SystemPoolTagInformation                        EQU     22
SystemProcessorStatistics                       EQU     23
SystemDpcInformation                            EQU     24
SystemLoadImage                                 EQU     26
SystemUnloadImage                               EQU     27
SystemTimeAdjustment                            EQU     28
SystemCrashDumpInformation                      EQU     32
SystemExceptionInformation                      EQU     33
SystemCrashDumpStateInformation                 EQU     34
SystemKernelDebuggerInformation                 EQU     35
SystemContextSwitchInformation                  EQU     36
SystemRegistryQuotaInformation                  EQU     37
SystemLoadAndCallImage                          EQU     38
SystemPrioritySeparation                        EQU     39
SystemTimeZoneInformation                       EQU     44
SystemLookasideInformation                      EQU     45
SystemSetTimeSlipEvent                          EQU     46
SystemCreateSession                             EQU     47
SystemDeleteSession                             EQU     48
SystemRangeStartInformation                     EQU     50
SystemVerifierInformation                       EQU     51
SystemAddVerifier                               EQU     52
SystemSessionProcessesInformation               EQU     53

;THREAD_STATE Enumeration
StateInitialized                                EQU     0
StateReady                                      EQU     1
StateRunning                                    EQU     2
StateStandby                                    EQU     3
StateTerminated                                 EQU     4
StateWait                                       EQU     5
StateTransition                                 EQU     6
StateUnknown                                    EQU     7

;FILE_INFORMATION_CLASS Enumeration
FileDirectoryInformation                        EQU     1
FileFullDirectoryInformation                    EQU     2
FileBothDirectoryInformation                    EQU     3
FileBasicInformation                            EQU     4
FileStandardInformation                         EQU     5
FileInternalInformation                         EQU     6
FileEaInformation                               EQU     7
FileAccessInformation                           EQU     8
FileNameInformation                             EQU     9
FileRenameInformation                           EQU     10
FileLinkInformation                             EQU     11
FileNamesInformation                            EQU     12
FileDispositionInformation                      EQU     13
FilePositionInformation                         EQU     14
FileFullEaInformation                           EQU     15
FileModeInformation                             EQU     16
FileAlignmentInformation                        EQU     17
FileAllInformation                              EQU     18
FileAllocationInformation                       EQU     19
FileEndOfFileInformation                        EQU     20
FileAlternateNameInformation                    EQU     21
FileStreamInformation                           EQU     22
FilePipeInformation                             EQU     23
FilePipeLocalInformation                        EQU     24
FilePipeRemoteInformation                       EQU     25
FileMailslotQueryInformation                    EQU     26
FileMailslotSetInformation                      EQU     27
FileCompressionInformation                      EQU     28
FileObjectIdInformation                         EQU     29
FileCompletionInformation                       EQU     30
FileMoveClusterInformation                      EQU     31
FileInformationReserved32                       EQU     32
FileInformationReserved33                       EQU     33
FileNetworkOpenInformation                      EQU     34
FileMaximumInformation                          EQU     35

;KEY_INFORMATION_CLASS Enumeration
KeyBasicInformation                             EQU     0
KeyNodeInformation                              EQU     1
KeyFullInformation                              EQU     2
KeyNameInformation                              EQU     3
KeyCachedInformation                            EQU     4
KeyVirtualizationInformation                    EQU     5

;KEY_VALUE_INFORMATION_CLASS Enumeration
KeyValueBasicInformation                        EQU     0
KeyValueFullInformation                         EQU     1
KeyValuePartialInformation                      EQU     2

;PROCESSINFOCLASS Enumeration
ProcessBasicInformation                         EQU     0
ProcessQuotaLimits                              EQU     1
ProcessIoCounters                               EQU     2
ProcessVmCounters                               EQU     3
ProcessTimes                                    EQU     4
ProcessBasePriority                             EQU     5
ProcessRaisePriority                            EQU     6
ProcessDebugPort                                EQU     7
ProcessExceptionPort                            EQU     8
ProcessAccessToken                              EQU     9
ProcessLdtInformation                           EQU     10
ProcessLdtSize                                  EQU     11
ProcessDefaultHardErrorMode                     EQU     12
ProcessIoPortHandlers                           EQU     13
ProcessPooledUsageAndLimits                     EQU     14
ProcessWorkingSetWatch                          EQU     15
ProcessUserModeIOPL                             EQU     16
ProcessEnableAlignmentFaultFixup                EQU     17
ProcessPriorityClass                            EQU     18
ProcessWx86Information                          EQU     19
ProcessHandleCount                              EQU     20
ProcessAffinityMask                             EQU     21
ProcessPriorityBoost                            EQU     22
ProcessDeviceMap                                EQU     23
ProcessSessionInformation                       EQU     24
ProcessForegroundInformation                    EQU     25
ProcessWow64Information                         EQU     26
MaxProcessInfoClass                             EQU     27

;LPC_TYPE Enumeration
LPC_NEW_MESSAGE                                 EQU     0
LPC_REQUEST                                     EQU     1
LPC_REPLY                                       EQU     2
LPC_DATAGRAM                                    EQU     3
LPC_LOST_REPLY                                  EQU     4
LPC_PORT_CLOSED                                 EQU     5
LPC_CLIENT_DIED                                 EQU     6
LPC_EXCEPTION                                   EQU     7
LPC_DEBUG_EVENT                                 EQU     8
LPC_ERROR_EVENT                                 EQU     9
LPC_CONNECTION_REQUEST                          EQU     10
LPC_CONNECTION_REFUSED                          EQU     11
LPC_MAXIMUM                                     EQU     12

;SECTION_INHERIT Enumeration
ViewShare                                       EQU     1
ViewUnmap                                       EQU     2

;SECTION_INFORMATION_CLASS Enumeration
SectionBasicInformation                         EQU     0
SectionImageInformation                         EQU     1

;OBJECT_INFORMATION_CLASS Enumeration
ObjectBasicInformation                          EQU     0
ObjectNameInformation                           EQU     1
ObjectTypeInformation                           EQU     2
ObjectAllTypesInformation                       EQU     3
ObjectHandleInformation                         EQU     4

;MEMORY_INFORMATION_CLASS Enumeration
MemoryBasicInformation                          EQU     0
MemoryWorkingSetList                            EQU     1
MemorySectionName                               EQU     2
MemoryBasicVlmInformation                       EQU     3

;THREADINFOCLASS Enumeration
ThreadBasicInformation                          EQU     0
ThreadTimes                                     EQU     1
ThreadPriority                                  EQU     2
ThreadBasePriority                              EQU     3
ThreadAffinityMask                              EQU     4
ThreadImpersonationToken                        EQU     5
ThreadDescriptorTableEntry                      EQU     6
ThreadEnableAlignmentFaultFixup                 EQU     7
ThreadEventPair                                 EQU     8
ThreadQuerySetWin32StartAddress                 EQU     9
ThreadZeroTlsCell                               EQU     10
ThreadPerformanceCount                          EQU     11
ThreadAmILastThread                             EQU     12
ThreadIdealProcessor                            EQU     13
ThreadPriorityBoost                             EQU     14
ThreadSetTlsArrayAddress                        EQU     15
ThreadIsIoPending                               EQU     16
ThreadHideFromDebugger                          EQU     17
MaxThreadInfoClass                              EQU     18

;FSINFOCLASS Enumeration
FileFsVolumeInformation                         EQU     1
FileFsLabelInformation                          EQU     2
FileFsSizeInformation                           EQU     3
FileFsDeviceInformation                         EQU     4
FileFsAttributeInformation                      EQU     5
FileFsControlInformation                        EQU     6
FileFsFullSizeInformation                       EQU     7
FileFsObjectIdInformation                       EQU     8
FileFsMaximumInformation                        EQU     9

;PLUGPLAY_BUS_CLASS Enumeration
SystemBus                                       EQU     0
PlugPlayVirtualBus                              EQU     1
MaxPlugPlayBusClass                             EQU     2

;PLUGPLAY_VIRTUAL_BUS_TYPE Enumeration
Root                                            EQU     0
MaxPlugPlayVirtualBusType                       EQU     1

;INTERFACE_TYPE Enumeration
InterfaceTypeUndefined                          EQU     (-1)
Internal                                        EQU     0
Isa                                             EQU     1
Eisa                                            EQU     2
MicroChannel                                    EQU     3
TurboChannel                                    EQU     4
PCIBus                                          EQU     5
VMEBus                                          EQU     6
NuBus                                           EQU     7
PCMCIABus                                       EQU     8
CBus                                            EQU     9
MPIBus                                          EQU     10
MPSABus                                         EQU     11
ProcessorInternal                               EQU     12
InternalPowerBus                                EQU     13
PNPISABus                                       EQU     14
PNPBus                                          EQU     15
MaximumInterfaceType                            EQU     16

;SYSTEM_DOCK_STATE Enumeration
SystemDockStateUnknown                          EQU     0
SystemUndocked                                  EQU     1
SystemDocked                                    EQU     2

MAX_SYSTEM_MODULE_NAME_LENGTH                   EQU     256

LPC_MAX_MESSAGE_SIZE                            EQU     148
LPC_MAX_DATA_SIZE                               EQU     104

SIZE_OF_80387_REGISTERS                         EQU     80
MAXIMUM_SUPPORTED_EXTENSION                     EQU     512

_CONTEXT_i386                                   EQU     010000H
_CONTEXT_AMD64                                  EQU     100000H
_CONTEXT_CONTROL                                EQU     1
_CONTEXT_INTEGER                                EQU     2

IMAGE_REL_BASED_MASK                            EQU     0FFFH
IMAGE_REL_BASED_SHIFT                           EQU     12

IMAGE_SIZEOF_BASE_RELOCATION                    EQU     8

UWOP_PUSH_NONVOL                                EQU     0
UWOP_ALLOC_LARGE                                EQU     1
UWOP_ALLOC_SMALL                                EQU     2
UWOP_SET_FPREG                                  EQU     3
UWOP_SAVE_NONVOL                                EQU     4
UWOP_SAVE_NONVOL_FAR                            EQU     5
UWOP_SAVE_XMM128                                EQU     6
UWOP_SAVE_XMM128_FAR                            EQU     7
UWOP_PUSH_MACHFRAME                             EQU     8

PDI_MODULES                                     EQU     01H
PDI_BACKTRACE                                   EQU     02H
PDI_HEAPS                                       EQU     04H
PDI_HEAP_TAGS                                   EQU     08H
PDI_HEAP_BLOCKS                                 EQU     10H
PDI_LOCKS                                       EQU     20H

UNW_FLAG_NHANDLER                               EQU     0H
UNW_FLAG_EHANDLER                               EQU     1H
UNW_FLAG_UHANDLER                               EQU     2H
UNW_FLAG_CHAININFO                              EQU     4H

MAX_BUS_NAME                                    EQU     24

KRNL_NORMAL_PRIORITY_CLASS                      EQU     02H
KRNL_IDLE_PRIORITY_CLASS                        EQU     01H
KRNL_HIGH_PRIORITY_CLASS                        EQU     03H
KRNL_REALTIME_PRIORITY_CLASS                    EQU     04H

;======================================== Structures ======================================;
IFNDEF STRING_DEFINED
    STRING_DEFINED EQU 1
    STRING STRUCT ALIGNMODE
        _Length         DW   ?
        MaximumLength   DW   ?
        Buffer          XPTR ?
    STRING ENDS
    ANSI_STRING                             TYPEDEF STRING
    OEM_STRING                              TYPEDEF STRING
    PSTRING                                 TYPEDEF XPTR
    POEM_STRING                             TYPEDEF PSTRING
ENDIF

IFNDEF UNICODE_STRING_DEFINED
    UNICODE_STRING_DEFINED EQU 1
    UNICODE_STRING STRUCT ALIGNMODE
        _Length         DW   ?
        MaximumLength   DW   ?
                        DD   ?   ;For Align 8
        Buffer          XPTR ?
    UNICODE_STRING      ENDS
    PUNICODE_STRING                         TYPEDEF XPTR
ENDIF

IFNDEF UNICODE_STRING32_DEFINED
    UNICODE_STRING32_DEFINED EQU 1
    UNICODE_STRING32 STRUCT ALIGNMODE
        _Length         DW ?
        MaximumLength   DW ?
        Buffer          DD ?
    UNICODE_STRING32 ENDS
ENDIF

IFNDEF UNICODE_STRING64_DEFINED
    UNICODE_STRING64_DEFINED EQU 1
    UNICODE_STRING64 STRUCT ALIGNMODE
        _Length         DW ?
        MaximumLength   DW ?
        Reserved        DD ?
        Buffer          DQ ?
    UNICODE_STRING64 ENDS
ENDIF

OBJECT_ATTRIBUTES STRUCT ALIGNMODE
    _Length                  DD    ?
    RootDirectory            XWORD ?
    ObjectName               XPTR  ?
    Attributes               DD    ?
    SecurityDescriptor       XPTR  ?
    SecurityQualityOfService XPTR  ?
OBJECT_ATTRIBUTES ENDS

CLIENT_ID STRUCT ALIGNMODE
    UniqueProcess   XWORD ?
    UniqueThread    XWORD ?
CLIENT_ID EndS

PEB_FREE_BLOCK STRUCT ALIGNMODE
    Next    XPTR ?
    _Size   DD   ?
PEB_FREE_BLOCK ENDS

CURDIR STRUCT ALIGNMODE
   DosPath  UNICODE_STRING <>
   Handle   XWORD ?
CURDIR ENDS

RTL_DRIVE_LETTER_CURDIR STRUCT ALIGNMODE
    Flags       DD ?
    _Length     DW ?
    TimeStamp   DD ?
    DosPath     STRING <>
RTL_DRIVE_LETTER_CURDIR ENDS

PROCESS_PARAMETERS STRUCT ALIGNMODE
    MaximumLength       DD    ?
    _Length             DD    ?
    Flags               DD    ?
    DebugFlags          DD    ?
    ConsoleHandle       XWORD ?
    ConsoleFlags        DD ?
    StandardInput       XWORD ?
    StandardOutput      XWORD ?
    StandardError       XWORD ?
    CurrentDirectory    CURDIR <>
    DllPath             UNICODE_STRING <>
    ImagePathName       UNICODE_STRING <>
    CommandLine         UNICODE_STRING <>
    Environment         XPTR  ?
    StartingX           DD    ?
    StartingY           DD    ?
    CountX              DD    ?
    CountY              DD    ?
    CountCharsX         DD    ?
    CountCharsY         DD    ?
    FillAttribute       DD    ?
    WindowFlags         DD    ?
    ShowWindowFlags     DD    ?
    WindowTitle         UNICODE_STRING <>
    Desktop             UNICODE_STRING <>
    ShellInfo           UNICODE_STRING <>
    RuntimeInfo         UNICODE_STRING <>
    CurrentDirectores   RTL_DRIVE_LETTER_CURDIR 32 DUP(<>)
PROCESS_PARAMETERS ENDS

RTL_BITMAP STRUCT ALIGNMODE
    SizeOfBitMap    DD   ?
    Buffer          XPTR ?
RTL_BITMAP ENDS

LDR_DATA_TABLE_ENTRY64 STRUCT ALIGNMODE
    InLoadOrderModuleList           LIST_ENTRY64 <>
    InMemoryOrderModuleList         LIST_ENTRY64 <>
    InInitializationOrderModuleList LIST_ENTRY64 <>
    DllBase                         DQ ?
    EntryPoint                      DQ ?
    SizeOfImage                     DD ?
    FullDllName                     UNICODE_STRING64 <>
    BaseDllName                     UNICODE_STRING64 <>
    Flags                           DD ?
    LoadCount                       DW ?
    TlsIndex                        DW ?
    UNION
        HashLinks                   LIST_ENTRY64 <>
        STRUCT
            SectionPointer          DQ ?
            CheckSum                DD ?
        ENDS
    ENDS
    UNION
        TimeDateStamp               DD ?
        LoadedImports               DQ ?
    ENDS
    EntryPointActivationContext     DQ ?
    PatchInformation                DQ ?
LDR_DATA_TABLE_ENTRY64 ENDS

LDR_DATA_TABLE_ENTRY32 STRUCT ALIGNMODE
    InLoadOrderModuleList           LIST_ENTRY32 <>
    InMemoryOrderModuleList         LIST_ENTRY32 <>
    InInitializationOrderModuleList LIST_ENTRY32 <>
    DllBase                         DD ?
    EntryPoint                      DD ?
    SizeOfImage                     DD ?
    FullDllName                     UNICODE_STRING32 <>
    BaseDllName                     UNICODE_STRING32 <>
    Flags                           DD ?
    LoadCount                       DW ?
    TlsIndex                        DW ?
    UNION
        HashLinks                   LIST_ENTRY32 <>
        STRUCT
            SectionPointer          DD ?
            CheckSum                DD ?
        ENDS
        UNION
            TimeDateStamp               DD ?
            LoadedImports               DD ?
        EndS
    EndS
    EntryPointActivationContext     DD ?
    PatchInformation                DD ?
LDR_DATA_TABLE_ENTRY32 ENDS

LDR_DATA_TABLE_ENTRY STRUCT ALIGNMODE
     InLoadOrderLinks           LIST_ENTRY <>
     InMemoryOrderLinks         LIST_ENTRY <>
     InInitializationOrderLinks LIST_ENTRY <>
     DllBase                    XPTR ?
     EntryPoint                 XPTR ?
     SizeOfImage                DD   ?
     FullDllName                UNICODE_STRING <>
     BaseDllName                UNICODE_STRING <>
     Flags                      DD   ?
     LoadCount                  DW   ?
     TlsIndex                   DW   ?
     UNION
          HashLinks             LIST_ENTRY <>
          STRUCT
               SectionPointer   XPTR ?
               CheckSum         DD   ?
          ENDS
     ENDS
     UNION
          TimeDateStamp         DD   ?
          LoadedImports         XPTR ?
     ENDS
     _ACTIVATION_CONTEXT        XPTR ?
     PatchInformation           XPTR ?
     ForwarderLinks             LIST_ENTRY <>
     ServiceTagLinks            LIST_ENTRY <>
     StaticLinks                LIST_ENTRY <>
LDR_DATA_TABLE_ENTRY ENDS

PEB_LDR_DATA64 STRUCT ALIGNMODE
    _Length                         DD ?
    Initialized                     DB ?
    SsHandle                        DQ ?
    InLoadOrderModuleList           LIST_ENTRY64 <>
    InMemoryOrderModuleList         LIST_ENTRY64 <>
    InInitializationOrderModuleList LIST_ENTRY64 <>
PEB_LDR_DATA64 ENDS

PEB_LDR_DATA32 STRUCT ALIGNMODE
    _Length                         DD ?
    Initialized                     DB ?
    SsHandle                        DD ?
    InLoadOrderModuleList           LIST_ENTRY32 <>
    InMemoryOrderModuleList         LIST_ENTRY32 <>
    InInitializationOrderModuleList LIST_ENTRY32 <>
PEB_LDR_DATA32 ENDS

PEB_LDR_DATA STRUCT ALIGNMODE
    _Length                         DD   ?
    Initialized                     DB   ?
    SsHandle                        XPTR ?
    InLoadOrderModuleList           LIST_ENTRY <>
    InMemoryOrderModuleList         LIST_ENTRY <>
    InInitializationOrderModuleList LIST_ENTRY <>
PEB_LDR_DATA ENDS

SYSTEM_STRINGS STRUCT ALIGNMODE
    SystemRoot          UNICODE_STRING <>
    System32Root        UNICODE_STRING <>
    BaseNamedObjects    UNICODE_STRING <>
SYSTEM_STRINGS ENDS

TEXT_INFO STRUCT ALIGNMODE
    Reserved        XPTR ?
    SystemStrings   XPTR ?
TEXT_INFO ENDS

PEB64 STRUCT ALIGNMODE
    InheritedAddressSpace    DB ?
    ReadImageFileExecOptions DB ?
    BeingDebugged            DB ?
    b003                     DB ?
    Reserved0                DD ?
    Mutant                   DQ ?
    ImageBaseAddress         DQ ?
    Ldr                      DQ ?
    ProcessParameters        DQ ?
PEB64 ENDS

PEB32 STRUCT ALIGNMODE
    InheritedAddressSpace    DB ?
    ReadImageFileExecOptions DB ?
    BeingDebugged            DB ?
    b003                     DB ?
    Mutant                   DD ?
    ImageBaseAddress         DD ?
    Ldr                      DD ?
    ProcessParameters        DD ?
PEB32 ENDS

PEB STRUCT ALIGNMODE
    InheritedAddressSpace            DB ?
    ReadImageFileExecOptions         DB ?
    BeingDebugged                    DB ?
    b003                             DB ?
    Mutant                           XPTR ?
    ImageBaseAddress                 XPTR ?
    Ldr                              XPTR ?
    ProcessParameters                XPTR ?
    SubSystemData                    XPTR ?
    ProcessHeap                      XPTR ?
    FastPebLock                      XPTR ?
    FastPebLockRoutine               XPTR ?
    FastPebUnlockRoutine             XPTR ?
    EnvironmentUpdateCount           DD   ?
    KernelCallbackTable              XPTR ?
    EventLogSection                  XPTR ?
    EventLog                         XPTR ?
    FreeList                         XPTR ?
    TlsExpansionCounter              DD   ?
    TlsBitmap                        XPTR ?
    TlsBitmapData                    DD   ?
    ReadOnlySharedMemoryBase         XPTR ?
    ReadOnlySharedMemoryHeap         XPTR ?
    ReadOnlyStaticServerData         XPTR ?
    InitAnsiCodePageData             XPTR ?
    InitOemCodePageData              XPTR ?
    InitUnicodeCaseTableData         XPTR ?
    KeNumberProcessors               DD   ?
    NtGlobalFlag                     DD   ?
    d6C                              DD   ?
    MmCriticalSectionTimeout         LARGE_INTEGER <>
    MmHeapSegmentReserve             DD   ?
    MmHeapSegmentCommit              DD   ?
    MmHeapDeCommitTotalFreeThreshold DD   ?
    MmHeapDeCommitFreeBlockThreshold DD   ?
    NumberOfHeaps                    DD   ?
    AvailableHeaps                   DD   ?
    ProcessHeapsListBuffer           XPTR ?
    GdiSharedHandleTable             XPTR ?
    ProcessStarterHelper             XPTR ?
    GdiDCAttributeList               XPTR ?
    LoaderLock                       XPTR ?
    NtMajorVersion                   DD   ?
    NtMinorVersion                   DD   ?
    NtBuildNumber                    DW   ?
    NtCSDVersion                     DW   ?
    PlatformId                       DD   ?
    Subsystem                        DD   ?
    MajorSubsystemVersion            DD   ?
    MinorSubsystemVersion            DD   ?
    AffinityMask                     KAFFINITY ?
    GdiHandleBuffer                  DD   ?
    PostProcessInitRoutine           DD   ?
    TlsExpansionBitmap               DD   ?
    TlsExpansionBitmapBits           DW   ?
    SessionId                        DD   ?
    AppCompatFlags                   ULARGE_INTEGER <>
    CSDVersion                       XPTR ?
PEB ENDS

TEB STRUCT ALIGNMODE
    Tib                          NT_TIB <>
    EnvironmentPointer           XPTR ?
    Cid                          CLIENT_ID <>
    ActiveRpcInfo                XPTR ?
    ThreadLocalStoragePointer    XPTR ?
    Peb                          XPTR ?
    LastErrorValue               DD   ?
    CountOfOwnedCriticalSections DD   ?
    CsrClientThread              XPTR ?
    Win32ThreadInfo              XPTR ?
    Win32ClientInfo              DD   01FH DUP(?)
    WOW32Reserved                XPTR ?
    CurrentLocale                DD   ?
    FpSoftwareStatusRegister     DD   ?
    SystemReserved1              XPTR ?
    Spare1                       XPTR ?
    ExceptionCode                DD   ?
    SpareBytes1                  DD   28 DUP(?)
    SystemReserved2              XPTR ?
    gdiRgn                       DD   ?
    gdiPen                       DD   ?
    gdiBrush                     DD   ?
    RealClientId                 CLIENT_ID <>
    GdiCachedProcessHandle       XPTR ?
    GdiClientPID                 DD   ?
    GdiClientTID                 DD   ?
    GdiThreadLocaleInfo          XPTR ?
    UserReserved                 XPTR 5 DUP(?)
    glDispatchTable              XPTR 118 DUP(?)
    glReserved1                  DD   01AH DUP(?)
    glReserved2                  XPTR ?
    glSectionInfo                XPTR ?
    glSection                    XPTR ?
    glTable                      XPTR ?
    glCurrentRC                  XPTR ?
    glContext                    XPTR ?
    LastStatusValue              DD   ?
    StaticUnicodeString          UNICODE_STRING <>
    StaticUnicodeBuffer          DW 105 DUP(?)
    DeallocationStack            XPTR ?
    TlsSlots                     XPTR 40 DUP(?)
    TlsLinks                     LIST_ENTRY <>
    Vdm                          XPTR ?
    ReservedForNtRpc             XPTR ?
    DbgSsReserved                XPTR 2 DUP(?)
    HardErrorDisabled            DD   ?
    Instrumentation              XPTR 10 DUP(?)
    WinSockData                  XPTR ?
    GdiBatchCount                DD   ?
    _Spare2                      DD   ?
    _Spare3                      DD   ?
    _Spare4                      DD   ?
    ReservedForOle               XPTR ?
    WaitingOnLoaderLock          DD   ?
    StackCommit                  XPTR ?
    StackCommitMax               XPTR ?
    StackReserve                 XPTR ?
TEB ENDS

DISPATCHER_HEADER STRUCT ALIGNMODE
    uType           DB ?
    uAbsolute       DB ?
    uSize           DB ?
    uInserted       DB ?
    lSignalState    DD ?
    WaitListHead    LIST_ENTRY <>
DISPATCHER_HEADER ENDS

KPROCESS STRUCT ALIGNMODE
    Header          DISPATCHER_HEADER <>
    le10            LIST_ENTRY <>
    d18             DD ?
    d1C             DD ?
    d20             DD ?
    d24             DD ?
    d28             DD ?
    d2C             DD ?
    d30             DD ?
    d34             DD ?
    dKernelTime     DD ?
    dUserTime       DD ?
    le40            LIST_ENTRY <>
    OutSwapList     LIST_ENTRY <>
    ThreadListHead  LIST_ENTRY <>
    d58             DD ?
    AffinityMask    KAFFINITY ?
    w60             DW ?
    bBasePriority   DB ?
    b63             DB ?
    w64             DW ?
    b66             DB ?
    fPriorityBoost  DB ?
KPROCESS ENDS

PORT_MESSAGE STRUCT ALIGNMODE
    DataSize            DW ?
    MessageSize         DW ?
    MessageType         DW ?
    VirtualRangesOffset DW ?
    ClientId            CLIENT_ID <>
    MessageId           DD ?
    SectionSize         DD ?
    Data                DB 2 DUP(?)
PORT_MESSAGE ENDS

SERVICE_DESCRIPTOR_TABLE STRUCT ALIGNMODE
    ServiceTable    XPTR ?
    puCounterTable  XPTR ?
    uTableSize      DD   ?
    pbArgumentTable XPTR ?
SERVICE_DESCRIPTOR_TABLE ENDS

KSEMAPHORE STRUCT ALIGNMODE
    Header  DISPATCHER_HEADER <>
    lLimit  DD ?
KSEMAPHORE ENDS

KTHREAD STRUCT ALIGNMODE
    Header                      DISPATCHER_HEADER <>
    le010                       LIST_ENTRY <>
    d018                        DD   ?
    d01C                        DD   ?
    pTeb                        XPTR ?
    d024                        DD   ?
    d028                        DD   ?
    b02C                        DB   ?
    bThreadState                DB   ?
    w02E                        DW   ?
    w030                        DW   ?
    b032                        DB   ?
    bPriority                   DB   ?
    le034                       LIST_ENTRY <>
    le03C                       LIST_ENTRY <>
    pProcess                    XPTR ?
    d048                        DD   ?
    dContextSwitches            DD   ?
    d050                        DD   ?
    w054                        DW   ?
    b056                        DB   ?
    bWaitReason                 DB   ?
    d058                        DD   ?
    ple05C                      XPTR ?
    ple060                      XPTR ?
    d064                        DD   ?
    bBasePriority               DB   ?
    b069                        DB   ?
    w06A                        DW   ?
    d06C                        DD   ?
    d070                        DD   ?
    d074                        DD   ?
    d078                        DD   ?
    d07C                        DD   ?
    d080                        DD   ?
    d084                        DD   ?
    d088                        DD   ?
    d08C                        DD   ?
    d090                        DD   ?
    d094                        DD   ?
    d098                        DD   ?
    d09C                        DD   ?
    d0A0                        DD   ?
    d0A4                        DD   ?
    d0A8                        DD   ?
    d0AC                        DD   ?
    d0B0                        DD   ?
    d0B4                        DD   ?
    d0B8                        DD   ?
    d0BC                        DD   ?
    d0C0                        DD   ?
    d0C4                        DD   ?
    d0C8                        DD   ?
    d0CC                        DD   ?
    d0D0                        DD   ?
    d0D4                        DD   ?
    d0D8                        DD   ?
    pServiceDescriptorTable     XPTR ?
    d0E0                        DD   ?
    d0E4                        DD   ?
    d0E8                        DD   ?
    d0EC                        DD   ?
    le0F0                       LIST_ENTRY <>
    d0F8                        DD   ?
    d0FC                        DD   ?
    d100                        DD   ?
    d104                        DD   ?
    d108                        DD   ?
    d10C                        DD   ?
    d110                        DD   ?
    d114                        DD   ?
    d118                        DD   ?
    b11C                        DB   ?
    b11D                        DB   ?
    w11E                        DW   ?
    d120                        DD   ?
    d124                        DD   ?
    d128                        DD   ?
    d12C                        DD   ?
    d130                        DD   ?
    w134                        DW   ?
    b136                        DB   ?
    ProcessorMode               KPROCESSOR_MODE ?
    dKernelTime                 DD   ?
    dUserTime                   DD   ?
    d140                        DD   ?
    d144                        DD   ?
    d148                        DD   ?
    d14C                        DD   ?
    d150                        DD   ?
    d154                        DD   ?
    d158                        DD   ?
    d15C                        DD   ?
    d160                        DD   ?
    d164                        DD   ?
    d168                        DD   ?
    d16C                        DD   ?
    d170                        DD   ?
    SuspendNop                  XPTR ?
    d178                        DD   ?
    d17C                        DD   ?
    d180                        DD   ?
    d184                        DD   ?
    d188                        DD   ?
    d18C                        DD   ?
    SuspendSemaphore            KSEMAPHORE <>
    ThreadList                  LIST_ENTRY <>
    d1AC                        DD   ?
KTHREAD ENDS

ETHREAD STRUCT ALIGNMODE
    Tcb                         KTHREAD <>
    liCreateTime                LARGE_INTEGER <>
    liExitTime                  LARGE_INTEGER <>
    ExitStatus                  DD   ?
    PostBlockList               LIST_ENTRY <>
    TerminationPortList         LIST_ENTRY <>
    uActiveTimerListLock        DD   ?
    ActiveTimerListHead         LIST_ENTRY <>
    Cid                         CLIENT_ID <>
    LpcReplySemaphore           KSEMAPHORE <>
    uLpcReplyMessage            DD   ?
    liLpcReplyMessageId         LARGE_INTEGER <>
    uImpersonationInfo          DD   ?
    IrpList                     LIST_ENTRY <>
    TopLevelIrp                 LIST_ENTRY <>
    uReadClusterSize            DD   ?
    fForwardClusterOnly         DB   ?
    fDisablePageFaultClustering DB   ?
    fDeadThread                 DB   ?
    fHasTerminated              DB   ?
    uEventPair                  DD   ?
    uGrantedAccess              DD   ?
    uThreadsProcess             DD   ?
    pStartAddress               XPTR ?
    Win32StartAddress           XPTR ?
    fLpcExitThreadCalled        DB   ?
    fHardErrorsAreDisabled      DB   ?
    wUknown1                    DW   ?
    dwUknown2                   DD   ?
ETHREAD ENDS

KEVENT STRUCT ALIGNMODE
    Header  DISPATCHER_HEADER <>
KEVENT ENDS

ERESOURCE_OLD STRUCT ALIGNMODE
    SystemResourcesList         LIST_ENTRY <>
    OwnerThreads                XPTR ?
    pbOwnerCounts               XPTR ?
    wTableSize                  DW   ?
    wActiveCount                DW   ?
    wFlag                       DW   ?
    wTableRover                 DW   ?
    bInitialOwnerCounts         DB   4 DUP(?)
    InitialOwnerThreads         DD   4 Dup(?)
    dwUknown1                   DD   ?
    uContentionCount            DD   ?
    wNumberOfExclusiveWaiters   DW   ?
    wNumberOfSharedWaiters      DW   ?
    SharedWaiters               KSEMAPHORE <>
    ExclusiveWaiters            KEVENT <>
    SpinLock                    XPTR ?
    uCreatorBackTraceIndex      DD   ?
    wDepth                      DW   ?
    wUknown2                    DW   ?
    pOwnerBackTrace             XPTR 4 DUP(?)
ERESOURCE_OLD ENDS

OWNER_ENTRY STRUCT ALIGNMODE
    OwnerThread DD ?
    sOwnerCount DW ?
    wTableSize  DW ?
OWNER_ENTRY ENDS

ERESOURCE_LITE STRUCT ALIGNMODE
    SystemResourcesList         LIST_ENTRY <>
    OwnerTable                  XPTR ?
    sActiveCount                DW   ?
    wFlag                       DW   ?
    SharedWaiters               XPTR ?
    ExclusiveWaiters            XPTR ?
    OwnerThreads                OWNER_ENTRY 2 DUP(<>)
    uContentionCount            DD ?
    wNumberOfSharedWaiters      DW ?
    wNumberOfExclusiveWaiters   DW ?
    UNION
        pAddress                XPTR ?
        uCreatorBackTraceIndex  DD ?
    ENDS
    SpinLock                    XPTR ?
ERESOURCE_LITE ENDS

IO_STATUS_BLOCK STRUCT ALIGNMODE
  UNION
    Status    DD ?
    Pointer   XPTR ?
  ENDS
  Information XPTR ?
IO_STATUS_BLOCK ENDS

IFNDEF QUOTA_LIMITS_DEFINED
    QUOTA_LIMITS_DEFINED EQU 1
    QUOTA_LIMITS STRUCT ALIGNMODE
        PagedPoolLimit          XPTR ?
        NonPagedPoolLimit       XPTR ?
        MinimumWorkingSetSize   XPTR ?
        MaximumWorkingSetSize   XPTR ?
        PagefileLimit           XPTR ?
        TimeLimit               LARGE_INTEGER <>
    QUOTA_LIMITS ENDS
ENDIF

IOCOUNTERS STRUCT ALIGNMODE
    uReadOperationCount     DD ?
    uWriteOperationCount    DD ?
    uOtherOperationCount    DD ?
    liReadTransferCount     LARGE_INTEGER <>
    liWriteTransferCount    LARGE_INTEGER <>
    liOtherTransferCount    LARGE_INTEGER <>
IOCOUNTERS ENDS

VM_COUNTERS STRUCT ALIGNMODE
    uPeakVirtualSize            DD ?
    uVirtualSize                DD ?
    uPageFaultCount             DD ?
    uPeakWorkingSetSize         DD ?
    uWorkingSetSize             DD ?
    uQuotaPeakPagedPoolUsage    DD ?
    uQuotaPagedPoolUsage        DD ?
    uQuotaPeakNonPagedPoolUsage DD ?
    uQuotaNonPagedPoolUsage     DD ?
    uPagefileUsage              DD ?
    uPeakPagefileUsage          DD ?
VM_COUNTERS ENDS

KERNEL_USER_TIMES STRUCT ALIGNMODE
    liCreateTime    LARGE_INTEGER <>
    liExitTime      LARGE_INTEGER <>
    liKernelTime    LARGE_INTEGER <>
    liUserTime      LARGE_INTEGER <>
KERNEL_USER_TIMES ENDS

BASE_PRIORITY_INFORMATION STRUCT ALIGNMODE
    BasePriority KPRIORITY ?
BASE_PRIORITY_INFORMATION ENDS

AFFINITY_MASK STRUCT ALIGNMODE
    AffinityMask KAFFINITY ?
AFFINITY_MASK ENDS

TIME_FIELDS STRUCT ALIGNMODE
    wYear           DW ?
    wMonth          DW ?
    wDay            DW ?
    wHour           DW ?
    wMinute         DW ?
    wSecond         DW ?
    wMilliseconds   DW ?
    wWeekday        DW ?
TIME_FIELDS ENDS

NTFS_VOLUME_DATA_BUFFER STRUCT ALIGNMODE
    liSerialNumber          LARGE_INTEGER <>
    liNumberOfSectors       LARGE_INTEGER <>
    liTotalClusters         LARGE_INTEGER <>
    liFreeClusters          LARGE_INTEGER <>
    liReserved              LARGE_INTEGER <>
    uBytesPerSector         DD ?
    uBytesPerCluster        DD ?
    uBytesPerMFTRecord      DD ?
    uClustersPerMFTRecord   DD ?
    liMFTLength             LARGE_INTEGER <>
    liMFTStart              LARGE_INTEGER <>
    liMFTMirrorStart        LARGE_INTEGER <>
    liMFTZoneStart          LARGE_INTEGER <>
    liMFTZoneEnd            LARGE_INTEGER <>
NTFS_VOLUME_DATA_BUFFER ENDS

OBJDIR_INFORMATION STRUCT ALIGNMODE
    ObjectName      UNICODE_STRING <>
    ObjectTypeName  UNICODE_STRING <>
    Data            DB 2 DUP(?)
OBJDIR_INFORMATION ENDS

FILE_FS_VOLUME_INFORMATION STRUCT ALIGNMODE
    VolumeCreationTime  LARGE_INTEGER <>
    VolumeSerialNumber  DD ?
    VolumeLabelLength   DD ?
    SupportsObjects     DB ?
    VolumeLabel         DW 2 DUP(?)
FILE_FS_VOLUME_INFORMATION ENDS

FILE_FS_LABEL_INFORMATION STRUCT ALIGNMODE
    VolumeLabelLength   DD ?
    VolumeLabel         DW 2 DUP(?)
FILE_FS_LABEL_INFORMATION ENDS

FILE_FS_SIZE_INFORMATION STRUCT ALIGNMODE
    TotalAllocationUnits        LARGE_INTEGER <>
    AvailableAllocationUnits    LARGE_INTEGER <>
    SectorsPerAllocationUnit    DD ?
    BytesPerSector              DD ?
FILE_FS_SIZE_INFORMATION ENDS

FILE_FS_DEVICE_INFORMATION STRUCT ALIGNMODE
    DeviceType      DD ?
    Characteristics DD ?
FILE_FS_DEVICE_INFORMATION ENDS

FILE_FS_ATTRIBUTE_INFORMATION STRUCT ALIGNMODE
    FileSystemAttributes        DD ?
    MaximumComponentNameLength  DD ?
    FileSystemNameLength        DD ?
    FileSystemName              DW 2 DUP(?)
FILE_FS_ATTRIBUTE_INFORMATION ENDS

FILE_FS_CONTROL_INFORMATION STRUCT ALIGNMODE
    FreeSpaceStartFiltering LARGE_INTEGER <>
    FreeSpaceThreshold      LARGE_INTEGER <>
    FreeSpaceStopFiltering  LARGE_INTEGER <>
    DefaultQuotaThreshold   LARGE_INTEGER <>
    DefaultQuotaLimit       LARGE_INTEGER <>
    FileSystemControlFlags  DD ?
FILE_FS_CONTROL_INFORMATION ENDS

FILE_FS_FULL_SIZE_INFORMATION STRUCT ALIGNMODE
    TotalQuotaAllocationUnits       LARGE_INTEGER <>
    AvailableQuotaAllocationUnits   LARGE_INTEGER <>
    AvailableAllocationUnits        LARGE_INTEGER <>
    SectorsPerAllocationUnit        DD ?
    BytesPerSector                  DD ?
FILE_FS_FULL_SIZE_INFORMATION ENDS

FILE_FS_OBJECT_ID_INFORMATION STRUCT ALIGNMODE
    VolumeObjectId              GUID <>
    VolumeObjectIdExtendedInfo  DD 12 DUP(?)
FILE_FS_OBJECT_ID_INFORMATION ENDS

SYSTEM_BASIC_INFORMATION STRUCT ALIGNMODE
    dwUnknown1                  DD   ?
    uKeMaximumIncrement         DD   ?
    uPageSize                   DD   ?
    uMmNumberOfPhysicalPages    DD   ?
    uMmLowestPhysicalPage       DD   ?
    uMmHighestPhysicalPage      DD   ?
    uAllocationGranularity      DD   ?
    pLowestUserAddress          XPTR ?
    pMmHighestUserAddress       XPTR ?
    uKeActiveProcessors         KAFFINITY ?
    bKeNumberProcessors         DB   ?
    bUnknown2                   DB   ?
    wUnknown3                   DW   ?
SYSTEM_BASIC_INFORMATION ENDS

SYSTEM_PROCESSOR_INFORMATION STRUCT ALIGNMODE
    wKeProcessorArchitecture    DW   ?
    wKeProcessorLevel           DW   ?
    wKeProcessorRevision        DW   ?
    wUnknown1                   DW   ?
    uKeFeatureBits              DD   ?
SYSTEM_PROCESSOR_INFORMATION ENDS

MM_INFO_COUNTERS STRUCT ALIGNMODE
    uPageFaults             DD ?
    uWriteCopyFaults        DD ?
    uTransistionFaults      DD ?
    uCacheTransitionCount   DD ?
    uDemandZeroFaults       DD ?
    uPagesRead              DD ?
    uPageReadIos            DD ?
    uCacheReadCount         DD ?
    uCacheIoCount           DD ?
    uPagefilePagesWritten   DD ?
    uPagefilePageWriteIos   DD ?
    uMappedFilePagesWritten DD ?
    uMappedFilePageWriteIos DD ?
MM_INFO_COUNTERS ENDS

SYSTEM_PERFORMANCE_INFORMATION STRUCT ALIGNMODE
    liIdleTime                              LARGE_INTEGER <>
    liIoReadTransferCount                   LARGE_INTEGER <>
    liIoWriteTransferCount                  LARGE_INTEGER <>
    liIoOtherTransferCount                  LARGE_INTEGER <>
    uIoReadOperationCount                   DD ?
    uIoWriteOperationCount                  DD ?
    uIoOtherOperationCount                  DD ?
    uMmAvailablePages                       DD ?
    uMmTotalCommittedPages                  DD ?
    uMmTotalCommitLimit                     DD ?
    uMmPeakCommitLimit                      DD ?
    MmInfoCounters                          MM_INFO_COUNTERS <>
    uPoolPaged                              DD ?
    uPoolNonPaged                           DD ?
    uPagedPoolAllocs                        DD ?
    uPagedPoolFrees                         DD ?
    uNonPagedPoolAllocs                     DD ?
    uNonPagedPoolFrees                      DD ?
    uMmTotalFreeSystemPages                 DD ?
    uMmSystemCodePage                       DD ?
    uMmTotalSystemDriverPages               DD ?
    uMmTotalSystemCodePages                 DD ?
    uSmallNonPagedLookasideListAllocateHits DD ?
    uSmallPagedLookasideListAllocateHits    DD ?
    dwUnknown1                              DD ?
    uMmSystemCachePage                      DD ?
    uMmPagedPoolPage                        DD ?
    uMmSystemDriverPage                     DD ?
    uCcFastReadNoWait                       DD ?
    uCcFastReadWait                         DD ?
    uCcFastReadResourceMiss                 DD ?
    uCcFastReadNotPossible                  DD ?
    uCcFastMdlReadNoWait                    DD ?
    uCcFastMdlReadWait                      DD ?
    uCcFastMdlReadResourceMiss              DD ?
    uCcFastMdlReadNotPossible               DD ?
    uCcMapDataNoWait                        DD ?
    uCcMapDataWait                          DD ?
    uCcMapDataNoWaitMiss                    DD ?
    uCcMapDataWaitMiss                      DD ?
    uCcPinMappedDataCount                   DD ?
    uCcPinReadNoWait                        DD ?
    uCcPinReadWait                          DD ?
    uCcPinReadNoWaitMiss                    DD ?
    uCcPinReadWaitMiss                      DD ?
    uCcCopyReadNoWait                       DD ?
    uCcCopyReadWait                         DD ?
    uCcCopyReadNoWaitMiss                   DD ?
    uCcCopyReadWaitMiss                     DD ?
    uCcMdlReadNoWait                        DD ?
    uCcMdlReadWait                          DD ?
    uCcMdlReadNoWaitMiss                    DD ?
    uCcMdlReadWaitMiss                      DD ?
    uCcReadAheadIos                         DD ?
    uCcLazyWriteIos                         DD ?
    uCcLazyWritePages                       DD ?
    uCcDataFlushes                          DD ?
    uCcDataPages                            DD ?
    uTotalContextSwitches                   DD ?
    uFirstLevelTbFills                      DD ?
    uSecondLevelTbFills                     DD ?
    uSystemCalls                            DD ?
SYSTEM_PERFORMANCE_INFORMATION ENDS

SYSTEM_TIME_INFORMATION STRUCT ALIGNMODE
    liKeBootTime            LARGE_INTEGER <>
    liKeSystemTime          LARGE_INTEGER <>
    liExpTimeZoneBias       LARGE_INTEGER <>
    uExpCurrentTimeZoneId   DD ?
    dwUnknown1              DD ?
SYSTEM_TIME_INFORMATION ENDS

SYSTEM_THREAD STRUCT ALIGNMODE
    liKernelTime    XPTR ?
    liUserTime      XPTR ?
    liCreateTime    XPTR ?
    WaitTime        DD   ?
    pStartAddress   XPTR ?
    Cid             CLIENT_ID <>
    Priority        KPRIORITY ?
    BasePriority    KPRIORITY ?
    ContextSwitches DD   ?
    ThreadState     DD   ?
    WaitReason      DD   ?
    dwUnknown2      DD   ?
SYSTEM_THREAD ENDS

SYSTEM_PROCESS_INFORMATION STRUCT ALIGNMODE
    uNext                           DD ?
    uThreadCount                    DD ?
    liUnknown1                      LARGE_INTEGER <>
    liUnknown2                      LARGE_INTEGER <>
    liUnknown3                      LARGE_INTEGER <>
    liCreateTime                    LARGE_INTEGER <>
    liUserTime                      LARGE_INTEGER <>
    liKernelTime                    LARGE_INTEGER <>
    usName                          UNICODE_STRING <>
    BasePriority                    KPRIORITY ?
    uUniqueProcessId                DD ?
    uInheritedFromUniqueProcessId   DD ?
    uHandleCount                    DD ?
    uSessionId                      DD ?
    dwUnknown5                      DD ?
    VmCounters                      VM_COUNTERS <>
    uCommitCharge                   DD ?
    aST                             SYSTEM_THREAD 2 DUP(<>)
SYSTEM_PROCESS_INFORMATION ENDS

IO_COUNTERSEX STRUCT ALIGNMODE
    ReadOperationCount  LARGE_INTEGER <>
    WriteOperationCount LARGE_INTEGER <>
    OtherOperationCount LARGE_INTEGER <>
    ReadTransferCount   LARGE_INTEGER <>
    WriteTransferCount  LARGE_INTEGER <>
    OtherTransferCount  LARGE_INTEGER <>
IO_COUNTERSEX ENDS

SYSTEM_PROCESS_INFORMATION_2000 STRUCT ALIGNMODE
    uNext                           DD ?
    uThreadCount                    DD ?
    liUnknown1                      LARGE_INTEGER <>
    liUnknown2                      LARGE_INTEGER <>
    liUnknown3                      LARGE_INTEGER <>
    liCreateTime                    LARGE_INTEGER <>
    liUserTime                      LARGE_INTEGER <>
    liKernelTime                    LARGE_INTEGER <>
    usName                          UNICODE_STRING <>
    BasePriority                    KPRIORITY ?
    uUniqueProcessId                DD ?
    uInheritedFromUniqueProcessId   DD ?
    uHandleCount                    DD ?
    uSessionId                      DD ?
    dwUnknown5                      DD ?
    VmCounters                      VM_COUNTERS <>
    uCommitCharge                   DD ?
    IoCounters                      IO_COUNTERSEX <>
    aST                             SYSTEM_THREAD 2 DUP(<>)
SYSTEM_PROCESS_INFORMATION_2000 ENDS

SYSTEM_CONFIGURATION_INFORMATION STRUCT ALIGNMODE
    uDiskCount      DD ?
    uFloppyCount    DD ?
    uCDRomCount     DD ?
    uTapeCount      DD ?
    uSerialCount    DD ?
    uParallelCount  DD ?
SYSTEM_CONFIGURATION_INFORMATION ENDS

SYSTEM_PROCESSOR_COUNTERS STRUCT ALIGNMODE
    liProcessorTime     LARGE_INTEGER <>
    liKernelTime        LARGE_INTEGER <>
    liUserTime          LARGE_INTEGER <>
    liDpcTime           LARGE_INTEGER <>
    liInterruptTime     LARGE_INTEGER <>
    uInterruptCount     DD ?
    dwUnknown1          DD ?
SYSTEM_PROCESSOR_COUNTERS ENDS

SYSTEM_GLOBAL_FLAG STRUCT ALIGNMODE
    NtGlobalFlag    DD ?
SYSTEM_GLOBAL_FLAG ENDS

SYSTEM_CALL_TIME_INFORMATION STRUCT ALIGNMODE
    _Length         DD ?
    TotalCalls      DD ?
    TimeOfCalls     LARGE_INTEGER 2 DUP(<>)
SYSTEM_CALL_TIME_INFORMATION ENDS

SYSTEM_MODULE STRUCT ALIGNMODE
    Reserved            DD 2 DUP(?)
    Base                DD ?
    _Size               DD ?
    Flags               DD ?
    Index               DW ?
    _Unknown            DW ?
    LoadCount           DW ?
    ModuleNameOffset    DW ?
    ImageName           DB MAX_SYSTEM_MODULE_NAME_LENGTH DUP(?)
SYSTEM_MODULE ENDS

IFNDEF SYSTEM_MODULE_INFORMATION_DEFINED
    SYSTEM_MODULE_INFORMATION_DEFINED EQU 1
    SYSTEM_MODULE_INFORMATION STRUCT ALIGNMODE
        uCount           DD   ?
        aSM              SYSTEM_MODULE 2 DUP(<>)
        Reserved         DD   2 DUP(?)
        Base             XPTR ?
        _Size            DD   ?
        Flags            DD   ?
        Index            DW   ?
        _Unknown         DW   ?
        LoadCount        DW   ?
        ModuleNameOffset DW   ?
        ImageName        DB   256 DUP(?)
    SYSTEM_MODULE_INFORMATION ENDS
ENDIF

SYSTEM_MODULE64 STRUCT ALIGNMODE
    Reserved         DD 2 DUP(?)
    Base             DQ ?
    _Size            DD ?
    Flags            DD ?
    Index            DW ?
    _Unknown         DW ?
    LoadCount        DW ?
    ModuleNameOffset DW ?
    ImageName        DB MAX_SYSTEM_MODULE_NAME_LENGTH DUP(?)
SYSTEM_MODULE64 ENDS

SYSTEM_MODULE_INFORMATION64 STRUCT ALIGNMODE
    uCount  DD ?
    aSM     SYSTEM_MODULE64 2 DUP(<>)
SYSTEM_MODULE_INFORMATION64 ENDS

SYSTEM_LOCK STRUCT ALIGNMODE
    UNION
        pEResourceOld           XPTR ?
        pEResourceLite          XPTR ?
        pEResource              XPTR ?
    ENDS
    wUnknown1                   DW   ?
    wUnknown2                   DW   ?
    ExclusiveOwnerThreadId      DD   ?
    uActiveCount                DD   ?
    uContentionCount            DD   ?
    dwUnknown3                  DD   ?
    dwUnknown4                  DD   ?
    uNumberOfSharedWaiters      DD   ?
    uNumberOfExclusiveWaiters   DD   ?
SYSTEM_LOCK ENDS

SYSTEM_LOCK_INFORMATION STRUCT ALIGNMODE
    uCount  DD ?
    aSL     SYSTEM_LOCK 2 DUP(<>)
SYSTEM_LOCK_INFORMATION ENDS

SYSTEM_HANDLE STRUCT ALIGNMODE
    uIdProcess      DD   ?
    ObjectType      DB   ?
    Flags           DB   ?
    Handle          DW   ?
    pObject         XPTR ?
    GrantedAccess   ACCESS_MASK ?
SYSTEM_HANDLE ENDS

SYSTEM_HANDLE_INFORMATION STRUCT ALIGNMODE
    uCount  DD ?
    aSH     SYSTEM_HANDLE 2 DUP(<>)
SYSTEM_HANDLE_INFORMATION ENDS

SYSTEM_OBJECTTYPE_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset     DD ?
    ObjectCount         DD ?
    HandleCount         DD ?
    TypeIndex           DD ?
    InvalidAttributes   DD ?
    GenericMapping      GENERIC_MAPPING <>
    ValidAccessMask     ACCESS_MASK ?
    PoolType            DD ?
    SecurityRequired    DB ?
    WaitableObject      DB ?
    TypeName            UNICODE_STRING <>
SYSTEM_OBJECTTYPE_INFORMATION ENDS

SYSTEM_OBJECT_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset         DD   ?
    Object                  XPTR ?
    CreatorProcessId        DD   ?
    CreatorBackTraceIndex   DW ?
    Flags                   DW ?
    PointerCount            DD   ?
    HandleCount             DD   ?
    PagedPoolCharge         DD   ?
    NonPagedPoolCharge      DD   ?
    ExclusiveProcessId      DD   ?
    SecurityDescriptor      XPTR ?
    ObjectName              UNICODE_STRING <>
SYSTEM_OBJECT_INFORMATION ENDS

SYSTEM_PAGE_FILE_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    CurrentSize     DD ?
    TotalUsed       DD ?
    PeakUsed        DD ?
    FileName        UNICODE_STRING <>
SYSTEM_PAGE_FILE_INFORMATION ENDS

SYSTEM_VDM_INSTEMUL_INFO STRUCT ALIGNMODE
    fExVdmSegmentNotPresent DD ?
    uOpcode0FV86            DD ?
    uOpcodeESPrefixV86      DD ?
    uOpcodeCSPrefixV86      DD ?
    uOpcodeSSPrefixV86      DD ?
    uOpcodeDSPrefixV86      DD ?
    uOpcodeFSPrefixV86      DD ?
    uOpcodeGSPrefixV86      DD ?
    uOpcodeOPER32PrefixV86  DD ?
    uOpcodeADDR32PrefixV86  DD ?
    uOpcodeINSBV86          DD ?
    uOpcodeINSWV86          DD ?
    uOpcodeOUTSBV86         DD ?
    uOpcodeOUTSWV86         DD ?
    uOpcodePUSHFV86         DD ?
    uOpcodePOPFV86          DD ?
    uOpcodeINTnnV86         DD ?
    uOpcodeINTOV86          DD ?
    uOpcodeIRETV86          DD ?
    uOpcodeINBimmV86        DD ?
    uOpcodeINWimmV86        DD ?
    uOpcodeOUTBimmV86       DD ?
    uOpcodeOUTWimmV86       DD ?
    uOpcodeINBV86           DD ?
    uOpcodeINWV86           DD ?
    uOpcodeOUTBV86          DD ?
    uOpcodeOUTWV86          DD ?
    uOpcodeLOCKPrefixV86    DD ?
    uOpcodeREPNEPrefixV86   DD ?
    uOpcodeREPPrefixV86     DD ?
    uOpcodeHLTV86           DD ?
    uOpcodeCLIV86           DD ?
    uOpcodeSTIV86           DD ?
    uVdmBopCount            DD ?
SYSTEM_VDM_INSTEMUL_INFO ENDS

SYSTEM_CACHE_INFORMATION STRUCT ALIGNMODE
    uFileCache                  DD ?
    uFileCachePeak              DD ?
    PageFaultCount              DD ?
    MinimumWorkingSet           DD ?
    MaximumWorkingSet           DD ?
    TransitionSharedPages       DD ?
    TransitionSharedPagesPeak   DD ?
    Reserved                    DD 2 DUP(?)
SYSTEM_CACHE_INFORMATION ENDS

SYSTEM_POOL_ENTRY STRUCT ALIGNMODE
    Allocated               DB   ?
    Spare0                  DB   ?
    AllocatorBackTraceIndex DW   ?
    _Size                   DD   ?
    UNION
        Tag                 DB   4 DUP(?)
        TagUlong            DD   ?
        ProcessChargedQuota XPTR ?
    ENDS
SYSTEM_POOL_ENTRY ENDS

SYSTEM_POOL_INFORMATION STRUCT ALIGNMODE
    TotalSize       DD   ?
    FirstEntry      XPTR ?
    EntryOverhead   DW   ?
    PoolTagPresent  DB   ?
    Spare0          DB   ?
    NumberOfEntries DD   ?
    Entries         SYSTEM_POOL_ENTRY 2 DUP(<>)
SYSTEM_POOL_INFORMATION ENDS

SYSTEM_POOL_TAG STRUCT ALIGNMODE
    UNION
        Tag             DB 4 DUP(?)
        TagUlong        DD ?
    ENDS
    PagedPoolAllocs     DD ?
    PagedPoolFrees      DD ?
    PagedPoolUsage      DD ?
    NonPagedPoolAllocs  DD ?
    NonPagedPoolFrees   DD ?
    NonPagedPoolUsage   DD ?
SYSTEM_POOL_TAG ENDS

SYSTEM_POOL_TAG_INFORMATION STRUCT ALIGNMODE
    uCount  DD ?
    aSPT    SYSTEM_POOL_TAG 2 DUP(<>)
SYSTEM_POOL_TAG_INFORMATION ENDS

SYSTEM_INTERRUPT_INFORMATION STRUCT ALIGNMODE
    ContextSwitches DD ?
    DpcCount        DD ?
    DpcRate         DD ?
    TimeIncrement   DD ?
    DpcBypassCount  DD ?
    ApcBypassCount  DD ?
SYSTEM_INTERRUPT_INFORMATION ENDS

SYSTEM_DPC_INFORMATION STRUCT ALIGNMODE
    dwUnknown1           DD ?
    MaximumDpcQueueDepth DD ?
    MinimumDpcRate       DD ?
    AdjustDpcThreshold   DD ?
    IdealDpcRate         DD ?
SYSTEM_DPC_INFORMATION ENDS

SYSTEM_MEMORY_INFO STRUCT ALIGNMODE
    StringOffset    XPTR ?
    ValidCount      DW ?
    TransitionCount DW ?
    ModifiedCount   DW ?
    PageTableCount  DW ?
SYSTEM_MEMORY_INFO ENDS

SYSTEM_MEMORY_INFORMATION STRUCT ALIGNMODE
    InfoSize    DD ?
    StringStart DD ?
    Memory      SYSTEM_MEMORY_INFO 2 DUP(<>)
SYSTEM_MEMORY_INFORMATION ENDS

SYSTEM_LOAD_DRIVER STRUCT ALIGNMODE
    DriverName      UNICODE_STRING <>
    BaseAddress     XPTR ?
    SectionPointer  XPTR ?
    EntryPoint      XPTR ?
    ExportDirectory XPTR ?
SYSTEM_LOAD_DRIVER ENDS

SYSTEM_UNLOAD_DRIVER STRUCT ALIGNMODE
    SectionPointer XPTR ?
SYSTEM_UNLOAD_DRIVER ENDS

SYSTEM_QUERY_TIME_ADJUSTMENT STRUCT ALIGNMODE
    TimeAdjustment      DD ?
    MaximumIncrement    DD ?
    TimeSynchronization DB ?
SYSTEM_QUERY_TIME_ADJUSTMENT ENDS

SYSTEM_SET_TIME_ADJUSTMENT STRUCT ALIGNMODE
    TimeAdjustment      DD ?
    TimeSynchronization DB ?
SYSTEM_SET_TIME_ADJUSTMENT ENDS

SYSTEM_CRASH_DUMP_INFORMATION STRUCT ALIGNMODE
    CrashDumpSectionHandle  XWORD ?
SYSTEM_CRASH_DUMP_INFORMATION ENDS

SYSTEM_CRASH_DUMP_INFORMATION_2000 STRUCT ALIGNMODE
    CrashDumpSectionHandle  XWORD ?
    _Unknown                XWORD ?
SYSTEM_CRASH_DUMP_INFORMATION_2000 ENDS

SYSTEM_EXCEPTION_INFORMATION STRUCT ALIGNMODE
    AlignmentFixupCount     DD ?
    ExceptionDispatchCount  DD ?
    FloatingEmulationCount  DD ?
    ByteWordEmulationCount  DD ?
SYSTEM_EXCEPTION_INFORMATION ENDS

SYSTEM_CRASH_DUMP_STATE_INFORMATION STRUCT ALIGNMODE
    ValidCrashDump  DD ?
SYSTEM_CRASH_DUMP_STATE_INFORMATION ENDS

SYSTEM_CRASH_DUMP_STATE_INFORMATION_2000 STRUCT ALIGNMODE
    ValidCrashDump  DD ?
    _Unknown        DD ?
SYSTEM_CRASH_DUMP_STATE_INFORMATION_2000 ENDS

SYSTEM_DEBUGGER_INFORMATION STRUCT ALIGNMODE
    KernelDebuggerEnabled       DB ?
    KernelDebuggerNotPresent    DB ?
SYSTEM_DEBUGGER_INFORMATION ENDS

SYSTEM_CONTEXT_SWITCH_INFORMATION STRUCT ALIGNMODE
    ContextSwitches DD ?
    FindAny         DD ?
    FindLast        DD ?
    FindIdeal       DD ?
    IdleAny         DD ?
    IdleCurrent     DD ?
    IdleLast        DD ?
    IdleIdeal       DD ?
    PreemptAny      DD ?
    PreemptCurrent  DD ?
    PreemptLast     DD ?
    SwitchToIdle    DD ?
SYSTEM_CONTEXT_SWITCH_INFORMATION ENDS

SYSTEM_REGISTRY_QUOTA_INFORMATION STRUCT ALIGNMODE
    RegistryQuotaAllowed    DD ?
    RegistryQuotaUsed       DD ?
    PagedPoolSize           DD ?
SYSTEM_REGISTRY_QUOTA_INFORMATION ENDS

SYSTEM_ADD_DRIVER STRUCT ALIGNMODE
    ModuleName UNICODE_STRING <>
SYSTEM_ADD_DRIVER ENDS

SYSTEM_PRIORITY_SEPARATION_INFORMATION STRUCT ALIGNMODE
    PrioritySeparation  DD ?
SYSTEM_PRIORITY_SEPARATION_INFORMATION ENDS

PLUGPLAY_BUS_TYPE STRUCT ALIGNMODE
    BusClass                    DD ?
    UNION
        SystemBusType           DD ?
        PlugPlayVirtualBusType  DD ?
    ENDS
PLUGPLAY_BUS_TYPE ENDS

PLUGPLAY_BUS_INSTANCE STRUCT ALIGNMODE
    BusType     PLUGPLAY_BUS_TYPE <>
    BusNumber   DD ?
    BusName     DW MAX_BUS_NAME DUP(?)
PLUGPLAY_BUS_INSTANCE ENDS

SYSTEM_PLUGPLAY_BUS_INFORMATION STRUCT ALIGNMODE
    BusCount    DD ?
    BusInstance PLUGPLAY_BUS_INSTANCE 2 DUP(<>)
SYSTEM_PLUGPLAY_BUS_INFORMATION ENDS

SYSTEM_DOCK_INFORMATION STRUCT ALIGNMODE
    DockState       DD ?
    DeviceBusType   DD ?
    DeviceBusNumber DD ?
    SlotNumber      DD ?
SYSTEM_DOCK_INFORMATION ENDS

SYSTEM_POWER_INFORMATION STRUCT ALIGNMODE
    SystemSuspendSupported          DB ?
    SystemHibernateSupported        DB ?
    ResumeTimerSupportsSuspend      DB ?
    ResumeTimerSupportsHibernate    DB ?
    LidSupported                    DB ?
    TurboSettingSupported           DB ?
    TurboMode                       DB ?
    SystemAcOrDc                    DB ?
    PowerDownDisabled               DB ?
    SpindownDrives                  LARGE_INTEGER <>
SYSTEM_POWER_INFORMATION ENDS

SYSTEM_PROCESSOR_SPEED_INFORMATION STRUCT ALIGNMODE
    MaximumProcessorSpeed   DD ?
    CurrentAvailableSpeed   DD ?
    ConfiguredSpeedLimit    DD ?
    PowerLimit              DB ?
    ThermalLimit            DB ?
    TurboLimit              DB ?
SYSTEM_PROCESSOR_SPEED_INFORMATION ENDS

SYSTEM_TIME_ZONE_INFORMATION STRUCT ALIGNMODE
    Bias            DD ?
    StandardName    DW 32 DUP(?)
    StandardDate    TIME_FIELDS <>
    StandardBias    DD ?
    DaylightName    DW 32 DUP(?)
    DaylightDate    TIME_FIELDS <>
    DaylightBias    DD ?
SYSTEM_TIME_ZONE_INFORMATION ENDS

SYSTEM_LOOKASIDE STRUCT ALIGNMODE
    Depth           DW ?
    MaximumDepth    DW ?
    TotalAllocates  DD ?
    AllocateMisses  DD ?
    TotalFrees      DD ?
    FreeMisses      DD ?
    _Type           DD ?
    Tag             DD ?
    _Size           DD ?
SYSTEM_LOOKASIDE ENDS

SYSTEM_LOOKASIDE_INFORMATION STRUCT ALIGNMODE
    asl SYSTEM_LOOKASIDE <>
SYSTEM_LOOKASIDE_INFORMATION ENDS

SYSTEM_SET_TIME_SLIP_EVENT STRUCT ALIGNMODE
    TimeSlipEvent   XWORD ?
SYSTEM_SET_TIME_SLIP_EVENT ENDS

SYSTEM_CREATE_SESSION STRUCT ALIGNMODE
    Session DD ?
SYSTEM_CREATE_SESSION ENDS

SYSTEM_DELETE_SESSION STRUCT ALIGNMODE
    Session DD ?
SYSTEM_DELETE_SESSION ENDS

SYSTEM_RANGE_START_INFORMATION STRUCT ALIGNMODE
    SystemRangeStart XPTR ?
SYSTEM_RANGE_START_INFORMATION ENDS

FILE_DIRECTORY_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    FileIndex       DD ?
    CreationTime    LARGE_INTEGER <>
    LastAccessTime  LARGE_INTEGER <>
    LastWriteTime   LARGE_INTEGER <>
    ChangeTime      LARGE_INTEGER <>
    EndOfFile       LARGE_INTEGER <>
    AllocationSize  LARGE_INTEGER <>
    FileAttributes  DD ?
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_DIRECTORY_INFORMATION ENDS

FILE_FULL_DIR_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    FileIndex       DD ?
    CreationTime    LARGE_INTEGER <>
    LastAccessTime  LARGE_INTEGER <>
    LastWriteTime   LARGE_INTEGER <>
    ChangeTime      LARGE_INTEGER <>
    EndOfFile       LARGE_INTEGER <>
    AllocationSize  LARGE_INTEGER <>
    FileAttributes  DD ?
    FileNameLength  DD ?
    EaSize          DD ?
    FileName        DW 2 DUP(?)
FILE_FULL_DIR_INFORMATION ENDS

FILE_BOTH_DIR_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    FileIndex       DD ?
    CreationTime    LARGE_INTEGER <>
    LastAccessTime  LARGE_INTEGER <>
    LastWriteTime   LARGE_INTEGER <>
    ChangeTime      LARGE_INTEGER <>
    EndOfFile       LARGE_INTEGER <>
    AllocationSize  LARGE_INTEGER <>
    FileAttributes  DD ?
    FileNameLength  DD ?
    EaSize          DD ?
    ShortNameLength DB ?
    ShortName       DW 12 DUP(?)
    FileName        DW 2 DUP(?)
FILE_BOTH_DIR_INFORMATION ENDS

FILE_BASIC_INFORMATION STRUCT ALIGNMODE
    CreationTime    LARGE_INTEGER <>
    LastAccessTime  LARGE_INTEGER <>
    LastWriteTime   LARGE_INTEGER <>
    ChangeTime      LARGE_INTEGER <>
    FileAttributes  DD ?
FILE_BASIC_INFORMATION ENDS

FILE_STANDARD_INFORMATION STRUCT ALIGNMODE
    AllocationSize  LARGE_INTEGER <>
    EndOfFile       LARGE_INTEGER <>
    NumberOfLinks   DD ?
    DeletePending   DB ?
    Directory       DB ?
FILE_STANDARD_INFORMATION ENDS
                                                            
FILE_INTERNAL_INFORMATION STRUCT ALIGNMODE
    IndexNumber LARGE_INTEGER <>
FILE_INTERNAL_INFORMATION ENDS

FILE_EA_INFORMATION STRUCT ALIGNMODE
    EaSize DD ?
FILE_EA_INFORMATION ENDS

FILE_ACCESS_INFORMATION STRUCT ALIGNMODE
    AccessFlags ACCESS_MASK ?
FILE_ACCESS_INFORMATION ENDS

FILE_NAME_INFORMATION STRUCT ALIGNMODE
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_NAME_INFORMATION ENDS

FILE_RENAME_INFORMATION STRUCT ALIGNMODE
    ReplaceIfExists DB ?
    RootDirectory   XWORD ?
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_RENAME_INFORMATION ENDS

FILE_LINK_INFORMATION STRUCT ALIGNMODE
    ReplaceIfExists DB ?
    RootDirectory   XWORD ?
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_LINK_INFORMATION ENDS

FILE_NAMES_INFORMATION STRUCT ALIGNMODE
    NextEntryOffset DD ?
    FileIndex       DD ?
    FileNameLength  DD ?
    FileName        DW 2 DUP(?)
FILE_NAMES_INFORMATION ENDS

FILE_ALLOCATION_INFORMATION STRUCT ALIGNMODE
    AllocationSize LARGE_INTEGER <>
FILE_ALLOCATION_INFORMATION ENDS

FILE_COMPRESSION_INFORMATION STRUCT ALIGNMODE
    CompressedFileSize   LARGE_INTEGER <>
    CompressionFormat    DW ?
    CompressionUnitShift DB ?
    ChunkShift           DB ?
    ClusterShift         DB ?
    Reserved             DB 3 DUP(?)
FILE_COMPRESSION_INFORMATION ENDS

FILE_COMPLETION_INFORMATION STRUCT ALIGNMODE
    Port    XWORD ?
    Key     DD    ?
FILE_COMPLETION_INFORMATION ENDS

KEY_VALUE_BASIC_INFORMATION STRUCT ALIGNMODE
    TitleIndex  DD ?
    _Type       DD ?
    NameLength  DD ?
    _Name       DW 2 DUP(?)
KEY_VALUE_BASIC_INFORMATION ENDS

KEY_VALUE_FULL_INFORMATION STRUCT ALIGNMODE
    TitleIndex  DD ?
    _Type       DD ?
    DataOffset  DD ?
    DataLength  DD ?
    NameLength  DD ?
    _Name       DW 2 DUP(?)
KEY_VALUE_FULL_INFORMATION ENDS

KEY_VALUE_PARTIAL_INFORMATION STRUCT ALIGNMODE
    TitleIndex  DD ?
    _Type       DD ?
    DataLength  DD ?
    Data        DB 2 DUP(?)
KEY_VALUE_PARTIAL_INFORMATION ENDS

KEY_NODE_INFORMATION STRUCT ALIGNMODE
    LastWriteTime   LARGE_INTEGER <>
    TitleIndex      DD ?
    ClassOffset     DD ?
    ClassLength     DD ?
    NameLength      DD ?
    _Name           DW 2 DUP(?)
KEY_NODE_INFORMATION ENDS

KEY_NAME_INFORMATION STRUCT ALIGNMODE
    NameLength  DD ?
    _Name       DW 2 DUP(?)
KEY_NAME_INFORMATION ENDS

PROCESS_BASIC_INFORMATION32 STRUCT ALIGNMODE
    ExitStatus                      DD ?
    PebBaseAddress                  DD ?
    AffinityMask                    DD ?
    BasePriority                    KPRIORITY ?
    uUniqueProcessId                DD ?
    uInheritedFromUniqueProcessId   DD ?
PROCESS_BASIC_INFORMATION32 ENDS

PROCESS_BASIC_INFORMATION64 STRUCT ALIGNMODE
    ExitStatus                      DD ?
    Reserved0                       DD ?
    PebBaseAddress                  DQ ?
    AffinityMask                    DQ ?
    BasePriority                    KPRIORITY ?
    Reserved1                       DD ?
    uUniqueProcessId                DQ ?
    uInheritedFromUniqueProcessId   DQ ?
PROCESS_BASIC_INFORMATION64 ENDS

PROCESS_BASIC_INFORMATION STRUCT ALIGNMODE
    ExitStatus                      DD ?
    PebBaseAddress                  XPTR ?
    AffinityMask                    KAFFINITY ?
    BasePriority                    KPRIORITY ?
    uUniqueProcessId                XPTR ?
    uInheritedFromUniqueProcessId   DD ?
PROCESS_BASIC_INFORMATION ENDS

PROCESS_RAISE_PRIORITY STRUCT ALIGNMODE
    RaisePriority KPRIORITY ?
PROCESS_RAISE_PRIORITY ENDS

PROCESS_DEBUG_PORT_INFORMATION STRUCT ALIGNMODE
    DebugPort XWORD ?
PROCESS_DEBUG_PORT_INFORMATION ENDS

PROCESS_EXCEPTION_PORT STRUCT ALIGNMODE
    ExceptionPort XWORD ?
PROCESS_EXCEPTION_PORT ENDS

PROCESS_ACCESS_TOKEN STRUCT ALIGNMODE
    Token   XWORD ?
    Thread  XWORD ?
PROCESS_ACCESS_TOKEN ENDS

PROCESS_WOW64_INFORMATION STRUCT ALIGNMODE
    Wow64PebBaseAddress XPTR ?
PROCESS_WOW64_INFORMATION ENDS

IFNDEF LDT_ENTRY_DEFINED
    LDT_ENTRY_DEFINED   EQU 1
    LDTBits RECORD  NTBaseHi:8,NTGranularity:1,NTDefault_Big:1,NTReserved_0:1,NTSys:1,NTLimitHi:4,NTPres:1,NTDpl:2,NTType:5,NTBaseMid:8

    LDT_ENTRY STRUCT ALIGNMODE
        LimitLow DW ?
        BaseLow  DW ?
        UNION
            STRUCT
                BaseMid DB ?
                Flags1  DB ?
                Flags2  DB ?
                BaseHi  DB ?
            ENDS
            STRUCT
                LDTBits <>
            ENDS
        ENDS
    LDT_ENTRY ENDS
    LDT_TABLE_SIZE Equ (8 * 1024 * SIDEOF LDT_ENTRY)
ENDIF

PROCESS_LDT_INFORMATION Struct ALIGNMODE
    Start       DD ?
    _Length     DD ?
    LdtEntries  LDT_ENTRY 2 DUP(<>)
PROCESS_LDT_INFORMATION EndS

PROCESS_LDT_SIZE Struct ALIGNMODE
    _Length DD ?
PROCESS_LDT_SIZE ENDS

PROCESS_DEFAULT_HARDERROR_MODE_INFORMATION STRUCT ALIGNMODE
    HardErrorMode DD ?
PROCESS_DEFAULT_HARDERROR_MODE_INFORMATION ENDS

PROCESS_POOLED_USAGE_AND_LIMITS_INFORMATION STRUCT ALIGNMODE
    PeakPagedPoolUsage      DD ?
    PagedPoolUsage          DD ?
    PagedPoolLimit          DD ?
    PeakNonPagedPoolUsage   DD ?
    NonPagedPoolUsage       DD ?
    NonPagedPoolLimit       DD ?
    PeakPagefileUsage       DD ?
    PagefileUsage           DD ?
    PagefileLimit           DD ?
PROCESS_POOLED_USAGE_AND_LIMITS_INFORMATION ENDS

PROCESS_WS_WATCH_INFORMATION STRUCT ALIGNMODE
    FaultingPc  XPTR ?
    FaultingVa  XPTR ?
PROCESS_WS_WATCH_INFORMATION ENDS

PROCESS_IOPL STRUCT ALIGNMODE
    Iopl DD ?
PROCESS_IOPL ENDS

PROCESS_ALLIGNMENT_FAULT_FIXUP STRUCT ALIGNMODE
    EnableAllignmentFaultFixup DB ?
PROCESS_ALLIGNMENT_FAULT_FIXUP ENDS

PROCESS_PRIORITY_CLASS_INFORMATION STRUCT ALIGNMODE
    _Unknown        DB ?
    PriorityClass   DB ?
PROCESS_PRIORITY_CLASS_INFORMATION ENDS

PROCESS_X86_INFORMATION STRUCT ALIGNMODE
    x86Info DD ?
PROCESS_X86_INFORMATION ENDS

PROCESS_HANDLE_COUNT_INFORMATION STRUCT ALIGNMODE
    HandleCount DD ?
PROCESS_HANDLE_COUNT_INFORMATION ENDS

PROCESS_PRIORITY_BOOST_INFORMATION STRUCT ALIGNMODE
    PriorityBoostEnabled DD ?
PROCESS_PRIORITY_BOOST_INFORMATION ENDS

PROCESS_DEVICE_MAP_INFORMATION STRUCT ALIGNMODE
    UNION
        STRUCT
            DirectoryHandle XWORD ?
        ENDS
        STRUCT
            DriveMap        DD    ?
            DriveType       DB    32 DUP(?)
        ENDS
    ENDS
PROCESS_DEVICE_MAP_INFORMATION ENDS

PROCESS_SESSION_INFORMATION STRUCT ALIGNMODE
    SessionId DD ?
PROCESS_SESSION_INFORMATION ENDS

USER_STACK STRUCT ALIGNMODE
    FixedStackBase          XPTR ?
    FixedStackLimit         XPTR ?
    ExpandableStackBase     XPTR ?
    ExpandableStackLimit    XPTR ?
    ExpandableStackBottom   XPTR ?
USER_STACK ENDS

THREAD_BASIC_INFORMATION STRUCT ALIGNMODE
    ExitStatus      DD   ?
    TebBaseAddress  XPTR ?
    ClientId        CLIENT_ID <>
    AffinityMask    KAFFINITY ?
    Priority        KPRIORITY ?
    BasePriority    KPRIORITY ?
THREAD_BASIC_INFORMATION ENDS

THREAD_PRIORITY STRUCT ALIGNMODE
    Priority KPRIORITY ?
THREAD_PRIORITY ENDS

THREAD_DESCRIPTOR_TABLE_ENTRY_INFORMATION STRUCT ALIGNMODE
    Selector    DD ?
    Descriptor  LDT_ENTRY <>
THREAD_DESCRIPTOR_TABLE_ENTRY_INFORMATION ENDS

THREAD_EVENTPAIR STRUCT ALIGNMODE
    EventPair XWORD ?
THREAD_EVENTPAIR ENDS

THREAD_WIN32_START_ADDRESS_INFORMATION STRUCT ALIGNMODE
    Win32StartAddress XPTR ?
THREAD_WIN32_START_ADDRESS_INFORMATION ENDS

THREAD_ZERO_TLSCELL STRUCT ALIGNMODE
    TlsIndex DD ?
THREAD_ZERO_TLSCELL ENDS

THREAD_PERFORMANCE_COUNTER_INFORMATION STRUCT ALIGNMODE
    Count1 DD ?
    Count2 DD ?
THREAD_PERFORMANCE_COUNTER_INFORMATION ENDS

THREAD_AMI_LAST_THREAD STRUCT ALIGNMODE
    AmILastThread DD ?
THREAD_AMI_LAST_THREAD ENDS

THREAD_IDEAL_PROCESSOR STRUCT ALIGNMODE
    IdealProcessor DD ?
THREAD_IDEAL_PROCESSOR ENDS

THREAD_TLS_ARRAY STRUCT ALIGNMODE
    TlsArray    XWORD ?
THREAD_TLS_ARRAY ENDS

THREAD_IS_IO_PENDING_INFORMATION STRUCT ALIGNMODE
    IsIOPending DD ?
THREAD_IS_IO_PENDING_INFORMATION ENDS

THREAD_HIDE_FROM_DEBUGGER STRUCT ALIGNMODE
    HideFromDebugger DD ?
THREAD_HIDE_FROM_DEBUGGER ENDS

SECTION_BASIC_INFORMATION STRUCT ALIGNMODE
    BaseAddress XPTR ?
    Attributes  DD   ?
    _Size       LARGE_INTEGER <>
SECTION_BASIC_INFORMATION ENDS

SECTION_IMAGE_INFORMATION STRUCT ALIGNMODE
    EntryPoint              XPTR ?
    Unknown1                DD ?
    StackReserve            DD ?
    StackCommit             DD ?
    Subsystem               DD ?
    MinorSubsystemVersion   DW ?
    MajorSubsystemVersion   DW ?
    Unknown2                DD ?
    Characteristics         DD ?
    ImageNumber             DW ?
    Executable              DB ?
    Unknown3                DB ?
    Unknown4                DD 3 DUP(?)
SECTION_IMAGE_INFORMATION ENDS

OBJECT_BASIC_INFORMATION STRUCT ALIGNMODE
    Attributes                  DD ?
    GrantedAccess               ACCESS_MASK ?
    HandleCount                 DD ?
    PointerCount                DD ?
    PagedPoolUsage              DD ?
    NonPagedPoolUsage           DD ?
    Reserved                    DD 3 DUP(?)
    NameInformationLength       DD ?
    TypeInformationLength       DD ?
    SecurityDescriptorLength    DD ?
    CreateTime                  LARGE_INTEGER <>
OBJECT_BASIC_INFORMATION ENDS

OBJECT_NAME_INFORMATION STRUCT ALIGNMODE
    _Name UNICODE_STRING <>
OBJECT_NAME_INFORMATION ENDS

OBJECT_TYPE_INFORMATION STRUCT ALIGNMODE
    _Name                   UNICODE_STRING <>
    ObjectCount             DD ?
    HandleCount             DD ?
    Reserved1               DD 4 DUP(?)
    PeakObjectCount         DD ?
    PeakHandleCount         DD ?
    Reserved2               DD 4 DUP(?)
    InvalidAttributes       DD ?
    GenericMapping          GENERIC_MAPPING <>
    ValidAccess             DD ?
    _Unknown                DB ?
    MaintainHandleDatabase  DB ?
    Reserved3               DB 2 DUP(?)
    PoolType                DD ?
    PagedPoolUsage          DD ?
    NonPagedPoolUsage       DD ?
OBJECT_TYPE_INFORMATION ENDS

OBJECT_ALL_TYPES_INFORMATION STRUCT ALIGNMODE
    NumberOfTypes   DD ?
    TypeInformation OBJECT_TYPE_INFORMATION <>
OBJECT_ALL_TYPES_INFORMATION ENDS

OBJECT_HANDLE_ATTRIBUTE_INFORMATION STRUCT ALIGNMODE
    Inherit             DB ?
    ProtectFromClose    DB ?
OBJECT_HANDLE_ATTRIBUTE_INFORMATION ENDS

IFNDEF MEMORY_BASIC_INFORMATION_DEFINED
    MEMORY_BASIC_INFORMATION_DEFINED EQU 1
    MEMORY_BASIC_INFORMATION STRUCT ALIGNMODE
        BaseAddress         XPTR ?
        AllocationBase      XPTR ?
        AllocationProtect   DD ?
        RegionSize          XPTR ?
        State               DD ?
        Protect             DD ?
        _Type               DD ?
    MEMORY_BASIC_INFORMATION ENDS
ENDIF

MEMORY_WORKING_SET_LIST STRUCT ALIGNMODE
    NumberOfPages   DD ?
    WorkingSetList  DD 2 DUP(?)
MEMORY_WORKING_SET_LIST ENDS

MEMORY_SECTION_NAME STRUCT ALIGNMODE
    SectionFileName UNICODE_STRING <>
MEMORY_SECTION_NAME ENDS

DEBUG_BUFFER STRUCT ALIGNMODE
    SectionHandle           XWORD ?
    SectionBase             XPTR  ?
    RemoteSectionBase       XPTR  ?
    SectionBaseDelta        DD    ?
    EventPairHandle         XWORD ?
    _Unknown                DD    2 DUP(?)
    RemoteThreadHandle      XWORD ?
    InfoClassMask           DD    ?
    SizeOfInfo              DD    ?
    AllocatedSize           DD    ?
    SectionSize             DD    ?
    ModuleInformation       XPTR  ?
    BackTraceInformation    XPTR  ?
    HeapInformation         XPTR  ?
    LockInformation         XPTR  ?
    Reserved                XPTR  8 DUP(?)
DEBUG_BUFFER ENDS

DEBUG_MODULE_INFORMATION STRUCT ALIGNMODE
    Reserved            DD 2 DUP(?)
    Base                DD ?
    _Size               DD ?
    Flags               DD ?
    Index               DW ?
    _Unknown            DW ?
    LoadCount           DW ?
    ModuleNameOffset    DW ?
    ImageName           DB 256 DUP(?)
DEBUG_MODULE_INFORMATION ENDS

DEBUG_HEAP_INFORMATION STRUCT ALIGNMODE
    Base        DD   ?
    Flags       DD   ?
    Granularity DW   ?
    _Unknown    DW   ?
    Allocated   DD   ?
    Committed   DD   ?
    TagCount    DD   ?
    BlockCount  DD   ?
    Reserved    DD   7 DUP(?)
    Tags        XPTR ?
    Blocks      XPTR ?
DEBUG_HEAP_INFORMATION ENDS

DEBUG_LOCK_INFORMATION STRUCT ALIGNMODE
    Address                     XPTR ?
    _Type                       DW ?
    CreatorBackTraceIndex       DW ?
    OwnerThreadId               DD ?
    ActiveCount                 DD ?
    ContentionCount             DD ?
    EntryCount                  DD ?
    RecursionCount              DD ?
    NumberOfSharedWaiters       DD ?
    NumberOfExclusiveWaiters    DD ?
DEBUG_LOCK_INFORMATION ENDS

PORT_SECTION_WRITE STRUCT ALIGNMODE
    _Length         DD    ?
    SectionHandle   XWORD ?
    SectionOffset   DD    ?
    ViewSize        DD    ?
    ViewBase        XPTR  ?
    TargetViewBase  XPTR  ?
PORT_SECTION_WRITE ENDS

PORT_SECTION_READ STRUCT ALIGNMODE
    _Length     DD ?
    ViewSize    DD ?
    ViewBase    XPTR ?
PORT_SECTION_READ ENDS

IFNDEF FLOATING_SAVE_AREA_DEFINED
    FLOATING_SAVE_AREA_DEFINED EQU 1
    FLOATING_SAVE_AREA STRUCT ALIGNMODE
        ControlWord     DD ?
        StatusWord      DD ?
        TagWord         DD ?
        ErrorOffset     DD ?
        ErrorSelector   DD ?
        DataOffset      DD ?
        DataSelector    DD ?
        RegisterArea    DB SIZE_OF_80387_REGISTERS DUP(?)
        Cr0NpxState     DD ?
    FLOATING_SAVE_AREA ENDS
ENDIF

IFNDEF CONTEXT32_DEFINED
    CONTEXT32_DEFINED   EQU 1
    CONTEXT32 STRUCT ALIGNMODE
        ContextFlags        DD ?
        _Dr0                DD ?
        _Dr1                DD ?
        _Dr2                DD ?
        _Dr3                DD ?
        _Dr6                DD ?
        _Dr7                DD ?
        FloatSave           FLOATING_SAVE_AREA <>
        SegGs               DD ?
        SegFs               DD ?
        SegEs               DD ?
        SegDs               DD ?
        _Edi                DD ?
        _Esi                DD ?
        _Ebx                DD ?
        _Edx                DD ?
        _Ecx                DD ?
        _Eax                DD ?
        _Ebp                DD ?
        _Eip                DD ?
        SegCs               DD ?
        EFlags              DD ?
        _Esp                DD ?
        SegSs               DD ?
        ExtendedRegisters   DB MAXIMUM_SUPPORTED_EXTENSION DUP(?)
    CONTEXT32 ENDS
ENDIF

SCOPE_RECORD STRUCT ALIGNMODE
    BeginAddress    DD ?
    EndAddress      DD ?
    HandlerAddress  DD ?
    JumpTarget      DD ?
SCOPE_RECORD EndS

SCOPE_TABLE STRUCT ALIGNMODE
    Count          DD ?
    ScopeRecord    SCOPE_RECORD 2 DUP(<>)
SCOPE_TABLE ENDS

EXCEPTION_DATA STRUCT ALIGNMODE
    UNION
        ExceptionHandler DD ?
        FunctionEntry    DD ?
    ENDS
    ScopeTable          SCOPE_TABLE <>
EXCEPTION_DATA ENDS

IFNDEF XMM_SAVE_AREA32_DEFINED
    XMM_SAVE_AREA32_DEFINED EQU 1
    XMM_SAVE_AREA32 Struct ALIGNMODE
        ControlWord     DW ?
        StatusWord      DW ?
        TagWord         DB ?
        Reserved1       DB ?
        ErrorOpcode     DW ?
        ErrorOffset     DD ?
        ErrorSelector   DW ?
        Reserved2       DW ?
        DataOffset      DD ?
        DataSelector    DW ?
        Reserved3       DW ?
        MxCsr           DD ?
        MxCsr_Mask      DD ?
        FloatRegisters  M128A 8 DUP(<>)
        XmmRegisters    M128A 16 DUP(<>)
        Reserved4       DB 96 DUP(?)
    XMM_SAVE_AREA32 ENDS
ENDIF

IFNDEF CONTEXT64_DEFINED
    CONTEXT64_DEFINED   EQU 1
    CONTEXT64 STRUCT ALIGNMODE
        P1Home                  DQ ?
        P2Home                  DQ ?
        P3Home                  DQ ?
        P4Home                  DQ ?
        P5Home                  DQ ?
        P6Home                  DQ ?
        ContextFlags            DD ?
        MxCsr                   DD ?
        SegCs                   DW ?
        SegDs                   DW ?
        SegEs                   DW ?
        SegFs                   DW ?
        SegGs                   DW ?
        SegSs                   DW ?
        EFlags                  DD ?
        _Dr0                    DQ ?
        _Dr1                    DQ ?
        _Dr2                    DQ ?
        _Dr3                    DQ ?
        _Dr6                    DQ ?
        _Dr7                    DQ ?
        _Rax                    DQ ?
        _Rcx                    DQ ?
        _Rdx                    DQ ?
        _Rbx                    DQ ?
        _Rsp                    DQ ?
        _Rbp                    DQ ?
        _Rsi                    DQ ?
        _Rdi                    DQ ?
        _R8                     DQ ?
        _R9                     DQ ?
        _R10                    DQ ?
        _R11                    DQ ?
        _R12                    DQ ?
        _R13                    DQ ?
        _R14                    DQ ?
        _R15                    DQ ?
        _Rip                    DQ ?
        UNION
            FltSave             XMM_SAVE_AREA32 <>
            STRUCT
                Header          M128A 2 DUP(<>)
                Legacy          M128A 8 DUP(<>)
                _Xmm0           M128A <>
                _Xmm1           M128A <>
                _Xmm2           M128A <>
                _Xmm3           M128A <>
                _Xmm4           M128A <>
                _Xmm5           M128A <>
                _Xmm6           M128A <>
                _Xmm7           M128A <>
                _Xmm8           M128A <>
                _Xmm9           M128A <>
                _Xmm10          M128A <>
                _Xmm11          M128A <>
                _Xmm12          M128A <>
                _Xmm13          M128A <>
                _Xmm14          M128A <>
                _Xmm15          M128A <>
            ENDS
        ENDS
        VectorRegister          M128A 26 DUP(<>)
        VectorControl           DQ ?
        DebugControl            DQ ?
        LastBranchToRip         DQ ?
        LastBranchFromRip       DQ ?
        LastExceptionToRip      DQ ?
        LastExceptionFromRip    DQ ?
    CONTEXT64 ENDS
ENDIF

IMAGE_BASE_RELOCATION_EX STRUCT ALIGNMODE
    VirtualAddress  DD ?
    SizeOfBlock     DD ?
    TypeOffset      DW 2 DUP(?)
IMAGE_BASE_RELOCATION_EX ENDS

;======================================== Functions =======================================;
IF (NTDDI_VERSION GE NTDDI_WINXP)
    IFDEF APP_WIN64
        IFNDEF __C_specific_handler
            __C_specific_handler PROTO :XPTR,:XPTR,:XPTR,:XPTR
        ENDIF
        IFNDEF __chkstk
            __chkstk PROTO
        ENDIF
    ENDIF
ENDIF
__isascii PROTO :XWORD
__iscsym PROTO :VARARG
__iscsymf PROTO :VARARG
__toascii PROTO :VARARG
_atoi64 PROTO :XWORD
_i64toa PROTO :XWORD,:XWORD,:XWORD
_i64tow PROTO :XWORD,:XWORD,:XWORD
_itoa PROTO :XWORD,:XWORD,:XWORD
_itow PROTO :XWORD,:XWORD,:XWORD
_lfind PROTO :VARARG
_local_unwind PROTO
_ltoa PROTO :XWORD,:XWORD,:XWORD
_ltow PROTO :XWORD,:XWORD,:XWORD
_memccpy PROTO :XWORD,:XWORD,:XWORD,:XWORD
_memicmp PROTO :XWORD,:XWORD,:XWORD
_setjmp PROTO :XPTR
_setjmpex PROTO :XPTR
_snprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
_snwprintf PROTO :VARARG
_splitpath PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
_strcmpi PROTO :XWORD,:XWORD
_stricmp PROTO :XPTR,:XPTR
_strlwr PROTO :XPTR
_strnicmp PROTO :XPTR,:XPTR,:XPTR
_strupr PROTO :XPTR
_ui64toa PROTO :XWORD,:XWORD,:XWORD
_ui64tow PROTO :XWORD,:XWORD,:XWORD
_ultoa PROTO :XWORD,:XWORD,:XWORD
_ultow PROTO :XWORD,:XWORD,:XWORD
_vscwprintf PROTO :VARARG
_vsnprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
_vsnwprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
_wcsicmp PROTO :XPTR,:XPTR
_wcslwr PROTO :XPTR
_wcsnicmp PROTO :XPTR,:XPTR,:XPTR
_wcstoui64 PROTO :VARARG
_wcsupr PROTO :XPTR
_wtoi PROTO :XWORD
_wtoi64 PROTO :XWORD
_wtol PROTO :XWORD
abs PROTO :XWORD
atan PROTO :XWORD
atoi PROTO :XWORD
atol PROTO :XWORD
bsearch PROTO :XPTR,:XPTR,D :XPTR,:XPTR,:XPTR
ceil PROTO :XWORD
cos PROTO :XWORD
CsrAllocateCaptureBuffer PROTO :XWORD,:XWORD
CsrAllocateMessagePointer PROTO :XWORD,:XWORD,:XWORD
CsrCaptureMessageBuffer PROTO :XWORD,:XWORD,:XWORD,:XWORD
CsrCaptureMessageMultiUnicodeStringsInPlace PROTO :XWORD,:XWORD,:XWORD
CsrCaptureMessageString PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
CsrCaptureTimeout PROTO :XWORD,:XWORD
CsrClientCallServer PROTO :XWORD,:XWORD,:XWORD,:XWORD
CsrClientConnectToServer PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
CsrFreeCaptureBuffer PROTO :XWORD
CsrGetProcessId PROTO
CsrIdentifyAlertableThread PROTO
CsrSetPriorityClass PROTO :XWORD,:XWORD
DbgBreakPoint PROTO
DbgPrint PROTO :VARARG
DbgPrintEx PROTO :VARARG
DbgPrintReturnControlC PROTO :VARARG
DbgPrompt PROTO :XWORD,:XWORD,:XWORD
DbgQueryDebugFilterState PROTO :XWORD,:XWORD
DbgSetDebugFilterState PROTO :XWORD,:XWORD,:XWORD
DbgUiConnectToDbg PROTO
DbgUiContinue PROTO :XWORD,:XWORD
DbgUiConvertStateChangeStructure PROTO :XWORD,:XWORD
DbgUiDebugActiveProcess PROTO :XWORD
DbgUiGetThreadDebugObject PROTO
DbgUiIssueRemoteBreakin PROTO :XWORD
DbgUiRemoteBreakin PROTO :XWORD
DbgUiSetThreadDebugObject PROTO :XWORD
DbgUiStopDebugging PROTO :XWORD
DbgUiWaitStateChange PROTO :XWORD,:XWORD
DbgUserBreakPoint PROTO
EtwCreateTraceInstanceId PROTO :XWORD,:XPTR
EtwGetTraceEnableFlags PROTO :XWORD
EtwGetTraceEnableLevel PROTO :XWORD
EtwGetTraceLoggerHandle PROTO :XPTR
EtwRegisterTraceGuidsA PROTO :XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD
EtwRegisterTraceGuidsW PROTO :XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD
EtwTraceMessage PROTO :XWORD,:XWORD,:XPTR,:XWORD
EtwUnregisterTraceGuids PROTO :XWORD
floor PROTO :XWORD
isalnum PROTO :XWORD
isalpha PROTO :XWORD
iscntrl PROTO :XWORD
isdigit PROTO :XWORD
isgraph PROTO :XWORD
islower PROTO :XWORD
isprint PROTO :XWORD
ispunct PROTO :XWORD
isspace PROTO :XWORD
isupper PROTO :XWORD
iswalpha PROTO :XWORD
iswctype PROTO :VARARG
iswdigit PROTO :XWORD
iswlower PROTO :XWORD
iswspace PROTO :XWORD
iswxdigit PROTO :VARARG
isxdigit PROTO :XWORD
KiRaiseUserExceptionDispatcher PROTO
KiUserApcDispatcher PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
KiUserCallbackDispatcher PROTO :XWORD,:XWORD,:XWORD
KiUserExceptionDispatcher PROTO :XWORD,:XWORD
labs PROTO :XWORD
LdrAccessResource PROTO :XWORD,:XWORD,:XWORD,:XWORD
LdrAddRefDll PROTO :XWORD,:XWORD
LdrDisableThreadCalloutsForDll PROTO :XWORD
LdrEnumerateLoadedModules PROTO :XWORD,:XWORD,:XWORD
LdrEnumResources PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
LdrFindEntryForAddress PROTO :XWORD,:XWORD
LdrFindResource_U PROTO :XWORD,:XWORD,:XWORD,:XWORD
LdrFindResourceDirectory_U PROTO :XWORD,:XWORD,:XWORD,:XWORD
LdrFindResourceEx_U PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
LdrFlushAlternateResourceModules PROTO
LdrGetDllHandle PROTO :XWORD,:XWORD,:XWORD,:XWORD
LdrGetDllHandleEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
LdrGetProcedureAddress PROTO :XWORD,:XWORD,:XWORD,:XWORD
LdrInitializeThunk PROTO :XWORD,:XWORD,:XWORD,:XWORD
LdrInitShimEngineDynamic PROTO :XWORD
LdrLoadAlternateResourceModule PROTO :XWORD,:XWORD
LdrLoadDll PROTO :XWORD,:XWORD,:XWORD,:XWORD
LdrLockLoaderLock PROTO :XWORD,:XWORD,:XWORD
LdrOpenImageFileOptionsKey PROTO :XPTR,:XWORD,:XPTR
LdrProcessRelocationBlock PROTO :XWORD,:XWORD,:XWORD,:XWORD
LdrQueryImageFileExecutionOptions PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
LdrQueryImageFileExecutionOptionsEx PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD
LdrQueryImageFileKeyOption PROTO :XWORD,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR
LdrQueryProcessModuleInformation PROTO :XWORD,:XWORD,:XWORD
LdrSetAppCompatDllRedirectionCallback PROTO :XWORD,:XWORD,:XWORD
LdrSetDllManifestProber PROTO :XWORD
LdrShutdownProcess PROTO
LdrShutdownThread PROTO
LdrUnloadAlternateResourceModule PROTO :XWORD
LdrUnloadDll PROTO :XWORD
LdrUnlockLoaderLock PROTO :XWORD,:XWORD
LdrVerifyImageMatchesChecksum PROTO :XWORD,:XWORD,:XWORD,:XWORD
log PROTO :XWORD
longjmp PROTO :XPTR,:XWORD
mbstowcs PROTO :XPTR,:XPTR,:XPTR
memchr PROTO :XWORD,:XWORD,:XWORD
memcmp PROTO :XPTR,:XPTR,:XPTR
memcpy PROTO :XWORD,:XWORD,:XWORD
memmove PROTO :XWORD,:XWORD,:XWORD
memset PROTO :XWORD,:XWORD,:XWORD
NlsAnsiCodePage PROTO :VARARG
NlsMbCodePageTag PROTO :VARARG
NlsMbOemCodePageTag PROTO :VARARG
NtAcceptConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAccessCheck PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAccessCheckAndAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAccessCheckByType PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAccessCheckByTypeAndAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAccessCheckByTypeResultList PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAccessCheckByTypeResultListAndAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAccessCheckByTypeResultListAndAuditAlarmByHandle PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAddAtom PROTO :XWORD,:XWORD,:XWORD
NtAddBootEntry PROTO :XWORD,:XWORD
NtAddDriverEntry PROTO :XPTR,:XWORD
NtAdjustGroupsToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAdjustPrivilegesToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtAlertResumeThread PROTO :XWORD,:XWORD
NtAlertThread PROTO :XWORD
NtAllocateLocallyUniqueId PROTO :XWORD
NtAllocateUserPhysicalPages PROTO :XWORD,:XWORD,:XWORD
NtAllocateUuids PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtAllocateVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtApphelpCacheControl PROTO :XWORD,:XWORD
NtAreMappedFilesTheSame PROTO :XWORD,:XWORD
NtAssignProcessToJobObject PROTO :XWORD,:XWORD
NtCallbackReturn PROTO :XWORD,:XWORD,:XWORD
NtCancelIoFile PROTO :XWORD,:XWORD
NtCancelTimer PROTO :XWORD,:XWORD
NtClearEvent PROTO :XWORD
NtClose PROTO :XWORD
NtCloseObjectAuditAlarm PROTO :XWORD,:XWORD,:XWORD
NtCompactKeys PROTO :XWORD,:XWORD
NtCompareTokens PROTO :XWORD,:XWORD,:XWORD
NtCompleteConnectPort PROTO :XWORD
NtCompressKey PROTO :XWORD
NtConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtContinue PROTO :XWORD,:XWORD
NtCreateDebugObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtCreateDirectoryObject PROTO :XWORD,:XWORD,:XWORD
NtCreateEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateEventPair PROTO :XWORD,:XWORD,:XWORD
NtCreateFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtCreateJobObject PROTO :XWORD,:XWORD,:XWORD
NtCreateJobSet PROTO :XWORD,:XWORD,:XWORD
NtCreateKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateKeyedEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtCreateMailslotFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateMutant PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtCreateNamedPipeFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreatePagingFile PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtCreatePort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateProcessEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateProfile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateSection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateSemaphore PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateSymbolicLinkObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtCreateThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtCreateToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtCreateWaitablePort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtDebugActiveProcess PROTO :XWORD,:XWORD
NtDebugContinue PROTO :XWORD,:XWORD,:XWORD
NtDelayExecution PROTO :XWORD,:XWORD
NtDeleteAtom PROTO :XWORD
NtDeleteBootEntry PROTO :XWORD
NtDeleteDriverEntry PROTO :XWORD
NtDeleteFile PROTO :XWORD
NtDeleteKey PROTO :XWORD
NtDeleteObjectAuditAlarm PROTO :XWORD,:XWORD,:XWORD
NtDeleteValueKey PROTO :XWORD,:XWORD
NtDeviceIoControlFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtDisableLastKnownGood PROTO
NtDisplayString PROTO :XWORD
NtDuplicateObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtDuplicateToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtEnableLastKnownGood PROTO
NtEnumerateBootEntries PROTO :XWORD,:XWORD
NtEnumerateDriverEntries PROTO :XPTR,:XPTR
NtEnumerateKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtEnumerateSystemEnvironmentValuesEx PROTO :XWORD,:XWORD,:XWORD
NtEnumerateValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtExtendSection PROTO :XWORD,:XWORD
NtFilterToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtFindAtom PROTO :XWORD,:XWORD,:XWORD
NtFlushBuffersFile PROTO :XWORD,:XWORD
NtFlushInstructionCache PROTO :XWORD,:XWORD,:XWORD
NtFlushKey PROTO :XWORD
NtFlushVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtFlushWriteBuffer PROTO
NtFreeUserPhysicalPages PROTO :XWORD,:XWORD,:XWORD
NtFreeVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtFsControlFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtGetContextThread PROTO :XWORD,:XWORD
NtGetCurrentProcessorNumber PROTO
NtGetDevicePowerState PROTO :XWORD,:XWORD
NtGetTickCount PROTO
NtGetWriteWatch PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtImpersonateAnonymousToken PROTO :XWORD
NtImpersonateClientOfPort PROTO :XWORD,:XWORD
NtImpersonateThread PROTO :XWORD,:XWORD,:XWORD
NtInitializeRegistry PROTO :XWORD
NtInitiatePowerAction PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtIsProcessInJob PROTO :XWORD,:XWORD
NtIsSystemResumeAutomatic PROTO
NtListenPort PROTO :XWORD,:XWORD
NtLoadDriver PROTO :XWORD
NtLoadKey PROTO :XWORD,:XWORD
NtLoadKey2 PROTO :XWORD,:XWORD,:XWORD
NtLoadKeyEx PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtLockFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtLockProductActivationKeys PROTO :XWORD,:XWORD
NtLockRegistryKey PROTO :XWORD
NtLockVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtMakePermanentObject PROTO :XWORD
NtMakeTemporaryObject PROTO :XWORD
NtMapUserPhysicalPages PROTO :XWORD,:XWORD,:XWORD
NtMapUserPhysicalPagesScatter PROTO :XWORD,:XWORD,:XWORD
NtMapViewOfSection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtModifyBootEntry PROTO :XWORD
NtModifyDriverEntry PROTO :XPTR
NtNotifyChangeDirectoryFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtNotifyChangeKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtNotifyChangeMultipleKeys PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtOpenDirectoryObject PROTO :XWORD,:XWORD,:XWORD
NtOpenEvent PROTO :XWORD,:XWORD,:XWORD
NtOpenEventPair PROTO :XWORD,:XWORD,:XWORD
NtOpenFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtOpenIoCompletion PROTO :XWORD,:XWORD,:XWORD
NtOpenJobObject PROTO :XWORD,:XWORD,:XWORD
NtOpenKey PROTO :XWORD,:XWORD,:XWORD
NtOpenKeyedEvent PROTO :XWORD,:XWORD,:XWORD
NtOpenMutant PROTO :XWORD,:XWORD,:XWORD
NtOpenObjectAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtOpenProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtOpenProcessToken PROTO :XWORD,:XWORD,:XWORD
NtOpenProcessTokenEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtOpenSection PROTO :XWORD,:XWORD,:XWORD
NtOpenSemaphore PROTO :XWORD,:XWORD,:XWORD
NtOpenSymbolicLinkObject PROTO :XWORD,:XWORD,:XWORD
NtOpenThread PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtOpenThreadToken PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtOpenThreadTokenEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtOpenTimer PROTO :XWORD,:XWORD,:XWORD
NtPlugPlayControl PROTO :XWORD,:XWORD,:XWORD
NtPowerInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtPrivilegeCheck PROTO :XWORD,:XWORD,:XWORD
NtPrivilegedServiceAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtPrivilegeObjectAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtProtectVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtPulseEvent PROTO :XWORD,:XWORD
NtQueryAttributesFile PROTO :XWORD,:XWORD
NtQueryBootEntryOrder PROTO :XWORD,:XWORD
NtQueryBootOptions PROTO :XWORD,:XWORD
NtQueryDebugFilterState PROTO :XWORD,:XWORD
NtQueryDefaultLocale PROTO :XWORD,:XWORD
NtQueryDefaultUILanguage PROTO :XWORD
NtQueryDirectoryFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryDirectoryObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryDriverEntryOrder PROTO :XPTR,:XPTR
NtQueryEaFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryFullAttributesFile PROTO :XWORD,:XWORD
NtQueryInformationAtom PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryInformationJobObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryInformationPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryInformationProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryInformationThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryInformationToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryInstallUILanguage PROTO :XWORD
NtQueryIntervalProfile PROTO :XWORD,:XWORD
NtQueryIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryMultipleValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryMutant PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryOpenSubKeys PROTO :XWORD,:XWORD
NtQueryPerformanceCounter PROTO :XWORD,:XWORD
NtQueryPortInformationProcess PROTO
NtQueryQuotaInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQuerySection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQuerySecurityObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQuerySemaphore PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQuerySymbolicLinkObject PROTO :XWORD,:XWORD,:XWORD
NtQuerySystemEnvironmentValue PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtQuerySystemEnvironmentValueEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQuerySystemInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtQuerySystemTime PROTO :XWORD
NtQueryTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryTimerResolution PROTO :XWORD,:XWORD,:XWORD
NtQueryValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueryVolumeInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtQueueApcThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtRaiseException PROTO :XWORD,:XWORD,:XWORD
NtRaiseHardError PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtReadFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtReadFileScatter PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtReadRequestData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtReadVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtRegisterThreadTerminatePort PROTO :XWORD
NtReleaseKeyedEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtReleaseMutant PROTO :XWORD,:XWORD
NtReleaseSemaphore PROTO :XWORD,:XWORD,:XWORD
NtRemoveIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtRemoveProcessDebug PROTO :XWORD,:XWORD
NtRenameKey PROTO :XWORD,:XWORD
NtReplaceKey PROTO :XWORD,:XWORD,:XWORD
NtReplyPort PROTO :XWORD,:XWORD
NtReplyWaitReceivePort PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtReplyWaitReceivePortEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtReplyWaitReplyPort PROTO :XWORD,:XWORD
NtRequestPort PROTO :XWORD,:XWORD
NtRequestWaitReplyPort PROTO :XWORD,:XWORD,:XWORD
NtResetEvent PROTO :XWORD,:XWORD
NtResetWriteWatch PROTO :XWORD,:XWORD,:XWORD
NtRestoreKey PROTO :XWORD,:XWORD,:XWORD
NtResumeProcess PROTO :XWORD
NtResumeThread PROTO :XWORD,:XWORD
NtSaveKey PROTO :XWORD,:XWORD
NtSaveKeyEx PROTO :XWORD,:XWORD,:XWORD
NtSaveMergedKeys PROTO :XWORD,:XWORD,:XWORD
NtSecureConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtSetBootEntryOrder PROTO :XWORD,:XWORD
NtSetBootOptions PROTO :XWORD,:XWORD
NtSetContextThread PROTO :XWORD,:XWORD
NtSetDebugFilterState PROTO :XWORD,:XWORD,:XWORD
NtSetDefaultHardErrorPort PROTO :XWORD
NtSetDefaultLocale PROTO :XWORD,:XWORD
NtSetDefaultUILanguage PROTO :XWORD
NtSetDriverEntryOrder PROTO :XPTR,:XPTR
NtSetEaFile PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtSetEvent PROTO :XWORD,:XWORD
NtSetEventBoostPriority PROTO :XWORD
NtSetHighEventPair PROTO :XWORD
NtSetHighWaitLowEventPair PROTO :XWORD
NtSetInformationDebugObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtSetInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtSetInformationJobObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtSetInformationKey PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtSetInformationObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtSetInformationProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtSetInformationThread PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtSetInformationToken PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtSetIntervalProfile PROTO :XWORD,:XWORD
NtSetIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtSetLdtEntries PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtSetLowEventPair PROTO :XWORD
NtSetLowWaitHighEventPair PROTO :XWORD
NtSetQuotaInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtSetSecurityObject PROTO :XWORD,:XWORD,:XWORD
NtSetSystemEnvironmentValue PROTO :XWORD,:XWORD
NtSetSystemEnvironmentValueEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtSetSystemInformation PROTO :XWORD,:XWORD,:XWORD
NtSetSystemPowerState PROTO :XWORD,:XWORD,:XWORD
NtSetSystemTime PROTO :XWORD,:XWORD
NtSetThreadExecutionState PROTO :XWORD,:XWORD
NtSetTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtSetTimerResolution PROTO :XWORD,:XWORD,:XWORD
NtSetUuidSeed PROTO :XWORD
NtSetValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtSetVolumeInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtShutdownSystem PROTO :XWORD
NtSignalAndWaitForSingleObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtStartProfile PROTO :XWORD
NtStopProfile PROTO :XWORD
NtSuspendProcess PROTO :XWORD
NtSuspendThread PROTO :XWORD,:XWORD
NtSystemDebugControl PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtTerminateJobObject PROTO :XWORD,:XWORD
NtTerminateProcess PROTO :XWORD,:XWORD
NtTerminateThread PROTO :XWORD,:XWORD
NtTestAlert PROTO
NtTraceEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtTranslateFilePath PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtUnloadDriver PROTO :XWORD
NtUnloadKey PROTO :XWORD
NtUnloadKey2 PROTO :XWORD
NtUnloadKeyEx PROTO :XWORD,:XWORD
NtUnlockFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtUnlockVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtUnmapViewOfSection PROTO :XWORD,:XWORD
NtVdmControl PROTO :XWORD,:XWORD
NtWaitForDebugEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtWaitForKeyedEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
NtWaitForMultipleObjects PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtWaitForMultipleObjects32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR
NtWaitForSingleObject PROTO :XWORD,:XWORD,:XWORD
NtWaitHighEventPair PROTO :XWORD
NtWaitLowEventPair PROTO :XWORD
NtWriteFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtWriteFileGather PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtWriteRequestData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtWriteVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
NtYieldExecution PROTO
PfxFindPrefix PROTO :XWORD,:XWORD
PfxInitialize PROTO :XWORD
PfxInsertPrefix PROTO :XWORD,:XWORD,:XWORD
PfxRemovePrefix PROTO :XWORD,:XWORD
pow PROTO :XWORD,:XWORD
qsort PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlAbortRXact PROTO :XWORD
RtlAbsoluteToSelfRelativeSD PROTO :XWORD,:XWORD,:XWORD
RtlAcquirePebLock PROTO
RtlAcquirePrivilege PROTO :XPTR,:XWORD,:XWORD,:XPTR
RtlAcquireResourceExclusive PROTO :XWORD,:XWORD
RtlAcquireResourceShared PROTO :XWORD,:XWORD
RtlActivateActivationContext PROTO :XWORD,:XWORD,:XWORD
RtlActivateActivationContextEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlActivateActivationContextUnsafeFast PROTO :XWORD,:XWORD
RtlAddAccessAllowedAce PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlAddAccessAllowedAceEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddAccessAllowedObjectAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddAccessDeniedAce PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlAddAccessDeniedAceEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddAccessDeniedObjectAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddActionToRXact PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddAtomToAtomTable PROTO :XWORD,:XWORD,:XWORD
RtlAddAttributeActionToRXact PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddAuditAccessAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddAuditAccessAceEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddAuditAccessObjectAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddCompoundAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAddFunctionTable PROTO :XPTR,:XWORD,:XWORD,:XWORD
RtlAddRefActivationContext PROTO :XWORD
RtlAddRefMemoryStream PROTO :XWORD
RtlAddressInSectionTable PROTO :XWORD,:XWORD,:XWORD
RtlAddVectoredContinueHandler PROTO :XWORD,:XPTR
RtlAddVectoredExceptionHandler PROTO :XWORD,:XWORD
RtlAdjustPrivilege PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlAllocateActivationContextStack PROTO :XPTR,:XPTR
RtlAllocateAndInitializeSid PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlAllocateHandle PROTO :XWORD,:XWORD
RtlAllocateHeap PROTO :XWORD,:XWORD,:XWORD
RtlAnsiCharToUnicodeChar PROTO :XWORD
RtlAnsiStringToUnicodeSize PROTO :XWORD
RtlAnsiStringToUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlAppendAsciizToString PROTO :XWORD,:XWORD
RtlAppendPathElement PROTO :XWORD,:XWORD,:XWORD
RtlAppendStringToString PROTO :XWORD,:XWORD
RtlAppendUnicodeStringToString PROTO :XWORD,:XWORD
RtlAppendUnicodeToString PROTO :XWORD,:XWORD
RtlApplicationVerifierStop PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlApplyRXact PROTO :XWORD
RtlApplyRXactNoFlush PROTO :XWORD
RtlAreAllAccessesGranted PROTO :XWORD,:XWORD
RtlAreAnyAccessesGranted PROTO :XWORD,:XWORD
RtlAreBitsClear PROTO :XWORD,:XWORD,:XWORD
RtlAreBitsSet PROTO :XWORD,:XWORD,:XWORD
RtlAssert PROTO :XWORD,:XWORD,:XWORD
RtlCancelTimer PROTO :XWORD,:XWORD
RtlCaptureContext PROTO :XWORD
RtlCaptureStackBackTrace PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlCharToInteger PROTO :XWORD,:XWORD,:XWORD
RtlCheckForOrphanedCriticalSections PROTO :XWORD
RtlCheckRegistryKey PROTO :XWORD,:XWORD
RtlClearAllBits PROTO :XWORD
RtlClearBits PROTO :XWORD,:XWORD,:XWORD
RtlCloneMemoryStream PROTO :XWORD,:XWORD
RtlCommitMemoryStream PROTO :XWORD,:XWORD
RtlCompactHeap PROTO :XWORD,:XWORD
RtlCompareMemory PROTO :XWORD,:XWORD,:XWORD
RtlCompareMemoryUlong PROTO :XWORD,:XWORD,:XWORD
RtlCompareString PROTO :XWORD,:XWORD,:XWORD
RtlCompareUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlCompressBuffer PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlComputeCrc32 PROTO :XWORD,:XWORD,:XWORD
RtlComputeImportTableHash PROTO :XWORD,:XWORD,:XWORD
RtlComputePrivatizedDllName_U PROTO :XWORD,:XWORD,:XWORD
RtlConsoleMultiByteToUnicodeN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlConvertExclusiveToShared PROTO :XWORD
RtlConvertSharedToExclusive PROTO :XWORD
RtlConvertSidToUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlConvertToAutoInheritSecurityObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCopyLuid PROTO :XWORD,:XWORD
RtlCopyLuidAndAttributesArray PROTO :XWORD,:XWORD,:XWORD
RtlCopyMappedMemory PROTO :XPTR,:XPTR,:XPTR
RtlCopyMemory PROTO :XPTR,:XPTR,:XWORD
RtlCopyMemoryNonTemporal PROTO :XPTR,:XPTR,:XWORD
RtlCopyMemoryStreamTo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCopyOutOfProcessMemoryStreamTo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCopySecurityDescriptor PROTO :XWORD,:XWORD
RtlCopySid PROTO :XWORD,:XWORD,:XWORD
RtlCopySidAndAttributesArray PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCopyString PROTO :XWORD,:XWORD
RtlCopyUnicodeString PROTO :XWORD,:XWORD
RtlCreateAcl PROTO :XWORD,:XWORD,:XWORD
RtlCreateActivationContext PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCreateAndSetSD PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCreateAtomTable PROTO :XWORD,:XWORD
RtlCreateBootStatusDataFile PROTO
RtlCreateEnvironment PROTO :XWORD,:XWORD
RtlCreateHeap PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCreateProcessParameters PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCreateQueryDebugBuffer PROTO :XWORD,:XWORD
RtlCreateRegistryKey PROTO :XWORD,:XWORD
RtlCreateSecurityDescriptor PROTO :XWORD,:XWORD
RtlCreateServiceSid PROTO :XPTR,:XPTR,:XPTR
RtlCreateSystemVolumeInformationFolder PROTO :XWORD
RtlCreateTagHeap PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlCreateTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCreateTimerQueue PROTO :XWORD
RtlCreateUnicodeString PROTO :XWORD,:XWORD
RtlCreateUnicodeStringFromAsciiz PROTO :XWORD,:XWORD
RtlCreateUserProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCreateUserSecurityObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCreateUserThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCustomCPToUnicodeN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlCutoverTimeToSystemTime PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlDeactivateActivationContext PROTO :XWORD,:XWORD
RtlDeactivateActivationContextUnsafeFast PROTO :XWORD
RtlDebugPrintTimes PROTO
RtlDecodePointer PROTO :XWORD
RtlDecodeSystemPointer PROTO :XWORD
RtlDecompressBuffer PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlDecompressFragment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlDefaultNpAcl PROTO :XWORD
RtlDelete PROTO :XWORD
RtlDeleteAce PROTO :XWORD,:XWORD
RtlDeleteAtomFromAtomTable PROTO :XWORD,:XWORD
RtlDeleteCriticalSection PROTO :XWORD
RtlDeleteElementGenericTable PROTO :XWORD,:XWORD
RtlDeleteElementGenericTableAvl PROTO :XWORD,:XWORD
RtlDeleteFunctionTable PROTO :XPTR
RtlDeleteNoSplay PROTO :XWORD,:XWORD
RtlDeleteRegistryValue PROTO :XWORD,:XWORD,:XWORD
RtlDeleteResource PROTO :XWORD
RtlDeleteSecurityObject PROTO :XWORD
RtlDeleteTimer PROTO :XWORD,:XWORD,:XWORD
RtlDeleteTimerQueue PROTO :XWORD
RtlDeleteTimerQueueEx PROTO :XWORD,:XWORD
RtlDeNormalizeProcessParams PROTO :XWORD
RtlDeregisterWait PROTO :XWORD
RtlDeregisterWaitEx PROTO :XWORD,:XWORD
RtlDestroyAtomTable PROTO :XWORD
RtlDestroyEnvironment PROTO :XWORD
RtlDestroyHandleTable PROTO :XWORD
RtlDestroyHeap PROTO :XWORD
RtlDestroyProcessParameters PROTO :XWORD
RtlDestroyQueryDebugBuffer PROTO :XWORD
RtlDetermineDosPathNameType_U PROTO :XWORD
RtlDllShutdownInProgress PROTO
RtlDnsHostNameToComputerName PROTO :XWORD,:XWORD,:XWORD
RtlDoesFileExists_U PROTO :XWORD
RtlDosApplyFileIsolationRedirection_Ustr PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlDosPathNameToNtPathName_U PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlDosPathNameToNtPathName_U_WithStatus PROTO :XPTR,:XPTR
RtlDosPathNameToRelativeNtPathName_U PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlDosPathNameToRelativeNtPathName_U_WithStatus PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlDosSearchPath_U PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlDosSearchPath_Ustr PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlDowncaseUnicodeChar PROTO :XWORD
RtlDowncaseUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlDumpResource PROTO :XWORD
RtlDuplicateUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlEmptyAtomTable PROTO :XWORD,:XWORD
RtlEnableEarlyCriticalSectionEventCreation PROTO
RtlEncodePointer PROTO :XWORD
RtlEncodeSystemPointer PROTO :XWORD
RtlEnterCriticalSection PROTO :XWORD
RtlEnumerateGenericTable PROTO :XWORD,:XWORD
RtlEnumerateGenericTableAvl PROTO :XWORD,:XWORD
RtlEnumerateGenericTableLikeADirectory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlEnumerateGenericTableWithoutSplaying PROTO :XWORD,:XWORD
RtlEnumerateGenericTableWithoutSplayingAvl PROTO :XWORD,:XWORD
RtlEnumProcessHeaps PROTO :XWORD,:XWORD
RtlEqualComputerName PROTO :XWORD,:XWORD
RtlEqualDomainName PROTO :XWORD,:XWORD
RtlEqualLuid PROTO :XWORD,:XWORD
RtlEqualPrefixSid PROTO :XWORD,:XWORD
RtlEqualSid PROTO :XWORD,:XWORD
RtlEqualString PROTO :XWORD,:XWORD,:XWORD
RtlEqualUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlEraseUnicodeString PROTO :XWORD
RtlExitUserThread PROTO :XWORD
RtlExpandEnvironmentStrings_U PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlFillMemory PROTO :XWORD,:XWORD,:XWORD
RtlFinalReleaseOutOfProcessMemoryStream PROTO :XWORD
RtlFindActivationContextSectionGuid PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlFindActivationContextSectionString PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlFindCharInUnicodeString PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlFindClearBits PROTO :XWORD,:XWORD,:XWORD
RtlFindClearBitsAndSet PROTO :XWORD,:XWORD,:XWORD
RtlFindClearRuns PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlFindLastBackwardRunClear PROTO :XWORD,:XWORD,:XWORD
RtlFindLeastSignificantBit PROTO :XWORD,:XWORD
RtlFindLongestRunClear PROTO :XWORD,:XWORD
RtlFindMessage PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlFindMostSignificantBit PROTO :XWORD,:XWORD
RtlFindNextForwardRunClear PROTO :XWORD,:XWORD,:XWORD
RtlFindSetBits PROTO :XWORD,:XWORD,:XWORD
RtlFindSetBitsAndClear PROTO :XWORD,:XWORD,:XWORD
RtlFirstEntrySList PROTO :XWORD
RtlFirstFreeAce PROTO :XWORD,:XWORD
RtlFlushSecureMemoryCache PROTO :XWORD,:XWORD
RtlFormatCurrentUserKeyPath PROTO :XWORD
RtlFormatMessage PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlFormatMessageEx PROTO :XPTR,:XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD
RtlFreeActivationContextStack PROTO :XPTR
RtlFreeAnsiString PROTO :XWORD
RtlFreeHandle PROTO :XWORD,:XWORD
RtlFreeHeap PROTO :XWORD,:XWORD,:XWORD
RtlFreeOemString PROTO :XWORD
RtlFreeSid PROTO :XWORD
RtlFreeThreadActivationContextStack PROTO
RtlFreeUnicodeString PROTO :XWORD
RtlGenerate8dot3Name PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlGetAce PROTO :XWORD,:XWORD,:XWORD
RtlGetActiveActivationContext PROTO :XWORD
RtlGetCallersAddress PROTO :XWORD,:XWORD
RtlGetCompressionWorkSpaceSize PROTO :XWORD,:XWORD,:XWORD
RtlGetControlSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD
RtlGetCriticalSectionRecursionCount PROTO 
RtlGetCurrentDirectory_U PROTO :XWORD,:XWORD
RtlGetCurrentPeb PROTO
RtlGetCurrentProcessorNumber PROTO
RtlGetDaclSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlGetElementGenericTable PROTO :XWORD,:XWORD
RtlGetElementGenericTableAvl PROTO :XWORD,:XWORD
RtlGetFrame PROTO
RtlGetFullPathName_U PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlGetFullPathName_UstrEx PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
RtlGetFunctionTableListHead PROTO
RtlGetGroupSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD
RtlGetLastNtStatus PROTO
RtlGetLastWin32Error PROTO
RtlGetLengthWithoutLastFullDosOrNtPathElement PROTO :XWORD,:XWORD,:XWORD
RtlGetLengthWithoutTrailingPathSeperators PROTO :XWORD,:XWORD,:XWORD
RtlGetLongestNtPathLength PROTO
RtlGetNativeSystemInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlGetNtGlobalFlags PROTO
RtlGetNtProductType PROTO :XWORD
RtlGetNtVersionNumbers PROTO :XWORD,:XWORD,:XWORD
RtlGetOwnerSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD
RtlGetProcessHeaps PROTO :XWORD,:XWORD
RtlGetSaclSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlGetSecurityDescriptorRMControl PROTO :XWORD,:XWORD
RtlGetSetBootStatusData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlGetThreadErrorMode PROTO
RtlGetUnloadEventTrace PROTO
RtlGetVersion PROTO :XWORD
RtlGUIDFromString PROTO :XPTR,:XPTR
RtlHashUnicodeString PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIdentifierAuthoritySid PROTO :XWORD
RtlImageDirectoryEntryToData PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlImageNtHeader PROTO :XWORD
RtlImageNtHeaderEx PROTO :XWORD,:XPTR,:XWORD,:XPTR
RtlImageRvaToSection PROTO :XWORD,:XWORD,:XWORD
RtlImageRvaToVa PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlImpersonateSelf PROTO :XWORD
RtlInitAnsiString PROTO :XWORD,:XWORD
RtlInitAnsiStringEx PROTO :XPTR,:XPTR
RtlInitCodePageTable PROTO :XWORD,:XWORD
RtlInitializeAtomPackage PROTO :XWORD
RtlInitializeBitMap PROTO :XPTR,:XPTR,:XWORD
RtlInitializeContext PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XPTR
RtlInitializeCriticalSection PROTO :XWORD
RtlInitializeCriticalSectionAndSpinCount PROTO :XWORD,:XWORD
RtlInitializeGenericTable PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlInitializeGenericTableAvl PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlInitializeHandleTable PROTO :XWORD,:XWORD,:XWORD
RtlInitializeResource PROTO :XWORD
RtlInitializeRXact PROTO :XWORD,:XWORD,:XWORD
RtlInitializeSid PROTO :XWORD,:XWORD,:XWORD
RtlInitializeSListHead PROTO :XWORD
RtlInitMemoryStream PROTO :XWORD
RtlInitNlsTables PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlInitOutOfProcessMemoryStream PROTO :XWORD
RtlInitString PROTO :XWORD,:XWORD
RtlInitUnicodeString PROTO :XWORD,:XWORD
RtlInitUnicodeStringEx PROTO :XWORD,:XWORD
RtlInsertElementGenericTable PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlInsertElementGenericTableAvl PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlInsertElementGenericTableFull PROTO :XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD
RtlInsertElementGenericTableFullAvl PROTO :XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD
RtlInstallFunctionTableCallback PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR
RtlInt64ToUnicodeString PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIntegerToChar PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIntegerToUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlInterlockedFlushSList PROTO :XWORD
RtlInterlockedPopEntrySList PROTO :XWORD
RtlInterlockedPushEntrySList PROTO :XWORD,:XWORD
RtlInterlockedPushListSList PROTO :XPTR,:XPTR,:XWORD
RtlIpv4AddressToStringA PROTO :XWORD,:XWORD
RtlIpv4AddressToStringExA PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIpv4AddressToStringExW PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIpv4AddressToStringW PROTO :XWORD,:XWORD
RtlIpv4StringToAddressA PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIpv4StringToAddressExA PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIpv4StringToAddressExW PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIpv4StringToAddressW PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIpv6AddressToStringA PROTO :XWORD,:XWORD
RtlIpv6AddressToStringExA PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlIpv6AddressToStringExW PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlIpv6AddressToStringW PROTO :XWORD,:XWORD
RtlIpv6StringToAddressA PROTO :XWORD,:XWORD,:XWORD
RtlIpv6StringToAddressExA PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIpv6StringToAddressExW PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlIpv6StringToAddressW PROTO :XWORD,:XWORD,:XWORD
RtlIsActivationContextActive PROTO :XWORD
RtlIsCriticalSectionLocked PROTO :XPTR
RtlIsCriticalSectionLockedByThread PROTO :XPTR
RtlIsDosDeviceName_U PROTO :XWORD
RtlIsGenericTableEmpty PROTO :XWORD
RtlIsGenericTableEmptyAvl PROTO :XWORD
RtlIsNameLegalDOS8Dot3 PROTO :XWORD,:XWORD,:XWORD
RtlIsTextUnicode PROTO :XWORD,:XWORD,:XWORD
RtlIsThreadWithinLoaderCallout PROTO
RtlIsValidHandle PROTO :XWORD,:XWORD
RtlIsValidIndexHandle PROTO :XWORD,:XWORD,:XWORD
RtlLargeIntegerToChar PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlLeaveCriticalSection PROTO :XWORD
RtlLengthRequiredSid PROTO :XWORD
RtlLengthSecurityDescriptor PROTO :XWORD
RtlLengthSid PROTO :XWORD
RtlLocalTimeToSystemTime PROTO :XWORD,:XWORD
RtlLockBootStatusData PROTO :XWORD
RtlLockHeap PROTO :XWORD
RtlLockMemoryStreamRegion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlLogStackBackTrace PROTO
RtlLookupAtomInAtomTable PROTO :XWORD,:XWORD,:XWORD
RtlLookupElementGenericTable PROTO :XWORD,:XWORD
RtlLookupElementGenericTableAvl PROTO :XWORD,:XWORD
RtlLookupElementGenericTableFull PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlLookupElementGenericTableFullAvl PROTO :XPTR,:XPTR,:XPTR,:XPTR
RtlLookupFunctionEntry PROTO :XWORD,:XPTR,:XPTR
RtlLookupFunctionTable PROTO  :XWORD,:XPTR,:XPTR
RtlMakeSelfRelativeSD PROTO :XWORD,:XWORD,:XWORD
RtlMapGenericMask PROTO :XWORD,:XWORD
RtlMapSecurityErrorToNtStatus PROTO :XWORD
RtlMoveMemory PROTO :XWORD,:XWORD,:XWORD
RtlMultiAppendUnicodeStringBuffer PROTO :XWORD,:XWORD,:XWORD
RtlMultiByteToUnicodeN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlMultiByteToUnicodeSize PROTO :XWORD,:XWORD,:XWORD
RtlMultipleAllocateHeap PROTO :XPTR,:XWORD,:XPTR
RtlMultipleFreeHeap PROTO :XPTR,:XWORD,:XWORD,:XPTR
RtlNewInstanceSecurityObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlNewSecurityGrantedAccess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlNewSecurityObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlNewSecurityObjectEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlNewSecurityObjectWithMultipleInheritance PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlNormalizeProcessParams PROTO :XWORD
RtlNtPathNameToDosPathName PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlNtStatusToDosError PROTO :XWORD
RtlNtStatusToDosErrorNoTeb PROTO :XWORD
RtlNumberGenericTableElements PROTO :XWORD
RtlNumberGenericTableElementsAvl PROTO :XWORD
RtlNumberOfClearBits PROTO :XWORD
RtlNumberOfSetBits PROTO :XWORD
RtlOemStringToUnicodeSize PROTO :XWORD
RtlOemStringToUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlOemToUnicodeN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlOpenCurrentUser PROTO :XWORD,:XWORD
RtlpApplyLengthFunction PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlPcToFileHeader PROTO :XWORD,:XWORD
RtlpEnsureBufferSize PROTO :XWORD,:XWORD,:XWORD
RtlPinAtomInAtomTable PROTO :XWORD,:XWORD
RtlpNotOwnerCriticalSection PROTO :XWORD
RtlpNtCreateKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlpNtEnumerateSubKey PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlpNtMakeTemporaryKey PROTO :XWORD
RtlpNtOpenKey PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlpNtQueryValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlpNtSetValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlPopFrame PROTO :XWORD
RtlPrefixString PROTO :XWORD,:XWORD,:XWORD
RtlPrefixUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlProtectHeap PROTO :XWORD,:XWORD
RtlpUnWaitCriticalSection PROTO :XWORD
RtlPushFrame PROTO :XWORD
RtlpWaitForCriticalSection PROTO :XWORD
RtlQueryAtomInAtomTable PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlQueryDepthSList PROTO :XWORD
RtlQueryEnvironmentVariable_U PROTO :XWORD,:XWORD,:XWORD
RtlQueryHeapInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlQueryInformationAcl PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlQueryInformationActivationContext PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlQueryInformationActiveActivationContext PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlQueryInterfaceMemoryStream PROTO :XWORD,:XWORD,:XWORD
RtlQueryProcessBackTraceInformation PROTO :XWORD
RtlQueryProcessDebugInformation PROTO :XWORD,:XWORD,:XWORD
RtlQueryProcessHeapInformation PROTO :XWORD
RtlQueryProcessLockInformation PROTO :XWORD
RtlQueryRegistryValues PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlQuerySecurityObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlQueryTagHeap PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlQueryTimeZoneInformation PROTO :XWORD
RtlQueueWorkItem PROTO :XWORD,:XWORD,:XWORD
RtlRaiseException PROTO :XWORD
RtlRaiseStatus PROTO :XWORD
RtlRandom PROTO :XWORD
RtlRandomEx PROTO :XWORD
RtlReadMemoryStream PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlReadOutOfProcessMemoryStream PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlReAllocateHeap PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlRealPredecessor PROTO :XWORD
RtlRealSuccessor PROTO :XWORD
RtlRegisterSecureMemoryCacheCallback PROTO :XWORD
RtlRegisterWait PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlReleaseActivationContext PROTO :XWORD
RtlReleaseMemoryStream PROTO :XWORD
RtlReleasePebLock PROTO
RtlReleasePrivilege PROTO :XPTR
RtlReleaseRelativeName PROTO :XPTR
RtlReleaseResource PROTO :XWORD
RtlRemoteCall PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlRemoveVectoredContinueHandler PROTO :XPTR
RtlRemoveVectoredExceptionHandler PROTO :XWORD
RtlResetRtlTranslations PROTO :XWORD
RtlRestoreContext PROTO :XPTR,:XPTR
RtlRestoreLastWin32Error PROTO :XWORD
RtlRevertMemoryStream PROTO :XWORD
RtlRunDecodeUnicodeString PROTO :XWORD,:XWORD
RtlRunEncodeUnicodeString PROTO :XWORD,:XWORD
RtlSecondsSince1970ToTime PROTO :XWORD,:XWORD
RtlSecondsSince1980ToTime PROTO :XWORD,:XWORD
RtlSeekMemoryStream PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlSelfRelativeToAbsoluteSD PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlSelfRelativeToAbsoluteSD2 PROTO :XWORD,:XWORD
RtlSetAllBits PROTO :XWORD
RtlSetAttributesSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD
RtlSetBits PROTO :XWORD,:XWORD,:XWORD
RtlSetControlSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD
RtlSetCriticalSectionSpinCount PROTO :XWORD,:XWORD
RtlSetCurrentDirectory_U PROTO :XWORD
RtlSetCurrentEnvironment PROTO :XWORD,:XWORD
RtlSetDaclSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlSetEnvironmentStrings PROTO ;XPTR,:XWORD
RtlSetEnvironmentVariable PROTO :XWORD,:XWORD,:XWORD
RtlSetGroupSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD
RtlSetHeapInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlSetInformationAcl PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlSetIoCompletionCallback PROTO :XWORD,:XWORD,:XWORD
RtlSetLastWin32Error PROTO :XWORD
RtlSetLastWin32ErrorAndNtStatusFromNtStatus PROTO :XWORD
RtlSetMemoryStreamSize PROTO :XWORD,:XWORD,:XWORD
RtlSetOwnerSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD
RtlSetProcessIsCritical PROTO :VARARG
RtlSetSaclSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlSetSecurityDescriptorRMControl PROTO :XWORD,:XWORD
RtlSetSecurityObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlSetSecurityObjectEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlSetThreadErrorMode PROTO :XWORD,:XPTR
RtlSetThreadIsCritical PROTO :VARARG
RtlSetThreadPoolStartFunc PROTO :XWORD,:XWORD
RtlSetTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlSetTimeZoneInformation PROTO :XWORD
RtlSetUnhandledExceptionFilter PROTO :XPTR
RtlSizeHeap PROTO :XWORD,:XWORD,:XWORD
RtlSplay PROTO :XWORD
RtlStartRXact PROTO :XWORD
RtlStatMemoryStream PROTO :XWORD,:XWORD,:XWORD
RtlStringFromGUID PROTO :XWORD,:XWORD
RtlSubAuthorityCountSid PROTO :XWORD
RtlSubAuthoritySid PROTO :XWORD,:XWORD
RtlSubtreePredecessor PROTO :XWORD
RtlSubtreeSuccessor PROTO :XWORD
RtlSystemTimeToLocalTime PROTO :XWORD,:XWORD
RtlTimeFieldsToTime PROTO :XWORD,:XWORD
RtlTimeToElapsedTimeFields PROTO :XWORD,:XWORD
RtlTimeToSecondsSince1970 PROTO :XWORD,:XWORD
RtlTimeToSecondsSince1980 PROTO :XWORD,:XWORD
RtlTimeToTimeFields PROTO :XWORD,:XWORD
RtlTraceDatabaseAdd PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlTraceDatabaseCreate PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlTraceDatabaseDestroy PROTO :XWORD
RtlTraceDatabaseEnumerate PROTO :XWORD,:XWORD,:XWORD
RtlTraceDatabaseFind PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlTraceDatabaseLock PROTO :XWORD
RtlTraceDatabaseUnlock PROTO :XWORD
RtlTraceDatabaseValidate PROTO :XWORD
RtlTryEnterCriticalSection PROTO :XWORD
RtlUnhandledExceptionFilter PROTO :XWORD
RtlUnhandledExceptionFilter2 PROTO :XWORD,:XWORD
RtlUnicodeStringToAnsiSize PROTO :XWORD
RtlUnicodeStringToAnsiString PROTO :XWORD,:XWORD,:XWORD
RtlUnicodeStringToCountedOemString PROTO :XWORD,:XWORD,:XWORD
RtlUnicodeStringToInteger PROTO :XWORD,:XWORD,:XWORD
RtlUnicodeStringToOemSize PROTO :XWORD
RtlUnicodeStringToOemString PROTO :XWORD,:XWORD,:XWORD
RtlUnicodeToCustomCPN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlUnicodeToMultiByteN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlUnicodeToMultiByteSize PROTO :XWORD,:XWORD,:XWORD
RtlUnicodeToOemN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlUniform PROTO :XWORD
RtlUnlockBootStatusData PROTO :XWORD
RtlUnlockHeap PROTO :XWORD
RtlUnlockMemoryStreamRegion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlUnwind PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlUnwindEx PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
RtlUpcaseUnicodeChar PROTO :XWORD
RtlUpcaseUnicodeString PROTO :XWORD,:XWORD,:XWORD
RtlUpcaseUnicodeStringToAnsiString PROTO :XWORD,:XWORD,:XWORD
RtlUpcaseUnicodeStringToCountedOemString PROTO :XWORD,:XWORD,:XWORD
RtlUpcaseUnicodeStringToOemString PROTO :XWORD,:XWORD,:XWORD
RtlUpcaseUnicodeToCustomCPN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlUpcaseUnicodeToMultiByteN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlUpcaseUnicodeToOemN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlUpdateTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlUpperChar PROTO :XWORD
RtlUpperString PROTO :XWORD,:XWORD
RtlValidAcl PROTO :XWORD
RtlValidateHeap PROTO :XWORD,:XWORD,:XWORD
RtlValidateProcessHeaps PROTO
RtlValidateUnicodeString PROTO :XWORD,:XWORD
RtlValidRelativeSecurityDescriptor PROTO :XWORD,:XWORD,:XWORD 
RtlValidSecurityDescriptor PROTO :XWORD
RtlValidSid PROTO :XWORD
RtlVerifyVersionInfo PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlVirtualUnwind PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
RtlWalkFrameChain PROTO :XWORD,:XWORD,:XWORD
RtlWalkHeap PROTO :XWORD,:XWORD
RtlWow64EnableFsRedirectionEx PROTO :XPTR,:XPTR
RtlWriteMemoryStream PROTO :XWORD,:XWORD,:XWORD,:XWORD
RtlWriteRegistryValue PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
RtlxAnsiStringToUnicodeSize PROTO :XWORD
RtlxOemStringToUnicodeSize PROTO :XWORD
RtlxUnicodeStringToAnsiSize PROTO :XWORD
RtlxUnicodeStringToOemSize PROTO :XWORD
RtlZeroHeap PROTO :XWORD,:XWORD
RtlZeroMemory PROTO :XWORD,:XWORD
RtlZombifyActivationContext PROTO :XWORD
sin PROTO :XWORD
sprintf PROTO :XWORD,:XWORD,:VARARG
sqrt PROTO :XWORD
sscanf PROTO :XWORD,:XWORD,:XWORD
strcat PROTO :XWORD,:XWORD
strchr PROTO :XWORD,:XWORD
strcmp PROTO :XWORD,:XWORD
strcpy PROTO :XWORD,:XWORD
strcspn PROTO :XWORD,:XWORD
strlen PROTO :XWORD
strncat PROTO :XWORD,:XWORD,:XWORD
strncmp PROTO :XWORD,:XWORD,:XWORD
strncpy PROTO :XWORD,:XWORD,:XWORD
strpbrk PROTO :XWORD,:XWORD
strrchr PROTO :XWORD,:XWORD
strspn PROTO :XWORD,:XWORD
strstr PROTO :XWORD,:XWORD
strtol PROTO :XWORD,:XWORD,:XWORD
strtoul PROTO :XWORD,:XWORD,:XWORD
swprintf PROTO :XWORD,:XWORD,:VARARG
tan PROTO :XWORD
tolower PROTO :XWORD
toupper PROTO :XWORD
towlower PROTO :XWORD
towupper PROTO :XWORD
vDbgPrintEx PROTO :XWORD,:XWORD,:XPTR,:VARARG
vDbgPrintExWithPrefix PROTO :XPTR,:XWORD,:XWORD,:XPTR,:VARARG
VerSetConditionMask PROTO :XWORD,:XWORD,:XWORD
vsprintf PROTO :XPTR,:XPTR,:VARARG
wcscat PROTO :XWORD,:XWORD
wcschr PROTO :XWORD,:XWORD
wcscmp PROTO :XWORD,:XWORD
wcscpy PROTO :XWORD,:XWORD
wcscspn PROTO :XWORD,:XWORD
wcslen PROTO :XWORD
wcsncat PROTO :XWORD,:XWORD,:XWORD
wcsncmp PROTO :XWORD,:XWORD,:XWORD
wcsncpy PROTO :XWORD,:XWORD,:XWORD
wcspbrk PROTO :XWORD,:XWORD
wcsrchr PROTO :XWORD,:XWORD
wcsspn PROTO :XWORD,:XWORD
wcsstr PROTO :XWORD,:XWORD
wcstol PROTO :XWORD,:XWORD,:XWORD
wcstombs PROTO :XPTR,:XPTR,:XPTR
wcstoul PROTO :XWORD,:XWORD,:XWORD
ZwAcceptConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAccessCheck PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAccessCheckAndAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAccessCheckByType PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAccessCheckByTypeAndAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAccessCheckByTypeResultList PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAccessCheckByTypeResultListAndAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAccessCheckByTypeResultListAndAuditAlarmByHandle PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAddAtom PROTO :XWORD,:XWORD,:XWORD
ZwAddBootEntry PROTO :XWORD,:XWORD
ZwAddDriverEntry PROTO :XPTR,:XPTR
ZwAdjustGroupsToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAdjustPrivilegesToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAlertResumeThread PROTO :XWORD,:XWORD
ZwAlertThread PROTO :XWORD
ZwAllocateLocallyUniqueId PROTO :XWORD
ZwAllocateUserPhysicalPages PROTO :XWORD,:XWORD,:XWORD
ZwAllocateUuids PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwAllocateVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwAreMappedFilesTheSame PROTO :XWORD,:XWORD
ZwAssignProcessToJobObject PROTO :XWORD,:XWORD
ZwCallbackReturn PROTO :XWORD,:XWORD,:XWORD
ZwCancelIoFile PROTO :XWORD,:XWORD
ZwCancelTimer PROTO :XWORD,:XWORD
ZwClearEvent PROTO :XWORD
ZwClose PROTO :XWORD
ZwCloseObjectAuditAlarm PROTO :XWORD,:XWORD,:XWORD
ZwCompactKeys PROTO :XWORD,:XWORD
ZwCompareTokens PROTO :XWORD,:XWORD,:XWORD
ZwCompleteConnectPort PROTO :XWORD
ZwCompressKey PROTO :XWORD
ZwConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwContinue PROTO :XWORD,:XWORD
ZwCreateDebugObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwCreateDirectoryObject PROTO :XWORD,:XWORD,:XWORD
ZwCreateEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateEventPair PROTO :XWORD,:XWORD,:XWORD
ZwCreateFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwCreateJobObject PROTO :XWORD,:XWORD,:XWORD
ZwCreateJobSet PROTO :XWORD,:XWORD,:XWORD
ZwCreateKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateKeyedEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwCreateMailslotFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateMutant PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwCreateNamedPipeFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreatePagingFile PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwCreatePort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateProcessEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateProfile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateSection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateSemaphore PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateSymbolicLinkObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwCreateThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwCreateToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwCreateWaitablePort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwDebugActiveProcess PROTO :XWORD,:XWORD
ZwDebugContinue PROTO :XWORD,:XWORD,:XWORD
ZwDelayExecution PROTO :XWORD,:XWORD
ZwDeleteAtom PROTO :XWORD
ZwDeleteBootEntry PROTO :XWORD
ZwDeleteDriverEntry PROTO :XWORD
ZwDeleteFile PROTO :XWORD
ZwDeleteKey PROTO :XWORD
ZwDeleteObjectAuditAlarm PROTO :XWORD,:XWORD,:XWORD
ZwDeleteValueKey PROTO :XWORD,:XWORD
ZwDeviceIoControlFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwDisplayString PROTO :XWORD
ZwDuplicateObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwDuplicateToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwEnumerateBootEntries PROTO :XWORD,:XWORD
ZwEnumerateDriverEntries PROTO :XPTR,:XPTR
ZwEnumerateKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwEnumerateSystemEnvironmentValuesEx PROTO :XWORD,:XWORD,:XWORD
ZwEnumerateValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwExtendSection PROTO :XWORD,:XWORD
ZwFilterToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwFindAtom PROTO :XWORD,:XWORD,:XWORD
ZwFlushBuffersFile PROTO :XWORD,:XWORD
ZwFlushInstructionCache PROTO :XWORD,:XWORD,:XWORD
ZwFlushKey PROTO :XWORD
ZwFlushVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwFlushWriteBuffer PROTO
ZwFreeUserPhysicalPages PROTO :XWORD,:XWORD,:XWORD
ZwFreeVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwFsControlFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwGetCurrentProcessorNumber PROTO
ZwGetContextThread PROTO :XWORD,:XWORD
ZwGetDevicePowerState PROTO :XWORD,:XWORD
ZwGetWriteWatch PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwImpersonateAnonymousToken PROTO :XWORD
ZwImpersonateClientOfPort PROTO :XWORD,:XWORD
ZwImpersonateThread PROTO :XWORD,:XWORD,:XWORD
ZwInitializeRegistry PROTO :XWORD
ZwInitiatePowerAction PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwIsProcessInJob PROTO :XWORD,:XWORD
ZwIsSystemResumeAutomatic PROTO
ZwListenPort PROTO :XWORD,:XWORD
ZwLoadDriver PROTO :XWORD
ZwLoadKey PROTO :XWORD,:XWORD
ZwLoadKey2 PROTO :XWORD,:XWORD,:XWORD
ZwLoadKeyEx PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR
ZwLockFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwLockProductActivationKeys PROTO :XWORD,:XWORD
ZwLockRegistryKey PROTO :XWORD
ZwLockVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwMakePermanentObject PROTO :XWORD
ZwMakeTemporaryObject PROTO :XWORD
ZwMapUserPhysicalPages PROTO :XWORD,:XWORD,:XWORD
ZwMapUserPhysicalPagesScatter PROTO :XWORD,:XWORD,:XWORD
ZwMapViewOfSection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwModifyBootEntry PROTO :XWORD
ZwModifyDriverEntry PROTO :XPTR
ZwNotifyChangeDirectoryFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwNotifyChangeKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwNotifyChangeMultipleKeys PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwOpenDirectoryObject PROTO :XWORD,:XWORD,:XWORD
ZwOpenEvent PROTO :XWORD,:XWORD,:XWORD
ZwOpenEventPair PROTO :XWORD,:XWORD,:XWORD
ZwOpenFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwOpenIoCompletion PROTO :XWORD,:XWORD,:XWORD
ZwOpenJobObject PROTO :XWORD,:XWORD,:XWORD
ZwOpenKey PROTO :XWORD,:XWORD,:XWORD
ZwOpenKeyedEvent PROTO :XWORD,:XWORD,:XWORD
ZwOpenMutant PROTO :XWORD,:XWORD,:XWORD
ZwOpenObjectAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwOpenProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwOpenProcessToken PROTO :XWORD,:XWORD,:XWORD
ZwOpenProcessTokenEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwOpenSection PROTO :XWORD,:XWORD,:XWORD
ZwOpenSemaphore PROTO :XWORD,:XWORD,:XWORD
ZwOpenSymbolicLinkObject PROTO :XWORD,:XWORD,:XWORD
ZwOpenThread PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwOpenThreadToken PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwOpenThreadTokenEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwOpenTimer PROTO :XWORD,:XWORD,:XWORD
ZwPlugPlayControl PROTO :XWORD,:XWORD,:XWORD
ZwPowerInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwPrivilegeCheck PROTO :XWORD,:XWORD,:XWORD
ZwPrivilegedServiceAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwPrivilegeObjectAuditAlarm PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwProtectVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwPulseEvent PROTO :XWORD,:XWORD
ZwQueryAttributesFile PROTO :XWORD,:XWORD
ZwQueryBootEntryOrder PROTO :XWORD,:XWORD
ZwQueryBootOptions PROTO :XWORD,:XWORD
ZwQueryDebugFilterState PROTO :XWORD,:XWORD
ZwQueryDefaultLocale PROTO :XWORD,:XWORD
ZwQueryDefaultUILanguage PROTO :XWORD
ZwQueryDirectoryFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryDirectoryObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryDriverEntryOrder PROTO :XPTR,:XPTR
ZwQueryEaFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryFullAttributesFile PROTO :XWORD,:XWORD
ZwQueryInformationAtom PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryInformationJobObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryInformationPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryInformationProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryInformationThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryInformationToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryInstallUILanguage PROTO :XWORD
ZwQueryIntervalProfile PROTO :XWORD,:XWORD
ZwQueryIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryMultipleValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryMutant PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryOpenSubKeys PROTO :XWORD,:XWORD
ZwQueryOpenSubKeysEx PROTO :XPTR,:XWORD,:XPTR,:XPTR
ZwQueryPerformanceCounter PROTO :XWORD,:XWORD
ZwQueryPortInformationProcess PROTO
ZwQueryQuotaInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQuerySection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQuerySecurityObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQuerySemaphore PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQuerySymbolicLinkObject PROTO :XWORD,:XWORD,:XWORD
ZwQuerySystemEnvironmentValue PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwQuerySystemEnvironmentValueEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQuerySystemInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwQuerySystemTime PROTO :XWORD
ZwQueryTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryTimerResolution PROTO :XWORD,:XWORD,:XWORD
ZwQueryValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueryVolumeInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwQueueApcThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwRaiseException PROTO :XWORD,:XWORD,:XWORD
ZwRaiseHardError PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwReadFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwReadFileScatter PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwReadRequestData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwReadVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwRegisterThreadTerminatePort PROTO :XWORD
ZwReleaseKeyedEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwReleaseMutant PROTO :XWORD,:XWORD
ZwReleaseSemaphore PROTO :XWORD,:XWORD,:XWORD
ZwRemoveIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwRemoveProcessDebug PROTO :XWORD,:XWORD
ZwRenameKey PROTO :XWORD,:XWORD
ZwReplaceKey PROTO :XWORD,:XWORD,:XWORD
ZwReplyPort PROTO :XWORD,:XWORD
ZwReplyWaitReceivePort PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwReplyWaitReceivePortEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwReplyWaitReplyPort PROTO :XWORD,:XWORD
ZwRequestPort PROTO :XWORD,:XWORD
ZwRequestWaitReplyPort PROTO :XWORD,:XWORD,:XWORD
ZwResetEvent PROTO :XWORD,:XWORD
ZwResetWriteWatch PROTO :XWORD,:XWORD,:XWORD
ZwRestoreKey PROTO :XWORD,:XWORD,:XWORD
ZwResumeProcess PROTO :XWORD
ZwResumeThread PROTO :XWORD,:XWORD
ZwSaveKey PROTO :XWORD,:XWORD
ZwSaveKeyEx PROTO :XWORD,:XWORD,:XWORD
ZwSaveMergedKeys PROTO :XWORD,:XWORD,:XWORD
ZwSecureConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwSetBootEntryOrder PROTO :XWORD,:XWORD
ZwSetBootOptions PROTO :XWORD,:XWORD
ZwSetContextThread PROTO :XWORD,:XWORD
ZwSetDebugFilterState PROTO :XWORD,:XWORD,:XWORD
ZwSetDefaultHardErrorPort PROTO :XWORD
ZwSetDefaultLocale PROTO :XWORD,:XWORD
ZwSetDefaultUILanguage PROTO :XWORD
ZwSetDriverEntryOrder PROTO :XPTR,:XWORD
ZwSetEaFile PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwSetEvent PROTO :XWORD,:XWORD
ZwSetEventBoostPriority PROTO :XWORD
ZwSetHighEventPair PROTO :XWORD
ZwSetHighWaitLowEventPair PROTO :XWORD
ZwSetInformationDebugObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwSetInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwSetInformationJobObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwSetInformationKey PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwSetInformationObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwSetInformationProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwSetInformationThread PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwSetInformationToken PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwSetIntervalProfile PROTO :XWORD,:XWORD
ZwSetIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwSetLdtEntries PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwSetLowEventPair PROTO :XWORD
ZwSetLowWaitHighEventPair PROTO :XWORD
ZwSetQuotaInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwSetSecurityObject PROTO :XWORD,:XWORD,:XWORD
ZwSetSystemEnvironmentValue PROTO :XWORD,:XWORD
ZwSetSystemEnvironmentValueEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwSetSystemInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwSetSystemPowerState PROTO :XWORD,:XWORD,:XWORD
ZwSetSystemTime PROTO :XWORD,:XWORD
ZwSetThreadExecutionState PROTO :XWORD,:XWORD
ZwSetTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwSetTimerResolution PROTO :XWORD,:XWORD,:XWORD
ZwSetUuidSeed PROTO :XWORD
ZwSetValueKey PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwSetVolumeInformationFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwShutdownSystem PROTO :XWORD
ZwSignalAndWaitForSingleObject PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwStartProfile PROTO :XWORD
ZwStopProfile PROTO :XWORD
ZwSuspendProcess PROTO :XWORD
ZwSuspendThread PROTO :XWORD,:XWORD
ZwSystemDebugControl PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwTerminateJobObject PROTO :XWORD,:XWORD
ZwTerminateProcess PROTO :XWORD,:XWORD
ZwTerminateThread PROTO :XWORD,:XWORD
ZwTestAlert PROTO
ZwTraceEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwTranslateFilePath PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwUnloadDriver PROTO :XWORD
ZwUnloadKey PROTO :XWORD
ZwUnloadKey2 PROTO :XPTR,:XWORD
ZwUnloadKeyEx PROTO :XWORD,:XWORD
ZwUnlockFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwUnlockVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwUnmapViewOfSection PROTO :XWORD,:XWORD
ZwVdmControl PROTO :XWORD,:XWORD
ZwWaitForDebugEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwWaitForKeyedEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
ZwWaitForMultipleObjects PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwWaitForMultipleObjects32 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR
ZwWaitForSingleObject PROTO :XWORD,:XWORD,:XWORD
ZwWaitHighEventPair PROTO :XWORD
ZwWaitLowEventPair PROTO :XWORD
ZwWriteFile PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwWriteFileGather PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwWriteRequestData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwWriteVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
ZwYieldExecution PROTO
IF (NTDDI_VERSION GE NTDDI_VISTA)
    A_SHAFinal PROTO :XPTR,:XWORD
    A_SHAInit PROTO :XPTR
    A_SHAUpdate PROTO :XPTR,:XPTR,:XWORD
    AlpcAdjustCompletionListConcurrencyCount PROTO :XWORD,:XWORD
    AlpcFreeCompletionListMessage PROTO :XPTR,:XPTR
    AlpcGetCompletionListLastMessageInformation PROTO :XPTR,:XPTR,:XPTR
    AlpcGetCompletionListMessageAttributes PROTO :XPTR,:XPTR
    AlpcGetHeaderSize PROTO :XWORD
    AlpcGetMessageAttribute PROTO :XPTR,:XWORD
    AlpcGetMessageFromCompletionList PROTO :XPTR,:XPTR
    AlpcGetOutstandingCompletionListMessageCount PROTO :XPTR
    AlpcInitializeMessageAttribute PROTO :XWORD,:XPTR,:XWORD
    AlpcMaxAllowedMessageLength PROTO
    AlpcRegisterCompletionList PROTO :XWORD,:XPTR,:XWORD,:XWORD,:XWORD
    AlpcRegisterCompletionListWorkerThread PROTO :XPTR
    AlpcRundownCompletionList PROTO :XWORD
    AlpcUnregisterCompletionList PROTO :XWORD
    AlpcUnregisterCompletionListWorkerThread PROTO :XWORD
    CsrVerifyRegion PROTO :XWORD,:XWORD
    EtwDeliverDataBlock PROTO :XWORD
    EtwEnumerateProcessRegGuids PROTO :XWORD,:XWORD,:XWORD
    EtwEventActivityIdControl PROTO :XWORD,:XWORD
    EtwEventEnabled PROTO :XWORD,:XPTR
    EtwEventProviderEnabled PROTO :XWORD,:XWORD,:XWORD
    EtwEventRegister PROTO :XPTR,:XPTR,:XPTR,:XPTR
    EtwEventUnregister PROTO :XWORD
    EtwEventWrite PROTO :XWORD,:XPTR,:XPTR,:XWORD,:XPTR
    EtwEventWriteEndScenario PROTO :XWORD,:XPTR,:XWORD,:XPTR
    EtwEventWriteFull PROTO :XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD,:XPTR
    EtwEventWriteStartScenario PROTO :XWORD,:XPTR,:XWORD,:XPTR
    EtwEventWriteString PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR
    EtwEventWriteTransfer PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR
    EtwLogTraceEvent PROTO :XOWRD,:XOWRD,:XOWRD
    EtwNotificationRegister PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD
    EtwNotificationUnregister PROTO :XOWRD,:XOWRD,:XOWRD
    EtwProcessPrivateLoggerRequest PROTO :XWORD
    EtwRegisterSecurityProvider PROTO
    EtwReplyNotification PROTO :XWORD
    EtwSendNotification PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD,:XOWRD
    EtwSetMark PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD
    EtwTraceEventInstance PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD,:XOWRD
    EtwWriteUMSecurityEvent PROTO :XPTR,:XOWRD,:XOWRD,:XPTR
    EtwpCreateEtwThread PROTO :XWORD,:XWORD
    EtwpGetCpuSpeed PROTO :XWORD,:XWORD
    LdrAddLoadAsDataTable PROTO :XOWRD,:XOWRD,:XOWRD,:XOWRD,:XOWRD
    LdrGetFailureData PROTO
    LdrGetFileNameFromLoadAsDataTable PROTO :XWORD,:XWORD
    LdrGetProcedureAddressEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrLoadAlternateResourceModuleEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrQueryModuleServiceTags PROTO :XWORD,:XWORD,:XWORD
    LdrRegisterDllNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrRemoveLoadAsDataTable PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrResFindResource PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrResFindResourceDirectory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrResRelease PROTO :XWORD,:XWORD,:XWORD
    LdrResSearchResource PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrSetMUICacheType PROTO :XWORD
    LdrUnloadAlternateResourceModuleEx PROTO :XWORD,:XWORD
    LdrUnregisterDllNotification PROTO :XWORD
    LdrVerifyImageMatchesChecksumEx PROTO :XWORD,:XWORD
    LdrpResGetMappingSize PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrpResGetResourceDirectory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    MD4Final PROTO :XWORD
    MD4Init PROTO :XWORD
    MD4Update PROTO :XWORD,:XWORD,:XWORD
    MD5Final PROTO :XWORD
    MD5Init PROTO :XWORD
    MD5Update PROTO :XWORD,:XWORD,:XWORD
    NtAlpcAcceptConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcCancelMessage PROTO :XWORD,:XWORD,:XWORD
    NtAlpcConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,,:XWORD
    NtAlpcCreatePort PROTO :XWORD,:XWORD,:XWORD
    NtAlpcCreatePortSection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcCreateResourceReserve PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcCreateSectionView PROTO :XWORD,:XWORD,:XWORD
    NtAlpcCreateSecurityContext PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDeletePortSection PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDeleteResourceReserve PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDeleteSectionView PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDeleteSecurityContext PROTO :XWORD,:XWORD,:XWORD
    NtAlpcDisconnectPort PROTO :XWORD,:XWORD
    NtAlpcImpersonateClientOfPort PROTO :XWORD,:XWORD,:XWORD
    NtAlpcOpenSenderProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcOpenSenderThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcQueryInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcQueryInformationMessage PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcRevokeSecurityContext PROTO :XWORD,:XWORD,:XWORD
    NtAlpcSendWaitReceivePort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcSetInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCancelIoFileEx PROTO :XWORD,:XWORD,:XWORD
    NtCancelSynchronousIoFile PROTO :XWORD,:XWORD,:XWORD
    NtCommitComplete PROTO :XWORD,:XWORD
    NtCommitEnlistment PROTO :XWORD,:XWORD
    NtCommitTransaction PROTO :XWORD,:XWORD
    NtCreateEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateKeyTransacted PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreatePrivateNamespace PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCreateResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateThreadEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateUserProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtDeletePrivateNamespace PROTO :XWORD
    NtEnumerateTransactionObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtFlushInstallUILanguage PROTO :XWORD,:XWORD
    NtFlushProcessWriteBuffers PROTO
    NtFreezeRegistry PROTO :XWORD
    NtFreezeTransactions PROTO :XWORD,:XWORD
    NtGetMUIRegistryInfo PROTO :XWORD,:XWORD,:XWORD
    NtGetNextProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtGetNextThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtGetNlsSectionPtr PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtGetNotificationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtInitializeNlsFiles PROTO :XWORD,:XWORD,:XWORD
    NtIsUILanguageComitted PROTO
    NtMapCMFModule PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenKeyTransacted PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtOpenPrivateNamespace PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtOpenResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenSession PROTO :XWORD,:XWORD,:XWORD
    NtOpenTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtPrePrepareComplete PROTO :XWORD,:XWORD
    NtPrePrepareEnlistment PROTO :XWORD,:XWORD
    NtPrepareComplete PROTO :XWORD,:XWORD
    NtPrepareEnlistment PROTO :XWORD,:XWORD
    NtPropagationComplete PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtPropagationFailed PROTO :XWORD,:XWORD,:XWORD
    NtQueryInformationEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryLicenseValue PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtReadOnlyEnlistment PROTO :XWORD,:XWORD
    NtRecoverEnlistment PROTO :XWORD,:XWORD
    NtRecoverResourceManager PROTO :XWORD
    NtRecoverTransactionManager PROTO :XWORD
    NtRegisterProtocolAddressInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtReleaseWorkerFactoryWorker PROTO :XWORD
    NtRemoveIoCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtRenameTransactionManager PROTO :XWORD,:XWORD
    NtReplacePartitionUnit PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtRollbackComplete PROTO :XWORD,:XWORD
    NtRollbackEnlistment PROTO :XWORD,:XWORD
    NtRollbackTransaction PROTO :XWORD,:XWORD
    NtRollforwardTransactionManager PROTO :XWORD,:XWORD
    NtSetInformationEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtShutdownWorkerFactory PROTO :XWORD,:XWORD
    NtSinglePhaseReject PROTO :XWORD,:XWORD
    NtThawRegistry PROTO
    NtThawTransactions PROTO
    NtTraceControl PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtWaitForWorkViaWorkerFactory PROTO :XWORD,:XWORD
    NtWorkerFactoryWorkerReady PROTO :XWORD
    NtdllDefWindowProc_A PROTO
    NtdllDefWindowProc_W PROTO
    NtdllDialogWndProc_A PROTO
    NtdllDialogWndProc_W PROTO
    RtlAcquireSRWLockExclusive PROTO :XWORD
    RtlAcquireSRWLockShared PROTO :XWORD
    RtlAddMandatoryAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAddSIDToBoundaryDescriptor PROTO :XWORD,:XWORD
    RtlAllocateMemoryBlockLookaside PROTO :XWORD,:XWORD,:XWORD
    RtlAllocateMemoryZone PROTO :XWORD,:XWORD,:XWORD
    RtlBarrier PROTO :XWORD,:XWORD
    RtlBarrierForDelete PROTO :XWORD,:XWORD
    RtlCleanUpTEBLangLists PROTO
    RtlCloneUserProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCmDecodeMemIoResource PROTO :XWORD,:XWORD
    RtlCmEncodeMemIoResource PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCommitDebugInfo PROTO :XWORD,:XWORD
    RtlCompareAltitudes PROTO :XWORD
    RtlCompareUnicodeStrings PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlConnectToSm PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlConvertLCIDToString PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCreateBoundaryDescriptor PROTO :XWORD,:XWORD
    RtlCreateEnvironmentEx PROTO :XWORD,:XWORD,:XWORD
    RtlCreateMemoryBlockLookaside PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCreateMemoryZone PROTO :XWORD,:XWORD,:XWORD
    RtlCreateProcessParametersEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCreateUserStack PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCultureNameToLCID PROTO :XWORD,:XWORD
    RtlDeCommitDebugInfo PROTO :XWORD,:XWORD,:XWORD
    RtlDeleteBarrier PROTO :XWORD
    RtlDeleteBoundaryDescriptor PROTO :XWORD
    RtlDeregisterSecureMemoryCacheCallback PROTO :XWORD
    RtlDestroyMemoryBlockLookaside PROTO :XWORD
    RtlDestroyMemoryZone PROTO :XWORD
    RtlExitUserProcess PROTO :XWORD
    RtlExpandEnvironmentStrings PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlExtendMemoryBlockLookaside PROTO :XWORD,:XWORD
    RtlExtendMemoryZone PROTO :XWORD,:XWORD
    RtlFindAceByType PROTO :XWORD,:XWORD,:XWORD
    RtlFindClosestEncodableLength PROTO :XWORD,:XWORD,:XWORD
    RtlFlsAlloc PROTO :XWORD,:XWORD
    RtlFlsFree PROTO :XWORD
    RtlFreeMemoryBlockLookaside PROTO :XWORD,:XWORD
    RtlFreeUserStack PROTO :XWORD
    RtlGetCurrentTransaction PROTO
    RtlGetFileMUIPath PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetIntegerAtom PROTO :XWORD,:XWORD
    RtlGetParentLocaleName PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetProductInfo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetSystemPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetThreadLangIdByIndex PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetThreadPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetUILanguageInfo PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetUnloadEventTraceEx PROTO :XWORD,:XWORD,:XWORD
    RtlGetUserPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlHeapTrkInitialize PROTO :XWORD
    RtlIdnToAscii PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlIdnToNameprepUnicode PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlIdnToUnicode PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlImpersonateSelfEx PROTO :XWORD,:XWORD,:XWORD
    RtlInitBarrier PROTO :XWORD,:XWORD,:XWORD
    RtlInitializeConditionVariable PROTO :XWORD
    RtlInitializeCriticalSectionEx PROTO :XWORD,:XWORD,:XWORD
    RtlInitializeNtUserPfn PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlInitializeSRWLock PROTO :XWORD
    RtlIoDecodeMemIoResource PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlIoEncodeMemIoResource PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlIsCurrentThreadAttachExempt PROTO
    RtlIsNormalizedString PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlIsValidLocaleName PROTO :XWORD,:XWORD
    RtlLCIDToCultureName PROTO :XWORD,:XWORD
    RtlLcidToLocaleName PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlLocaleNameToLcid PROTO :XWORD,:XWORD,:XWORD
    RtlLockCurrentThread PROTO
    RtlLockMemoryBlockLookaside PROTO :XWORD
    RtlLockMemoryZone PROTO :XWORD
    RtlLockModuleSection PROTO :XWORD
    RtlNormalizeString PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlNumberOfSetBitsUlongPtr PROTO :XWORD
    RtlOwnerAcesPresent PROTO :XWORD
    RtlProcessFlsData PROTO :XWORD
    RtlQueryActivationContextApplicationSettings PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryDynamicTimeZoneInformation PROTO :XWORD
    RtlQueryElevationFlags PROTO :XWORD
    RtlQueryEnvironmentVariable PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryModuleInformation PROTO :XWORD,:XWORD,:XWORD
    RtlRegisterThreadWithCsrss PROTO
    RtlReleaseSRWLockExclusive PROTO :XWORD
    RtlReleaseSRWLockShared PROTO :XWORD
    RtlRemovePrivileges PROTO :XWORD,:XWORD,:XWORD
    RtlReportException PROTO :XWORD,:XWORD,:XWORD
    RtlResetMemoryBlockLookaside PROTO :XWORD
    RtlResetMemoryZone PROTO :XWORD
    RtlRetrieveNtUserPfn PROTO :XWORD,:XWORD,:XWORD
    RtlRunOnceBeginInitialize PROTO :XWORD,:XWORD,:XWORD
    RtlRunOnceComplete PROTO :XWORD,:XWORD,:XWORD
    RtlRunOnceExecuteOnce PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlRunOnceInitialize PROTO :XWORD
    RtlSendMsgToSm PROTO :XWORD,:XWORD
    RtlSetCurrentTransaction PROTO :XWORD
    RtlSetDynamicTimeZoneInformation PROTO :XWORD
    RtlSetEnvironmentVar PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlSetProcessDebugInformation PROTO :XWORD,:XWORD,:XWORD
    RtlSetThreadPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD
    RtlSetUserFlagsHeap PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlSetUserValueHeap PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlSidDominates PROTO :XWORD,:XWORD,:XWORD
    RtlSidEqualLevel PROTO :XWORD,:XWORD,:XWORD
    RtlSidHashInitialize PROTO :XWORD,:XWORD,:XWORD
    RtlSidHashLookup PROTO XWORD,:XWORD
    RtlSidIsHigherLevel PROTO :XWORD,:XWORD,:XWORD
    RtlSleepConditionVariableCS PROTO :XWORD,:XWORD,:XWORD
    RtlSleepConditionVariableSRW PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlTestBit PROTO :XWORD,:XWORD
    RtlTryAcquirePebLock PROTO
    RtlUnlockCurrentThread PROTO
    RtlUnlockMemoryBlockLookaside PROTO :XWORD
    RtlUnlockMemoryZone PROTO :XWORD
    RtlUnlockModuleSection PROTO :XWORD
    RtlUpdateClonedCriticalSection PROTO :XWORD
    RtlUpdateClonedSRWLock PROTO :XWORD,:XWORD
    RtlUserThreadStart PROTO :XWORD,:XWORD
    RtlWakeAllConditionVariable PROTO :XWORD
    RtlWakeConditionVariable PROTO :XWORD
    RtlWerpReportException PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlWow64CallFunction64 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlWow64EnableFsRedirection PROTO :XWORD
    RtlpCheckDynamicTimeZoneInformation PROTO :XWORD,:XWORD
    RtlpCleanupRegistryKeys PROTO
    RtlpConvertCultureNamesToLCIDs PROTO :XWORD,:XWORD
    RtlpConvertLCIDsToCultureNames PROTO :XWORD,:XWORD
    RtlpCreateProcessRegistryInfo PROTO :XWORD
    RtlpGetLCIDFromLangInfoNode PROTO :XWORD,:XWORD,:XWORD
    RtlpGetNameFromLangInfoNode PROTO :XWORD,:XWORD,:XWORD
    RtlpGetSystemDefaultUILanguage PROTO :XWORD,:XWORD
    RtlpGetUserOrMachineUILanguage4NLS PROTO :XWORD,:XWORD,:XWORD
    RtlpInitializeLangRegistryInfo PROTO :XWORD
    RtlpIsQualifiedLanguage PROTO :XWORD,:XWORD,:XWORD
    RtlpLoadMachineUIByPolicy PROTO :XWORD,:XWORD,:XWORD
    RtlpLoadUserUIByPolicy PROTO :XWORD,:XWORD,:XWORD
    RtlpMuiFreeLangRegistryInfo PROTO :XWORD
    RtlpMuiRegCreateRegistryInfo PROTO
    RtlpMuiRegFreeRegistryInfo PROTO :XWORD,:XWORD
    RtlpMuiRegLoadRegistryInfo PROTO :XWORD,:XWORD
    RtlpQueryDefaultUILanguage PROTO :XWORD,:XWORD
    RtlpRefreshCachedUILanguage PROTO :XWORD,:XWORD
    RtlpSetInstallLanguage PROTO :XWORD,:XWORD
    RtlpSetPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD
    RtlpSetUserPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD
    RtlpVerifyAndCommitUILanguageSettings PROTO :XWORD
    ShipAssert PROTO :XWORD,:XWORD
    ShipAssertGetBufferInfo PROTO :XWORD,:XWORD
    ShipAssertMsgA PROTO :XWORD,:XWORD,:XWORD
    ShipAssertMsgW PROTO :XWORD,:XWORD,:XWORD
    TpAllocAlpcCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    TpAllocCleanupGroup PROTO :XWORD
    TpAllocIoCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    TpAllocPool PROTO :XWORD,:XWORD
    TpAllocTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpAllocWait PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpAllocWork PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpCallbackLeaveCriticalSectionOnCompletion PROTO :XWORD,:XWORD
    TpCallbackMayRunLong PROTO :XWORD
    TpCallbackReleaseMutexOnCompletion PROTO :XWORD,:XWORD
    TpCallbackReleaseSemaphoreOnCompletion PROTO :XWORD,:XWORD,:XWORD
    TpCallbackSetEventOnCompletion PROTO :XWORD,:XWORD
    TpCallbackUnloadDllOnCompletion PROTO :XWORD,:XWORD
    TpCancelAsyncIoOperation PROTO :XWORD
    TpCaptureCaller PROTO :XWORD
    TpCheckTerminateWorker PROTO :XWORD
    TpDbgDumpHeapUsage PROTO :XWORD,:XWORD,:XWORD
    TpDbgSetLogRoutine PROTO :XWORD
    TpDisassociateCallback PROTO :XWORD
    TpIsTimerSet PROTO :XWORD
    TpPostWork PROTO :XWORD
    TpReleaseAlpcCompletion PROTO :XWORD
    TpReleaseCleanupGroup PROTO :XWORD
    TpReleaseCleanupGroupMembers PROTO :XWORD,:XWORD,:XWORD
    TpReleaseIoCompletion PROTO :XWORD
    TpReleasePool PROTO :XWORD
    TpReleaseTimer PROTO :XWORD
    TpReleaseWait PROTO :XWORD
    TpReleaseWork PROTO :XWORD
    TpSetPoolMaxThreads PROTO :XWORD,:XWORD
    TpSetPoolMinThreads PROTO :XWORD,:XWORD
    TpSetTimer PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpSetWait PROTO :XWORD,:XWORD,:XWORD
    TpSimpleTryPost PROTO :XWORD,:XWORD,:XWORD
    TpStartAsyncIoOperation PROTO :XWORD
    TpWaitForAlpcCompletion PROTO :XWORD
    TpWaitForIoCompletion PROTO :XWORD,:XWORD
    TpWaitForTimer PROTO :XWORD,:XWORD
    TpWaitForWait PROTO :XWORD,:XWORD
    TpWaitForWork PROTO :XWORD,:XWORD
    WerReportSQMEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmAddToStream PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmEndSession PROTO :XWORD
    WinSqmEventEnabled PROTO :XWORD,:XWORD
    WinSqmEventWrite PROTO :XWORD,:XWORD,:XWORD
    WinSqmIsOptedIn PROTO
    WinSqmSetString PROTO :XWORD,:XWORD,:XWORD
    WinSqmStartSession PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcAcceptConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcCancelMessage PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcConnectPort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcCreatePort PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcCreatePortSection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcCreateResourceReserve PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcCreateSectionView PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcCreateSecurityContext PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDeletePortSection PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDeleteResourceReserve PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDeleteSectionView PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDeleteSecurityContext PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcDisconnectPort PROTO :XWORD,:XWORD
    ZwAlpcImpersonateClientOfPort PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcOpenSenderProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcOpenSenderThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcQueryInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcQueryInformationMessage PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcRevokeSecurityContext PROTO :XWORD,:XWORD,:XWORD
    ZwAlpcSendWaitReceivePort PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcSetInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCancelIoFileEx PROTO :XWORD,:XWORD,:XWORD
    ZwCancelSynchronousIoFile PROTO :XWORD,:XWORD,:XWORD
    ZwCommitComplete PROTO :XWORD,:XWORD
    ZwCommitEnlistment PROTO :XWORD,:XWORD
    ZwCommitTransaction PROTO :XWORD,:XWORD
    ZwCreateEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateKeyTransacted PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreatePrivateNamespace PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateThreadEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateUserProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwDeletePrivateNamespace PROTO :XWORD
    ZwEnumerateTransactionObject PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwFlushInstallUILanguage PROTO :XWORD,:XWORD
    ZwFlushProcessWriteBuffers PROTO
    ZwFreezeRegistry PROTO :XWORD
    ZwFreezeTransactions PROTO :XWORD,:XWORD
    ZwGetMUIRegistryInfo PROTO :XWORD,:XWORD,:XWORD
    ZwGetNextProcess PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwGetNextThread PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwGetNlsSectionPtr PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwGetNotificationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwInitializeNlsFiles PROTO :XWORD,:XWORD,:XWORD
    ZwIsUILanguageComitted PROTO
    ZwMapCMFModule PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenKeyTransacted PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenPrivateNamespace PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenSession PROTO :XWORD,:XWORD,:XWORD
    ZwOpenTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwPrePrepareComplete PROTO :XWORD,:XWORD
    ZwPrePrepareEnlistment PROTO :XWORD,:XWORD
    ZwPrepareComplete PROTO :XWORD,:XWORD
    ZwPrepareEnlistment PROTO :XWORD,:XWORD
    ZwPropagationComplete PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwPropagationFailed PROTO :XWORD,:XWORD,:XWORD
    ZwQueryInformationEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryInformationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryInformationTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryInformationTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryInformationWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueryLicenseValue PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwReadOnlyEnlistment PROTO :XWORD,:XWORD
    ZwRecoverEnlistment PROTO :XWORD,:XWORD
    ZwRecoverResourceManager PROTO :XWORD
    ZwRecoverTransactionManager PROTO :XWORD
    ZwRegisterProtocolAddressInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwReleaseWorkerFactoryWorker PROTO :XWORD
    ZwRemoveIoCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwRenameTransactionManager PROTO :XWORD,:XWORD
    ZwReplacePartitionUnit PROTO :XWORD,:XWORD,:XWORD
    ZwRollbackComplete PROTO :XWORD,:XWORD
    ZwRollbackEnlistment PROTO :XWORD,:XWORD
    ZwRollbackTransaction PROTO :XWORD,:XWORD
    ZwRollforwardTransactionManager PROTO :XWORD,:XWORD
    ZwSetInformationEnlistment PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationResourceManager PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationTransactionManager PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationWorkerFactory PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwShutdownWorkerFactory PROTO :XWORD,:XWORD
    ZwSinglePhaseReject PROTO :XWORD,:XWORD
    ZwThawRegistry PROTO
    ZwThawTransactions PROTO
    ZwTraceControl PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwWaitForWorkViaWorkerFactory PROTO :XWORD,:XWORD
    ZwWorkerFactoryWorkerReady PROTO :XWORD
    _swprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
    _vswprintf PROTO :XPTR,:XPTR,:XPTR,:VARARG
  
	NtdllDefWindowProcA EQU <NtdllDefWindowProc_A>
	NtdllDialogWndProcA EQU <NtdllDialogWndProc_A>
	NtdllDefWindowProcW EQU <NtdllDefWindowProc_W>
	NtdllDialogWndProcW EQU <NtdllDialogWndProc_W>

    IFDEF APP_UNICODE
        NtdllDefWindowProc EQU <NtdllDefWindowProc_W>
        NtdllDialogWndProc EQU <NtdllDialogWndProc_W>
        ShipAssertMsg EQU <ShipAssertMsgW>
    ELSE
        NtdllDefWindowProc EQU <NtdllDefWindowProc_A>
        NtdllDialogWndProc EQU <NtdllDialogWndProc_A>
        ShipAssertMsg EQU <ShipAssertMsgA>
    ENDIF
ENDIF

IF (NTDDI_VERSION GE NTDDI_WIN7)
    EtwEventSetInformation PROTO :XWORD,:XWORD,:XPTR,:XWORD
    EtwEventWriteEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    EtwEventWriteNoRegistration PROTO :XWORD,:XWORD,:XWORD,:XWORD
    EvtIntReportAuthzEventAndSourceAsync PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    EvtIntReportEventAndSourceAsync PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrGetDllHandleByMapping PROTO :XWORD,:XWORD
    LdrGetDllHandleByName PROTO :XWORD,:XWORD,:XWORD
    LdrGetKnownDllSectionHandle PROTO :XPTR,:XWORD,:XPTR
    LdrResGetRCConfig PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrRscIsTypeExist PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrLoadEnclaveModule PROTO :XWORD,:XWORD,:XWORD
    LdrSystemDllInitBlock PROTO
    memcpy_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    memmove_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtAllocateReserveObject PROTO :XWORD,:XWORD,:XWORD
    NtCreateProfileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtDrawText PROTO :XWORD
    NtNotifyChangeDirectoryFileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtNotifyChangeSession PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenKeyEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtOpenKeyTransactedEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQuerySecurityAttributesToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQuerySystemInformationEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueueApcThreadEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtSerializeBoot PROTO
    NtSetIoCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtSetTimerEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtUmsThreadYield PROTO :XWORD
    RtlAcquireReleaseSRWLockExclusive PROTO :XWORD
    RtlAddIntegrityLabelToBoundaryDescriptor PROTO :XWORD,:XWORD
    IF (NTDDI_VERSION NE NTDDI_WIN81)
        RtlCheckSandboxedToken PROTO :XWORD,:XPTR
    ENDIF
    RtlContractHashTable PROTO :XWORD
    RtlCopyContext PROTO :XWORD,:XWORD,:XWORD
    RtlCopyExtendedContext PROTO :XWORD,:XWORD,:XWORD
    RtlCreateHashTable PROTO :XWORD,:XWORD,:XWORD
    RtlCreateProcessReflection PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlCreateVirtualAccountSid PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlDeleteHashTable PROTO :XWORD
    RtlDetectHeapLeaks PROTO
    RtlDisableThreadProfiling PROTO :XWORD
    RtlEnableThreadProfiling PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlEndEnumerationHashTable PROTO :XWORD,:XWORD
    RtlEndWeakEnumerationHashTable PROTO :XWORD,:XWORD
    RtlEnumerateEntryHashTable PROTO :XWORD,:XWORD
    RtlEthernetAddressToStringA PROTO :XWORD,:XWORD
    RtlEthernetAddressToStringW PROTO :XWORD,:XWORD
    RtlEthernetStringToAddressA PROTO :XWORD,:XWORD,:XWORD
    RtlEthernetStringToAddressW PROTO :XWORD,:XWORD,:XWORD
    RtlExpandHashTable PROTO :XWORD
    RtlGetCurrentProcessorNumberEx PROTO :XWORD
    RtlGetEnabledExtendedFeatures PROTO :XWORD,:XWORD
    RtlGetExtendedContextLength PROTO :XWORD,:XWORD
    RtlGetExtendedFeaturesMask PROTO :XWORD
    RtlGetFullPathName_UEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetLocaleFileMappingAddress PROTO :XWORD,:XWORD,:XWORD
    RtlGetNextEntryHashTable PROTO XWORD,:XWORD
    RtlGetProcessPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlInitializeExtendedContext PROTO :XWORD,:XWORD,:XWORD
    RtlInitEnumerationHashTable PROTO :XWORD,:XWORD
    RtlInitWeakEnumerationHashTable PROTO :XWORD,:XWORD
    RtlInsertEntryHashTable PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlInterlockedClearBitRun PROTO :XWORD,:XWORD,:XWORD
    RtlInterlockedSetBitRun PROTO :XWORD,:XWORD,:XWORD
    RtlIsNameInExpression PROTO :XPTR,:XPTR,:XWORD,:XPTR
    RtlKnownExceptionFilter PROTO :XWORD
    RtlLoadStringA PROTO :XWORD,:XWORD,:XPTR,:XWORD
    RtlLoadStringW PROTO :XWORD,:XWORD,:XPTR,:XWORD
    RtlLocateExtendedFeature PROTO :XWORD,:XWORD,:XWORD
    RtlLocateLegacyContext PROTO :XWORD,:XWORD
    RtlLookupEntryHashTable PROTO :XWORD,:XWORD,:XWORD
    RtlQueryCriticalSectionOwner PROTO :XWORD
    RtlQueryPerformanceCounter PROTO :XWORD
    RtlQueryPerformanceFrequency PROTO :XWORD
    RtlQueryThreadProfiling PROTO :XWORD,:XWORD
    RtlReadThreadProfilingData PROTO :XWORD,:XWORD,:XWORD
    RtlRemoveEntryHashTable PROTO :XWORD,:XWORD,:XWORD
    RtlReplaceSidInSd PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlReportSilentProcessExit PROTO :XWORD,:XWORD
    RtlReportSqmEscalation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlSetExtendedFeaturesMask PROTO :XWORD,:XWORD,:XWORD
    RtlSetProcessPreferredUILanguages PROTO :XWORD,:XWORD,:XWORD
    RtlTryAcquireSRWLockExclusive PROTO :XWORD
    RtlTryAcquireSRWLockShared PROTO :XWORD
    RtlUnicodeToUTF8N PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlUTF8ToUnicodeN PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlWeaklyEnumerateEntryHashTable PROTO :XWORD,:XWORD
    RtlWow64GetThreadContext PROTO :XWORD,:XPTR
    RtlWow64LogMessageInEventLogger PROTO :XWORD,:XWORD,:XWORD
    RtlWow64SetThreadContext PROTO :XWORD,:XPTR
    SbExecuteProcedure PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    SbSelectProcedure PROTO :XWORD,:XWORD,:XWORD,:XWORD
    sprintf_s PROTO :XWORD,:XWORD,:XWORD,:VARARG
    sscanf_s PROTO :VARARG
    strcat_s PROTO :XWORD,:XWORD,:XWORD
    strcpy_s PROTO :XWORD,:XWORD,:XWORD
    strncat_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    strncpy_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    strnlen PROTO :XWORD,:XWORD
    strtok_s PROTO :XWORD,:XWORD,:XWORD
    swprintf_s PROTO :XWORD,:XWORD,:XWORD,:VARARG
    swscanf_s PROTO :VARARG
    TpAllocAlpcCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    TpAlpcRegisterCompletionList PROTO :XWORD
    TpAlpcUnregisterCompletionList PROTO :XWORD
    TpCallbackIndependent PROTO :XWORD
    TpDisablePoolCallbackChecks PROTO :XWORD
    TpQueryPoolStackInformation PROTO :XWORD,:XWORD
    TpSetDefaultPoolMaxThreads PROTO :XWORD
    TpSetDefaultPoolStackInformation PROTO :XWORD
    TpSetPoolStackInformation PROTO :XWORD,:XWORD
    vsprintf_s PROTO :XPTR,:XPTR,:XPTR,:VARARG
    vswprintf_s PROTO :XPTR,:XPTR,:XPTR,:VARARG
    wcscat_s PROTO :XWORD,:XWORD,:XWORD
    wcscpy_s PROTO :XWORD,:XWORD,:XWORD
    wcsncat_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    wcsncpy_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    wcsnlen PROTO :XWORD,:XWORD
    WinSqmAddToAverageDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmAddToStreamEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCheckEscalationAddToStreamEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCheckEscalationSetDWORD PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCheckEscalationSetDWORD64 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCheckEscalationSetString PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCommonDatapointDelete PROTO :XWORD
    WinSqmCommonDatapointSetDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmCommonDatapointSetDWORD64 PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCommonDatapointSetStreamEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    WinSqmCommonDatapointSetString PROTO :XWORD,:XWORD,:XWORD
    WinSqmGetEscalationRuleStatus PROTO XWORD,:XWORD
    WinSqmGetInstrumentationProperty PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmIncrementDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmIsOptedInEx PROTO :XWORD
    WinSqmSetDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmSetDWORD64 PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmSetEscalationInfo PROTO :XWORD,:XWORD,:XWORD,:XWORD
    WinSqmSetIfMaxDWORD PROTO :XWORD,:XWORD,:XWORD
    WinSqmSetIfMinDWORD PROTO :XWORD,:XWORD,:XWORD
    ZwAllocateReserveObject PROTO :XWORD,:XWORD,:XWORD
    ZwCreateProfileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwDisableLastKnownGood PROTO
    ZwDrawText PROTO :XWORD
    ZwEnableLastKnownGood PROTO
    ZwNotifyChangeSession PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenKeyEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenKeyTransactedEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQuerySecurityAttributesToken PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQuerySystemInformationEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQueueApcThreadEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwSerializeBoot PROTO
    ZwSetIoCompletionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwSetTimerEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwUmsThreadYield PROTO :XWORD
    _i64toa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _i64tow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _itoa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _itow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ltoa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ltow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _makepath_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    _snprintf_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:VARARG
    _snscanf_s PROTO :VARARG
    _snwprintf_s PROTO :VARARG
    _snwscanf_s PROTO :VARARG
    _splitpath_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    _strnset_s PROTO :XPTR,:XPTR,:XWORD,:XPTR
    _strset_s PROTO :XPTR,:XPTR,:XWORD
    _ui64toa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ui64tow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ultoa_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _ultow_s PROTO :XWORD,:XWORD,:XWORD,:XWORD
    _vsnprintf_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:VARARG
    _vsnwprintf_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:VARARG
    _wcsnset_s PROTO :XPTR,:XPTR,:XWORD,:XPTR
    _wcsset_s PROTO :XPTR,:XPTR,:XWORD
    _wmakepath_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    _wsplitpath_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    IFDEF APP_UNICODE
        RtlEthernetAddressToString EQU <RtlEthernetAddressToStringW>
        RtlEthernetStringToAddress EQU <RtlEthernetStringToAddressW>
        RtlLoadString EQU <RtlLoadStringW>
    ELSE
        RtlEthernetAddressToString EQU <RtlEthernetAddressToStringA>
        RtlEthernetStringToAddress EQU <RtlEthernetStringToAddressA>
        RtlLoadString EQU <RtlLoadStringA>
    ENDIF
ENDIF

IF (NTDDI_VERSION GE NTDDI_WIN8)
    ApiSetQueryApiSetPresence PROTO :XPTR,:XPTR
    LdrAddDllDirectory PROTO :XPTR,:XPTR
    LdrAppxHandleIntegrityFailure PROTO 
    LdrGetDllDirectory PROTO :XPTR
    LdrGetDllFullName PROTO :XPTR,:XPTR
    LdrGetDllPath PROTO :XWORD,:XWORD,:XWORD,:XWORD
    LdrGetProcedureAddressForCaller PROTO :XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR
    LdrProcessRelocationBlockEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrQueryOptionalDelayLoadedAPI PROTO 
    LdrRemoveDllDirectory PROTO :XPTR
    LdrResolveDelayLoadedAPI PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XWORD
    LdrResolveDelayLoadsFromDll PROTO :XPTR,:XPTR,:XWORD
    LdrSetDefaultDllDirectories PROTO :XWORD
    LdrSetDllDirectory PROTO :XPTR
    LdrStandardizeSystemPath PROTO :XPTR
    NtAddAtomEx PROTO :XPTR,:XWORD,:XPTR,:XWORD
    NtAdjustTokenClaimsAndDeviceGroups PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR
    NtAlertThreadByThreadId PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcConnectPortEx PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR
    NtAssociateWaitCompletionPacket PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XWORD,:XPTR
    NtCancelWaitCompletionPacket PROTO :XWORD,:XWORD
    NtCreateDirectoryObjectEx PROTO :XPTR,:XWORD,:XPTR,:XWORD,:XWORD
    NtCreateIRTimer PROTO :XPTR,:XWORD
    NtCreateLowBoxToken PROTO :XPTR,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR
    NtCreateTokenEx PROTO :XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    NtCreateWaitCompletionPacket PROTO :XPTR,:XWORD,:XPTR
    NtCreateWnfStateName PROTO :XPTR,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    NtDeleteWnfStateData PROTO :XWORD,:XPTR
    NtDeleteWnfStateName PROTO :XPTR
    NtFilterBootOption PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XWORD
    NtFilterTokenEx PROTO :XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    NtFlushBuffersFileEx PROTO :XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    NtGetCachedSigningLevel PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    NtQueryWnfStateData PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    NtQueryWnfStateNameInformation PROTO :XPTR,:XWORD,:XPTR,:XPTR,:XWORD
    NtSetCachedSigningLevel PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtSetIRTimer PROTO :XWORD,:XPTR
    NtSetInformationVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD
    NtSubscribeWnfStateChange PROTO :XPTR,:XWORD,:XWORD,:XPTR
    NtUnmapViewOfSectionEx PROTO :XWORD,:XPTR,:XWORD
    NtUnsubscribeWnfStateChange PROTO :XPTR
    NtUpdateWnfStateData PROTO :XPTR,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XWORD
    NtWaitForAlertByThreadId PROTO :XWORD,:XWORD
    RtlAddGrowableFunctionTable PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAddResourceAttributeAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAddScopedPolicyIDAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAllocateWnfSerializationGroup PROTO
    RtlAppxIsFileOwnedByTrustedInstaller PROTO :XWORD,:XPTR
    RtlAvlInsertNodeEx PROTO :XPTR,:XWORD,:XWORD,:XWORD
    RtlAvlRemoveNode PROTO :XPTR,:XWORD
    RtlCanonicalizeDomainName PROTO :XWORD,:XWORD,:XWORD
    RtlCheckPortableOperatingSystem PROTO :XPTR
    RtlCheckTokenCapability PROTO :XWORD,:XPTR,:XWORD
    RtlCheckTokenMembership PROTO :XWORD,:XPTR,:XPTR
    RtlCheckTokenMembershipEx PROTO :XWORD,:XPTR,:XWORD,:XPTR
    RtlClearBit PROTO :XPTR,:XWORD
    RtlCopyBitMap PROTO :XPTR,:XPTR,:XWORD
    RtlCrc32 PROTO :XPTR,:XWORD,:XWORD
    RtlCrc64 PROTO :XPTR,:XWORD,:XWORD
    RtlCreateHashTableEx PROTO :XPTR,:XWORD,:XWORD,:XWORD
    RtlDecompressBufferEx PROTO :XWORD,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR
    RtlDeleteElementGenericTableAvlEx PROTO :XWORD,:XWORD
    RtlDeleteGrowableFunctionTable PROTO :XPTR
    RtlEqualWnfChangeStamps PROTO :XWORD,:XWORD
    RtlExtractBitMap PROTO :XPTR,:XPTR,:XWORD,:XWORD
    RtlFlushHeaps PROTO
    RtlGetAppContainerNamedObjectPath PROTO :XWORD,:XPTR,:XWORD,:XPTR
    RtlGetExePath PROTO
    RtlGetSearchPath PROTO :XPTR
    RtlGetSystemTimePrecise PROTO :XPTR,:XPTR
    RtlGrowFunctionTable PROTO :XPTR,:XWORD
    RtlInterlockedPushListSListEx PROTO :XPTR
    RtlIsCapabilitySid PROTO :XPTR
    RtlIsPackageSid PROTO :XPTR
    RtlIsUntrustedObject PROTO :XWORD,:XPTR,:XPTR
    RtlLengthSidAsUnicodeString PROTO :XPTR,:XPTR
    RtlNumberOfClearBitsInRange PROTO :XPTR,:XWORD,:XWORD
    RtlNumberOfSetBitsInRange PROTO :XPTR,:XWORD,:XWORD
    RtlpConvertAbsoluteToRelativeSecurityAttribute PROTO :XWORD,:XWORD,:XWORD
    RtlpConvertRelativeToAbsoluteSecurityAttribute PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlpFreezeTimeBias PROTO
    RtlpMergeSecurityAttributeInformation PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlPublishWnfStateData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryPackageIdentity PROTO :XWORD,:XPTR
    RtlQueryRegistryValuesEx PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XPTR
    RtlQueryUnbiasedInterruptTime PROTO :XWORD
    RtlQueryValidationRunlevel PROTO :XPTR
    RtlQueryWnfMetaNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryWnfStateData PROTO :XPTR,:XWORD,:XPTR,:XPTR,:XPTR
    RtlQueryWnfStateDataWithExplicitScope PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueueApcWow64Thread PROTO :XWORD,:XPTR,:XPTR,:XWORD,:XWORD
    RtlRbInsertNodeEx PROTO :XPTR,:XPTR,:XWORD,:XPTR
    RtlRbRemoveNode PROTO :XPTR,:XPTR
    RtlRegisterForWnfMetaNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlReleasePath PROTO :XWORD
    RtlResetNtUserPfn PROTO
    RtlSetBit PROTO :XPTR,:XWORD
    RtlSetPortableOperatingSystem PROTO :XWORD
    RtlSetSearchPathMode PROTO :XWORD
    RtlSubscribeWnfStateChangeNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlTryConvertSRWLockSharedToExclusiveOrRelease PROTO :XWORD
    RtlTestAndPublishWnfStateData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlUnsubscribeWnfNotificationWaitForCompletion PROTO :XWORD
    RtlUnsubscribeWnfNotificationWithCompletionCallback PROTO :XWORD,:XWORD,:XWORD
    RtlUnsubscribeWnfStateChangeNotification PROTO :XWORD
    RtlWaitOnAddress PROTO :XPTR,:XPTR,:XPTR,:XPTR
    RtlWaitForWnfMetaNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlWakeAddressAll PROTO :XPTR
    RtlWakeAddressSingle PROTO :XPTR
    RtlWakeAddressSingleNoFence PROTO :XWORD
    RtlWakeAddressAllNoFence PROTO :XWORD
    RtlWnfCompareChangeStamp PROTO :XWORD,:XWORD
    RtlWnfDllUnloadCallback PROTO :XWORD
    TpSetTimerEx PROTO :XPTR,:XPTR,:XWORD,:XWORD
    TpSetWaitEx PROTO :XPTR,:XWORD,:XPTR,:XPTR
    TpTimerOutstandingCallbackCount PROTO :XWORD
    WinSqmIsSessionDisabled PROTO :XWORD
    TpAllocJobNotification PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    TpCallbackDetectedUnrecoverableError PROTO :XWORD
    TpReleaseJobNotification PROTO :XWORD
    TpSetPoolThreadBasePriority PROTO :XWORD,:XWORD
    TpWaitForJobNotification PROTO :XWORD
    ZwAddAtomEx PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwAdjustTokenClaimsAndDeviceGroups PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR
    ZwAlertThreadByThreadId PROTO :XWORD
    ZwAlpcConnectPortEx PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwAssociateWaitCompletionPacket PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD,:XWORD,:XPTR
    ZwCancelWaitCompletionPacket PROTO :XWORD,:XWORD
    ZwCreateDirectoryObjectEx PROTO :XPTR,:XWORD,:XPTR,:XWORD,:XWORD
    ZwCreateIRTimer PROTO :XWORD,:XPTR
    ZwCreateLowBoxToken PROTO :XWORD,:XPTR
    ZwCreateTokenEx PROTO :XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwCreateWaitCompletionPacket PROTO :XPTR,:XWORD,:XPTR
    ZwCreateWnfStateName PROTO :XPTR,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    ZwDeleteWnfStateData PROTO :XPTR,:XPTR
    ZwDeleteWnfStateName PROTO :XPTR
    ZwFilterBootOption PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XWORD
    ZwFilterTokenEx PROTO :XWORD,:XWORD,:XPTR,:XPTR,:XPTR,:XWORD,:XPTR,:XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwFlushBuffersFileEx PROTO :XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    ZwGetCachedSigningLevel PROTO :XWORD,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwQueryWnfStateData PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR,:XPTR
    ZwQueryWnfStateNameInformation PROTO :XPTR,:XWORD,:XPTR,:XPTR,:XWORD
    ZwSetCachedSigningLevel PROTO :XWORD,:XWORD,:XPTR,:XWORD,:XPTR
    ZwSetIRTimer PROTO :XWORD,:XPTR
    ZwSetInformationVirtualMemory PROTO :XWORD,:XWORD,:XWORD,:XPTR,:XPTR,:XWORD
    ZwSubscribeWnfStateChange PROTO :XPTR,:XWORD,:XWORD,:XPTR
    ZwUnmapViewOfSectionEx PROTO :XWORD,:XPTR,:XWORD
    ZwUnsubscribeWnfStateChange PROTO :XPTR
    ZwUpdateWnfStateData PROTO :XPTR,:XPTR,:XWORD,:XPTR,:XPTR,:XWORD,:XWORD
    ZwWaitForAlertByThreadId PROTO :XPTR,:XPTR
    _errno PROTO :VARARG
    _strlwr_s PROTO :VARARG
    _strupr_s PROTO :VARARG
    _wcslwr_s PROTO :VARARG
    _wcstoi64 PROTO :VARARG
    _wcsupr_s PROTO :VARARG
    iswalnum PROTO :XWORD
    iswascii PROTO :VARARG
    iswgraph PROTO :XWORD
    iswprint PROTO :XWORD
    qsort_s PROTO :VARARG
    wcstok_s PROTO :XWORD,:XWORD,:XWORD
ENDIF

IF (NTDDI_VERSION GE NTDDI_WIN81)
    NtCancelTimer2 PROTO :XWORD,:XPTR
    NtCreateTimer2 PROTO :XPTR,:XPTR,:XPTR,:XWORD,:XWORD
    NtGetCompleteWnfStateSubscription PROTO :XPTR,:XWORD,:XWORD,:XWORD,:XPTR,:XWORD
    NtSetTimer2 PROTO :XWORD,:XPTR,:XPTR,:XPTR
    NtSetWnfProcessNotificationEvent PROTO :XWORD
    LdrSetImplicitPathOptions PROTO :XWORD,:XWORD
    PssNtCaptureSnapshot PROTO :XWORD,:XWORD,:XWORD,:XWORD
    PssNtDuplicateSnapshot PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    PssNtFreeRemoteSnapshot PROTO :XWORD,:XWORD
    PssNtFreeSnapshot PROTO :XWORD
    PssNtFreeWalkMarker PROTO :XWORD
    PssNtQuerySnapshot PROTO :XWORD,:XWORD,:XWORD,:XWORD
    PssNtValidateDescriptor PROTO :XWORD,:XWORD
    PssNtWalkSnapshot PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAddProcessTrustLabelAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAllocateAndInitializeSidEx PROTO :XPTR,:XWORD,:XPTR,:XPTR
    RtlGetAppContainerParent PROTO :XPTR,:XPTR
    RtlGetAppContainerSidType PROTO :XPTR,:XPTR
    RtlIsParentOfChildAppContainer PROTO :XPTR,:XPTR
    RtlIsValidProcessTrustLabelSid PROTO :XPTR
    RtlQueryPackageIdentityEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryResourcePolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlSidDominatesForTrust PROTO :XPTR,:XPTR,:XPTR
    RtlStringFromGUIDEx PROTO :XPTR,:XPTR,:XWORD
    RtlTestProtectedAccess PROTO :XWORD,:XWORD
    RtlValidProcessProtection PROTO :XWORD
    TpCallbackSendAlpcMessageOnCompletion PROTO :XWORD,:XWORD,:XWORD,:XWORD
    TpCallbackSendPendingAlpcMessage PROTO :XWORD
    TpTrimPools PROTO
    WinSqmStartSessionForPartner PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCancelTimer2 PROTO :XWORD,:XPTR
    ZwCreateTimer2 PROTO :XPTR,:XPTR,:XPTR,:XWORD,:XWORD
    ZwGetCompleteWnfStateSubscription PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XPTR,:XWORD
    ZwSetTimer2 PROTO :XWORD,:XPTR,:XPTR,:XPTR
    ZwSetWnfProcessNotificationEvent PROTO :XWORD
ENDIF

IF (NTDDI_VERSION GE NTDDI_WIN10)
    ApiSetQueryApiSetPresenceEx PROTO :XWORD,:XWORD,:XWORD
    DbgUiConvertStateChangeStructureEx PROTO :XWORD,:XWORD
    LdrCallEnclave PROTO :XWORD,:XWORD,:XWORD
    LdrControlFlowGuardEnforced PROTO
    LdrCreateEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrDeleteEnclave PROTO :XWORD
    LdrFastFailInLoaderCallout PROTO
    LdrInitializeEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    LdrIsModuleSxsRedirected PROTO :XWORD
    LdrUpdatePackageSearchPath PROTO :XWORD
    NtAcquireProcessActivityReference PROTO :XWORD,:XWORD,:XWORD,:
    NtAllocateVirtualMemoryEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtAlpcImpersonateClientContainerOfPort PROTO :XWORD,:XWORD,:XWORD
    NtCallEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCommitRegistryTransaction PROTO :XWORD,:XWORD
    NtCompareObjects PROTO :XWORD,:XWORD
    NtCompareSigningLevels PROTO :XWORD,:XWORD
    NtConvertBetweenAuxiliaryCounterAndPerformanceCounter PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCreateCrossVmEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreateEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtCreatePartition PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCreateRegistryTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtCreateSectionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtGetCurrentProcessorNumberEx PROTO :XWORD
    NtInitializeEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtLoadEnclaveData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtManageHotPatch PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtManagePartition PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtMapViewOfSectionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtOpenPartition PROTO :XWORD,:XWORD,:XWORD
    NtOpenRegistryTransaction PROTO :XWORD,:XWORD,:XWORD
    NtQueryAuxiliaryCounterFrequency PROTO :XWORD
    NtQueryDirectoryFileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQueryInformationByName PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtQuerySecurityPolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtRevertContainerImpersonation PROTO
    NtRollbackRegistryTransaction PROTO :XWORD,:XWORD
    NtSetCachedSigningLevel2 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    NtSetInformationSymbolicLink PROTO :XWORD,:XWORD,:XWORD,:XWORD
    NtTerminateEnclave PROTO :XWORD,:XWORD
    RtlAddAccessFilterAce PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlAreLongPathsEnabled PROTO
    RtlCapabilityCheck PROTO :XWORD,:XWORD,:XWORD
    RtlCapabilityCheckForSingleSessionSku PROTO :XWORD,:XWORD,:XWORD
    RtlCheckBootStatusIntegrity PROTO :XWORD,:XWORD
    RtlCheckSystemBootStatusIntegrity PROTO :XWORD
    RtlClearThreadWorkOnBehalfTicket PROTO
    RtlConstructCrossVmEventPath PROTO :XWORD,:XWORD,:XWORD
    RtlConvertDeviceFamilyInfoToString PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlConvertSRWLockExclusiveToShared PROTO :XWORD
    RtlCreateProcessParametersWithTemplate PROTO :XWORD,:XWORD,:XWORD
    RtlCreateUserProcessEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlDecodeRemotePointer PROTO :XWORD,:XWORD,:XWORD
    RtlDeriveCapabilitySidsFromName PROTO :XWORD,:XWORD,:XWORD
    RtlDoesNameContainWildCards PROTO :XWORD
    RtlDosLongPathNameToNtPathName_U_WithStatus PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlDosLongPathNameToRelativeNtPathName_U_WithStatus PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlDrainNonVolatileFlush PROTO :XPTR
    RtlEncodeRemotePointer PROTO :XWORD,:XWORD,:XWORD
    RtlEndStrongEnumerationHashTable PROTO :XWORD,:XWORD
    RtlExtendCorrelationVector PROTO :XWORD
    RtlFillMemoryNonTemporal PROTO :XPTR,:XWORD,:XWORD
    RtlFillNonVolatileMemory PROTO :XPTR,:XPTR,:XWORD,:XWORD,:XWORD
    RtlFindExportedRoutineByName PROTO :XWORD,:XWORD
    RtlFindUnicodeSubstring PROTO :XWORD,:XWORD,:XWORD
    RtlFlsGetValue PROTO :XWORD,:XWORD
    RtlFlsSetValue PROTO :XWORD,:XWORD
    RtlFlushNonVolatileMemory PROTO :XPTR,:XPTR,:XPTR,:XWORD
    RtlFlushNonVolatileMemoryRanges PROTO :XPTR,:XPTR,:XPTR,:XWORD
    RtlFreeNonVolatileToken PROTO :XPTR
    RtlGetActiveConsoleId PROTO
    RtlGetConsoleSessionForegroundProcessId PROTO
    RtlGetCurrentServiceSessionId PROTO
    RtlGetDeviceFamilyInfoEnum PROTO :XWORD,:XWORD,:XWORD
    RtlGetExtendedContextLength2 PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetInterruptTimePrecise PROTO :XWORD
    RtlGetMultiTimePrecise PROTO :XWORD,:XWORD,:XWORD
    RtlGetNonVolatileToken PROTO :XWORD
    RtlGetNtSystemRoot PROTO
    RtlGetPersistedStateLocation PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlGetSessionProperties PROTO :XWORD,:XWORD
    RtlGetSuiteMask PROTO
    RtlGetSystemBootStatus PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlGetSystemBootStatusEx PROTO :XWORD,:XWORD,:XWORD
    RtlGetThreadWorkOnBehalfTicket PROTO :XWORD,:XWORD
    RtlGetTokenNamedObjectPath PROTO :XWORD,:XWORD,:XWORD
    RtlGuardCheckLongJumpTarget PROTO :XWORD,:XWORD,:XWORD
    RtlIncrementCorrelationVector PROTO :XWORD
    RtlInitializeCorrelationVector PROTO :XWORD,:XWORD,:XWORD
    RtlInitializeExtendedContext2 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlInitializeSidEx PROTO
    RtlInitStringEx PROTO :XWORD,:XWORD
    RtlInitStrongEnumerationHashTable PROTO :XWORD,:XWORD
    RtlIsCloudFilesPlaceholder PROTO :XWORD,:XWORD
    RtlIsCurrentProcess PROTO :XWORD
    RtlIsCurrentThread PROTO :XWORD
    RtlIsElevatedRid PROTO :XWORD
    RtlIsMultiSessionSku PROTO
    RtlIsMultiUsersInSessionSku PROTO
    RtlIsNameInUnUpcasedExpression PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlIsNonEmptyDirectoryReparsePointAllowed PROTO :XWORD
    RtlIsPartialPlaceholder PROTO :XWORD,:XWORD
    RtlIsPartialPlaceholderFileHandle PROTO :XWORD,:XWORD
    RtlIsPartialPlaceholderFileInfo PROTO :XWORD,:XWORD,:XWORD
    RtlIsProcessorFeaturePresent PROTO :XWORD
    RtlIsStateSeparationEnabled PROTO
    RtlLocateExtendedFeature2 PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlLookupFirstMatchingElementGenericTableAvl PROTO :XWORD,:XWORD,:XWORD
    RtlOsDeploymentState PROTO :XWORD
    RtlQueryImageMitigationPolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryPackageClaims PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryProcessPlaceholderCompatibilityMode PROTO
    RtlQueryProtectedPolicy PROTO :XWORD,:XWORD
    RtlQueryRegistryValueWithFallback PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlQueryThreadPlaceholderCompatibilityMode PROTO
    RtlQueryTokenHostIdAsUlong64 PROTO :XWORD,:XWORD
    RtlRaiseCustomSystemEventTrigger PROTO :XWORD
    RtlReplaceSystemDirectoryInPath PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlReportExceptionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlRestoreBootStatusDefaults PROTO :XWORD
    RtlRestoreSystemBootStatusDefaults PROTO
    RtlSetImageMitigationPolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlSetProcessPlaceholderCompatibilityMode PROTO :XWORD
    RtlSetProtectedPolicy PROTO :XWORD,:XWORD,:XWORD
    RtlSetProxiedProcessId PROTO :XWORD
    RtlSetSystemBootStatus PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlSetSystemBootStatusEx PROTO :XWORD,:XWORD,:XWORD
    RtlSetThreadPlaceholderCompatibilityMode PROTO :XWORD
    RtlSetThreadSubProcessTag PROTO :XWORD
    RtlSetThreadWorkOnBehalfTicket PROTO :XWORD
    RtlStronglyEnumerateEntryHashTable PROTO :XWORD,:XWORD
    RtlSwitchedVVI PROTO :XWORD,:XWORD,:XWORD,:XWORD
    RtlUdiv128 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    RtlValidateCorrelationVector PROTO :XWORD
    RtlWow64GetCpuAreaInfo PROTO :XPTR,:XWORD,:XPTR
    RtlWow64GetCurrentMachine PROTO
    RtlWow64GetEquivalentMachineCHPE PROTO :XWORD
    RtlWow64GetProcessMachines PROTO :XWORD,:XWORD,:XWORD
    RtlWow64GetSharedInfoProcess PROTO :XWORD,:XWORD,:XWORD
    RtlWow64IsWowGuestMachineSupported PROTO :XWORD,:XWORD
    RtlWriteNonVolatileMemory PROTO :XPTR,:XPTR,:XPTR,:XWORD
    RtlpGetDeviceFamilyInfoEnum PROTO :XWORD,:XWORD,:XWORD
    RtlpTimeFieldsToTime PROTO :XWORD,:XWORD,:XWORD
    RtlpTimeToTimeFields PROTO :XWORD,:XWORD,:XWORD
    TpSetPoolMaxThreadsSoftLimit PROTO :XWORD,:XWORD
    TpSetPoolThreadCpuSets PROTO :XWORD,:XWORD,:XWORD
    TpSetPoolWorkerThreadIdleTimeout PROTO :XWORD,:XWORD,:XWORD
    WerReportExceptionWorker PROTO :XWORD
    WinSqmStartSqmOptinListener PROTO
    ZwAcquireProcessActivityReference PROTO :XWORD,:XWORD,:XWORD
    ZwAllocateVirtualMemoryEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwAlpcImpersonateClientContainerOfPort PROTO :XWORD,:XWORD,:XWORD
    ZwCallEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCommitRegistryTransaction PROTO :XWORD,:XWORD
    ZwCompareObjects PROTO :XWORD,:XWORD
    ZwCompareSigningLevels PROTO :XWORD,:XWORD
    ZwConvertBetweenAuxiliaryCounterAndPerformanceCounter PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateCrossVmEvent PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwCreatePartition PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateRegistryTransaction PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwCreateSectionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwGetCurrentProcessorNumberEx PROTO :XWORD
    ZwInitializeEnclave PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwLoadEnclaveData PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwManageHotPatch PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwManagePartition PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwMapViewOfSectionEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwNotifyChangeDirectoryFileEx PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwOpenPartition PROTO :XWORD,:XWORD,:XWORD
    ZwOpenRegistryTransaction PROTO :XWORD,:XWORD,:XWORD
    ZwQueryAuxiliaryCounterFrequency PROTO :XWORD
    ZwQueryInformationByName PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwQuerySecurityPolicy PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwRevertContainerImpersonation PROTO
    ZwRollbackRegistryTransaction PROTO :XWORD,:XWORD
    ZwSetCachedSigningLevel2 PROTO :XWORD,:XWORD,:XWORD,:XWORD,:XWORD,:XWORD
    ZwSetInformationSymbolicLink PROTO :XWORD,:XWORD,:XWORD,:XWORD
    ZwTerminateEnclave PROTO :XWORD,:XWORD
    _vscprintf PROTO :VARARG
    atan2 PROTO :VARARG
    bsearch_s PROTO :XPTR,:XPTR,:XPTR,:XPTR,:XPTR
ENDIF

IFDEF APP_UNICODE
    EtwRegisterTraceGuids EQU <EtwRegisterTraceGuidsW>
    RtlIpv4AddressToStringEx EQU <RtlIpv4AddressToStringExW>
    RtlIpv4AddressToString EQU <RtlIpv4AddressToStringW>
    RtlIpv4StringToAddressEx EQU <RtlIpv4StringToAddressExW>
    RtlIpv4StringToAddress EQU <RtlIpv4StringToAddressW>
    RtlIpv6AddressToStringEx EQU <RtlIpv6AddressToStringExW>
    RtlIpv6AddressToString EQU <RtlIpv6AddressToStringW>
    RtlIpv6StringToAddressEx EQU <RtlIpv6StringToAddressExW>
    RtlIpv6StringToAddress EQU <RtlIpv6StringToAddressW>
ELSE
    EtwRegisterTraceGuids EQU <EtwRegisterTraceGuidsA>
    EtwRegisterTraceGuids EQU <EtwRegisterTraceGuidsA>
    RtlIpv4AddressToStringEx EQU <RtlIpv4AddressToStringExA>
    RtlIpv4AddressToString EQU <RtlIpv4AddressToStringA>
    RtlIpv4StringToAddressEx EQU <RtlIpv4StringToAddressExA>
    RtlIpv4StringToAddress EQU <RtlIpv4StringToAddressA>
    RtlIpv6AddressToStringEx EQU <RtlIpv6AddressToStringExA>
    RtlIpv6AddressToString EQU <RtlIpv6AddressToStringA>
    RtlIpv6StringToAddressEx EQU <RtlIpv6StringToAddressExA>
    RtlIpv6StringToAddress EQU <RtlIpv6StringToAddressA>
ENDIF

;======================= Undocumented functions (unknown arguments) =======================;
;EtwTraceMessageVa PROTO
;ExpInterlockedPopEntrySListEnd PROTO
;ExpInterlockedPopEntrySListFault PROTO
;ExpInterlockedPopEntrySListResume PROTO
;LdrProcessInitializationComplete PROTO
;_fltused PROTO
;ZwApphelpCacheControl PROTO
;IFNDEF __misaligned_access
;    __misaligned_access PROTO
;ENDIF
;IF (NTDDI_VERSION GE NTDDI_VISTA)
;    RtlCompleteProcessCloning PROTO
;ENDIF
;IF (NTDDI_VERSION GE NTDDI_WIN7)
;    RtlCreateUmsCompletionList PROTO
;    RtlCreateUmsThreadContext PROTO
;    RtlDeleteUmsCompletionList PROTO
;    RtlDeleteUmsThreadContext PROTO
;    RtlDequeueUmsCompletionListItems PROTO
;    RtlEnterUmsSchedulingMode PROTO
;    RtlExecuteUmsThread PROTO
;    RtlGetCurrentUmsThread PROTO
;    RtlGetNextUmsListItem PROTO
;    RtlGetUmsCompletionListEvent PROTO
;    RtlpUmsExecuteYieldThreadEnd PROTO
;    RtlpUmsThreadYield PROTO
;    RtlNtdllName PROTO
;    RtlpExecuteUmsThread PROTO
;    RtlPrepareForProcessCloning PROTO
;    RtlpQueryProcessDebugInformationFromWow64 PROTO
;    RtlQueryUmsThreadInformation PROTO
;    RtlSetUmsThreadInformation PROTO
;    RtlUmsThreadYield PROTO
;    RtlWow64GetThreadSelectorEntry PROTO
;    RtlWow64SuspendThread PROTO
;ENDIF
;IF (NTDDI_VERSION GE NTDDI_WIN81)
;    KiUserInvertedFunctionTable PROTO
;ENDIF
;IF (NTDDI_VERSION GE NTDDI_WIN10)
;    EtwCheckCoverage PROTO
;    RtlCallEnclaveReturn PROTO
;    RtlCreateUserFiberShadowStack PROTO
;    RtlEnclaveCallDispatch PROTO
;    RtlEnclaveCallDispatchReturn PROTO
;    RtlFreeUserFiberShadowStack PROTO
;    RtlInitializeBitMapEx PROTO
;    RtlTestBitEx PROTO
;    RtlUserFiberStart PROTO
;    RtlWow64GetCurrentCpuArea PROTO
;    RtlWow64SuspendProcess PROTO
;    RtlpQueryProcessDebugInformationRemote PROTO
;    RtlpWow64CtxFromAmd64 PROTO
;    RtlpWow64GetContextOnAmd64 PROTO
;    RtlpWow64SetContextOnAmd64 PROTO
;    RtlWow64PopAllCrossProcessWorkFromWorkList PROTO
;    RtlWow64PopCrossProcessWorkFromFreeList PROTO
;    RtlWow64PushCrossProcessWorkOntoFreeList PROTO
;    RtlWow64PushCrossProcessWorkOntoWorkList PROTO
;    RtlWow64RequestCrossProcessHeavyFlush PROTO
;ENDIF

ENDIF ;NTDLL_INC
